--[[
一个简单的示例，新建一个精灵，并在精灵上放置了一个文本。
当调用 CreateCustomNode 时，会生成这个精灵并返回。
]]

-- 新建一个 table，包含 CreateCustomNode 和 GetBaseType 方法。
local container = {}

-- 新建根节点 Node，目前这个方法的名字为固定的，必须为 CreateCustomNode。
-- 方法的最后一句必须是一个 return 语句，把新建的结点返回。
function container.CreateCustomNode()
    local rootNode = nil
    if __NotEditor then
        rootNode = ccui.EditBox:create(cc.size(1000,300),"editbox.png")
        rootNode:setInputMode(cc.EDITBOX_INPUT_MODE_ANY) --0-6 0:任何数据 2:数字 6:单行输入
        rootNode:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE) --0:default 1:done 2:send 3:search 4:go
        rootNode:setPlaceholderFontColor(cc.c3b(191,191,191))
        rootNode:setEnabled(false)
        rootNode.isReady = false
        local defaultText = "　　"
        for i=1,20 do
            defaultText = string.format("%s　　",defaultText)
        end
        --rootNode:setText(defaultText)
        util.delay(0.6,function()
            if false == rootNode.isReady then
                local defaultText = ""
                rootNode.isReady = true
                if nil ~= rootNode.defaultText then
                    defaultText = rootNode.defaultText
                end
                --rootNode:setText(defaultText)
                rootNode:setEnabled(true)
            end
        end)
        rootNode.setTouchEnabled2 = rootNode.setTouchEnabled
        rootNode.setTouchEnabled = function(self,isEnabled)
            if false == isEnabled then
                rootNode:setInputMode(cc.EDITBOX_INPUT_MODE_ANY)
            end
            rootNode:setTouchEnabled2(true)
        end
        rootNode.setFontSize2 = rootNode.setFontSize
        rootNode.setFontSize = function(self,intValue)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setFontSize2(intValue)
            rootNode:setPlaceholderFontSize(intValue)
        end
        rootNode.setPlaceHolder2 = rootNode.setPlaceHolder
        rootNode.setPlaceHolder = function(self,strValue)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setPlaceHolder2(strValue)
        end
        rootNode.setString2 = rootNode.setText
        rootNode.setString = function(self,strValue)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            if false == rootNode.isReady then
                rootNode.defaultText = strValue
            else
                --rootNode:setString2(strValue)
            end
        end
        rootNode.getString = function()
            return rootNode:getText()
        end
        rootNode.setLayoutComponentEnabled2 = rootNode.setLayoutComponentEnabled
        rootNode.setLayoutComponentEnabled = function(self,isEnabled)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setLayoutComponentEnabled2(isEnabled)
        end
        rootNode.setCascadeColorEnabled2 = rootNode.setCascadeColorEnabled
        rootNode.setCascadeColorEnabled = function(self,isEnabled)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setCascadeColorEnabled2(isEnabled)
        end
        rootNode.setCascadeOpacityEnabled2 = rootNode.setCascadeOpacityEnabled
        rootNode.setCascadeOpacityEnabled = function(self,isEnabled)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setCascadeOpacityEnabled2(isEnabled)
        end
        rootNode.setFontName2 = rootNode.setFontName
        rootNode.setFontName = function(self,strValue)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setFontName2(strValue)
        end
        rootNode.setMaxLengthEnabled = function(self,isEnabled)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
        end
        rootNode.setMaxLength2 = rootNode.setMaxLength
        rootNode.setMaxLength = function(self,intValue)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setMaxLength2(intValue)
        end
        rootNode.setPasswordEnabled = function(self,isEnabled)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            if type(isEnabled) == "boolean" then
                if isEnabled then
                    rootNode:setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD)
                else
                    --TODO
                end
            end
        end
        rootNode.addEventListener = function(self,cbFunc)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:registerScriptEditBoxHandler(cbFunc)
        end
        rootNode.setPosition2 = rootNode.setPosition
        rootNode.setPosition = function(self,intValue1,intValue2)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setPosition2(intValue1,intValue2)
        end
        rootNode.setColor2 = rootNode.setColor
        rootNode.setColor = function(self,c3bValue)
            if tolua.type(self) == "cc.Label" then
                tolua.cast(self, "ccui.EditBox")
            end
            rootNode:setFontColor(c3bValue)
            rootNode:setPlaceholderFontColor(c3bValue)
            -- rootNode:setColor2(c3bValue)
        end
    else
        rootNode = ccui.TextField:create()
    end
    return rootNode
end

-- 返回该插件所扩展的基础类型。
function container.GetBaseType()
    return 'TextField'
end

-- 返回这个包含 CreateCustomNode 和 GetBaseType 方法的表。
return container