local Island = class("Island", cc.load("mvc").ViewBase)
Island.RESOURCE_FILENAME = "Fight.Island"

local InputA = class("InputA")
local InputB = class("InputB")

function InputA:onTouch(view, node, eventType)
    if eventType==0 then
        -- 
        self.isLongTouch = false
        if view.__cname=="Island"then
            if view.side==mdt.fight.me then
                self.delay = util.delayNode(1, function()
                    for k,v in pairs(mdt.fight.island) do
                        if v.side==mdt.fight.me then
                            mdt.fight.selectID[k] = true
                        end
                    end
                    self.isLongTouch = true
                end)

            end
        else
            mdt.fight.selectID = {}
        end
        return
    elseif eventType==1 then
        return
    else
        if self.delay and not tolua.isnull(self.delay) then
            util.unscheduleNode(self.delay)
            self.delay = nil
        end
        if eventType==2 then
            if view.__cname=="Island"then
                if self.isLongTouch then
                    self.isLongTouch = false
                    return
                end
            end
        else
            return
        end
    end
    if view.__cname=="Island" and self.doubleID~=view.id then
        self.isDoubleClick = false
        if self.double and not tolua.isnull(self.double) then
            util.unscheduleNode(self.double)
        end
    end

    local percent = mdt.fight.percent
    if view.side==mdt.fight.me then
        if self.isDoubleClick then
            if table.nums(mdt.fight.selectID)>0 then
                for from, _ in pairs(mdt.fight.selectID) do 
                    ctr.battle.control(from, view.id, percent)
                end
                mdt.fight.selectID = {}
            end
            return
        end
        if mdt.fight.selectID[view.id] then
            mdt.fight.selectID[view.id] = nil
        else
            mdt.fight.selectID[view.id] = true
        end
    else
        if table.nums(mdt.fight.selectID)>0 then
            for from, _ in pairs(mdt.fight.selectID) do 
                ctr.battle.control(from, view.id, percent)
            end
            mdt.fight.selectID = {}
        end
    end
 
    if view.__cname=="Island"then
        self.isDoubleClick = true
        self.doubleID = view.id
        self.double = util.delayNode(0.3, function() 
            self.isDoubleClick = false
        end) 
    end
end

function InputB:onTouch(view, node, eventType)
    if eventType==0 then
        if view.__cname == 'Island' then
            mdt.fight.selectID[view.id] = true
        end
    elseif eventType==1 then
        local p0 = node:getTouchMovePosition()
        p0.ret = function(view, bIn)
            if mdt.fight.island[view.id].side==mdt.fight.me then
                mdt.fight.selectID[view.id] = true
            end
        end
        event.dispatch('IsInputTouchIn', p0)
    else
        local percent = mdt.fight.percent
        local p0 = node:getTouchEndPosition()
        p0.ret = function(view, bIn)
            if table.nums(mdt.fight.selectID)>0 then
                for from, _ in pairs(mdt.fight.selectID) do 
                    ctr.battle.control(from, view.id, percent)
                end
            end
        end
        event.dispatch('IsInputTouchIn', p0)
        
        mdt.fight.selectID = {}
    end  
end


return { A=InputA:create(), B=InputB:create() }
