cc.exports.ctr = ctr or {}
local game = {}
local effect = {}
local cellList = {}
local itemList = {}
local scheduleMoveLimit = nil
local lastPos = nil
local Inner = nil

function game.init(uiInner)
    mdt.CW = 120
    mdt.nw = math.floor(display.width/mdt.CW)+2
    mdt.nh = math.floor(display.height/mdt.CW)
    
    mdt.nw2 = math.floor(mdt.nw/2)
    mdt.nh2 = math.floor(mdt.nh/2)

    mdt.mode= mdt.mode or 1
    mdt.map = mdt.map or {}
    
    effect = {}
    require('app.views.Cell.Cell').Init()

    cellList = {}

    scheduleMoveLimit = nil
    lastPos = nil
    Inner = uiInner
    game.Inner = Inner
end

function game.createCell()
    cellList = {}
    require('app.views.Cell.Cell').InitMapPic()
    for x0=1, mdt.nw do
        for y0=1, mdt.nh do
            local cell = util.createView('Cell.Cell')            
            --cell:setPosition((x0-2)*mdt.CW, (y0-2)*mdt.CW)
            cell:setLocation(x0, y0)
            Inner:addChild(cell)
            cellList[#cellList+1] = cell
        end
    end
end

function game.refreshCell(noCheck)
    if nil == mdt.bx then
        mdt.bx =math.floor( mdt.x/mdt.nw)
        mdt.by =math.floor( mdt.y/mdt.nh)
    end
    local dx = mdt.x - mdt.nw2 -1
    local dy = mdt.y - mdt.nh2 -1
    local dx2 = mdt.x + mdt.nw2 
    local dy2 = mdt.y + mdt.nh2 

    local slot = {}
    for x0=1, mdt.nw do
        local p = {}
        slot[x0 + dx] = p
        for y0=1, mdt.nh do
            p[y0 + dy] = true
        end
    end
    local list = {}
    
    for i=1,#cellList do
        local cell = cellList[i]
        if cell.x<dx+1 or cell.x>dx2-1 or cell.y<dy+1 or cell.y>dy2-1 then
            list[#list+1] = cell
        else
            if not noCheck then
                cell:check()
            end
            slot[cell.x][cell.y] = nil
        end
    end
    local i = 1
    
    for x0=1, mdt.nw do
        local p = slot[x0 + dx]
        for y0=1, mdt.nh do
            local p2 = p[y0 + dy]
            if p2 then
                list[i]:setLocation(x0 + dx, y0 + dy)
                i=i+1
            end
        end
    end
    if not mdt.isChallenge then
        if not mdt.isNewbie then
            game.refreshItem()
        end
    end

    local bx = math.floor( mdt.x/mdt.nw)
    local by = math.floor( mdt.y/mdt.nh)

    local list = { }
    for i=-2,2 do
        list[i] = {}
    end

    if mdt.bx>bx then
        list[-1][-1] = true
        list[-1][0] = true
        list[-1][1] = true
    elseif mdt.bx<bx then
        list[1][-1] = true
        list[1][0] = true
        list[1][1] = true
    end
    if mdt.by>by then
        list[0][-1] = true
        list[-1][-1] = true
        list[1][-1] = true
    elseif mdt.by<by then
        list[0][1] = true
        list[-1][1] = true
        list[1][1] = true
    end
    mdt.bx = bx
    mdt.by = by

    if not mdt.isChallenge then
        if mdlogin.getIsNewbieComplete(mdlogin.getCurLoginServerID()) then
            if mdt.Newbieagain == nil or mdt.Newbieagain == false then
                for x, l in pairs(list) do
                    for y, v in pairs(l) do
                        if v then 
                            net.msg.NC_LoadRect((bx+x)*mdt.nw, (by+y)*mdt.nh, mdt.nw, mdt.nh)
                        end
                    end
                end
            end
        end
    end
end

function game.refreshItem()
    local dx = mdt.x - mdt.nw2 -1
    local dy = mdt.y - mdt.nh2 -1
    local dx2 = mdt.x + mdt.nw2 
    local dy2 = mdt.y + mdt.nh2 

    local list = {}
    for y, vy in pairs(mdt.challenge) do
        if y>=dy and y<=dy2 then
            for x, v in pairs(vy) do
                if v.open == true then
                end
                if x>=dx and x<=dx2 and v.open then
                    list[#list+1] = { x=x,y=y, pointType=v.pointType }
                end
            end
        end
    end

    -- delete item
    for i=#itemList,1, -1 do
        local item = itemList[i]
        if item.x<dx or item.x>dx2 or item.y<dy or item.y>dy2 then
            itemList[i] = itemList[#itemList]
            item:removeFromParent()
            itemList[#itemList] = nil
        end
    end

    -- add item
    for i=1,#list do
        local v = list[i]
        local no = true
        for _, item in pairs(itemList) do
            if item.x==v.x and item.y==v.y then
                no = false
                break
            end
        end
        if no then
            local item = nil
            if v.pointType==0 then
                item = util.createView('Challenge.CellChallenge')
            else
                item = util.createView('Challenge.CellChallenge', 'Challenge.CellChallenge2')
            end
            item:setLocation(v.x, v.y)
            Inner:addChild(item)
            itemList[#itemList+1] = item
        end
    end
    
end

function game.clearItem()
    for _, v in pairs(itemList) do
        if v and (not tolua.isnull(v)) then
            v:removeFromParent()
        end
    end
    itemList={}
end

function game.addEffect(x, y, state)
    local id = tostring(x)..'_'..tostring(y)
    local eff = effect[id]
    if eff then 
        if eff.state==0 then
            eff.node:removeFromParent()
            eff.node = nil
        else
            return
        end
    end

    local node = nil
    if state==1 then    -- click effect
        local vn = 'Themes.Theme'..mdt.theme..'.CellClickAction'
        node = util.createView('Cell.CellClickAction', vn)
    else
        node = util.createView('Cell.CellAction')
    end
    node:setPosition(x*mdt.CW, y*mdt.CW)
    node:setState(state)
    Inner:addChild(node)
    
    effect[id] = { x=x,y=y,node=node,state=state }
    node:setCloseListener(function()
        effect[id] = nil
    end)
end

function game.RemoveEffect(dx, dy)
    local id = tostring(dx)..'_'..tostring(dy)
    local eff = effect[id]
    if eff then 
        eff.node:removeFromParent()
        effect[id] = nil
    end
end

function game.clearEffect()
    for _, v in pairs(effect) do
        if v.node then
            v.node:removeFromParent()
            v.node = nil
        end
    end
    effect={}
end

function game.refreshEffect()
    local minx = mdt.x - mdt.nw2
    local miny = mdt.y - mdt.nh2
    local maxx = mdt.x + mdt.nw2
    local maxy = mdt.y + mdt.nh2
    for i=1,#mdt.effect do
        local te = mdt.effect[i]
        if te.x<minx or te.x>maxx or te.y<miny or te.y>maxy then
            local id = tostring(te.x)..'_'..tostring(te.y)
            local eff = effect[id]
            if eff then 
                if eff.state==0 then
                    eff.node:removeFromParent()
                    eff.node = nil
--                else
--                    return
                end
            end
        else
            game.addEffect(te.x, te.y, te.state)
        end
    end
    mdt.effect = {}
end

function game.LoadMap()
    game.clearEffect()
    game.clearItem()
    if not mdt.x or not mdt.w then return end
    Inner:setPosition((-mdt.x+mdt.nw2-1)*mdt.CW, (-mdt.y+mdt.nh2-1)*mdt.CW)
    mdt.bx =math.floor( mdt.x/mdt.nw)
    mdt.by =math.floor( mdt.y/mdt.nh)
    if not mdt.isChallenge then
        if mdt.Newbieagain == nil or mdt.Newbieagain == false then
            for x=-1,1 do
                for y=-1,1 do
                    net.msg.NC_LoadRect((mdt.bx+x)*mdt.nw, (mdt.by+y)*mdt.nh, mdt.nw, mdt.nh)
                end
            end
        end
    end
end

function game.sendSetPos(x, y)
    mdt.x = x
    mdt.y = y
    Inner:setPosition((-mdt.x+mdt.nw2-1)*mdt.CW, (-mdt.y+mdt.nh2-1)*mdt.CW)
    lastPos = lastPos or { x=-99, y=-99, clock=0 }
    local lp = lastPos
    local clock = os.clock()
    if math.abs(lp.x-mdt.x)>5 or math.abs(lp.y-mdt.y)>5 or clock-lp.clock>2 then
        net.msg.NC_SetPos()
        lp.x = mdt.x
        lp.y = mdt.y
        lp.clock = clock
    end
end

-- 检测拖动边界
function game.moveMap(dpx, dpy, size)
    local px, py = Inner:getPosition()
    px = px + dpx
    py = py + dpy
    local x = -math.floor(px/mdt.CW) + mdt.nw2 -1
    local y = -math.floor(py/mdt.CW) + mdt.nh2 -1
    
    if x~=mdt.x or y~=mdt.y then
        mdt.x = x
        mdt.y = y
        game.refreshCell(true)
        if not mdt.isChallenge then
            game.sendSetPos(x, y)
        end
        --game.moveEffect(x, y)
    end
--    px = px % mdt.CW
--    py = py % mdt.CW
    Inner:setPosition(px, py)

    if not scheduleMoveLimit then
        local dxL = mdt.x-mdt.nw2 + 2
        local dyB = mdt.y-mdt.nh2 + 2
        local dpR = (size.width % mdt.CW)/mdt.CW
        local dpT = (size.height % mdt.CW)/mdt.CW
        local dxR = mdt.w -mdt.nw + 3 - dpR + px/mdt.CW
        local dyT = mdt.h -mdt.nh + 3 - dpT + py/mdt.CW
        if dxL<0 or dyB<0 or dxR<0 or dyT<0 then
            local clock = os.clock()
            scheduleMoveLimit = util.scheduleNode(0, function()
                local newclock = os.clock()
                local dt = (newclock-clock)*10
                local dxL = mdt.x-mdt.nw2 + 2
                local dyB = mdt.y-mdt.nh2 + 2
                local px, py = Inner:getPosition()
                local dxR = mdt.w -mdt.nw + 4 - dpR +px/mdt.CW
                local dyT = mdt.h -mdt.nh + 4 - dpT + py/mdt.CW        

                local dx = dxL<0 and dxL or (dxR<0 and -dxR or 0)
                local dy = dyB<0 and dyB or (dyT<0 and -dyT or 0)
                if dxL>=0 and dyB>=0 and dxR>=0 and dyT>=0 then
                    util.unscheduleNode(scheduleMoveLimit, Inner)
                    scheduleMoveLimit = nil
                    return
                end

                game.moveMap(dx*mdt.CW*dt, dy*mdt.CW*dt)
                clock = newclock

            end, Inner)
        end
    end
end

function game.click(beganPos, endPos, mode)
    local dis = cc.pGetDistance(beganPos, endPos)
    if dis<50 then
--        local dx = mdt.x - mdt.nw2 + 1
--        local dy = mdt.y - mdt.nh2 + 1
        local px, py = Inner:getPosition()
        local x = math.floor((endPos.x - px)/mdt.CW)--+dx
        local y = math.floor((endPos.y - py)/mdt.CW)--+dy
        
        if x<0 or y<0 or x>=mdt.w or y>=mdt.h then return end
        local PY = mdt.point[y]
        if PY==nil then return end
        local PXY = PY[x]
        if PXY==nil then return end   
        if PXY == net.enum.EBigMapGridStatus_UNOPEN then
            if mdt.life<=0 and not mdt.isChallenge and not mdt.isNewbie then
                local view = util.showDialog('Dialog', 'Common.BuyLife')
                view:setcosttype('diamond')
                return
            end
            if mdt.mode==mode then
                if mdt.isChallenge then
                    net.msg.NC_ChallengeClickGrid(x, y)
                elseif mdt.isNewbie then
                    event.dispatch('onNextNewbieStep')
                else
                    if mdt.UseItemBoom then
                        net.msg.NC_ApplyUseItem(50001)
                        mdt.useboomx = x 
                        mdt.useboomy = y
                    end
                    net.msg.NC_ClickGrid(x, y)  
                end
            else
                if mdt.isChallenge then
                    net.msg.NC_ChallengeFlagGrid(x, y)
                elseif mdt.isNewbie then
                    event.dispatch('onNextNewbieStep')
                else
                    if mdt.UseItemBoom then
                        net.msg.NC_ApplyUseItem(50001)
                        mdt.useboomx = x 
                        mdt.useboomy = y
                    end
                    net.msg.NC_FlagGrid(x, y)
                end
            end
            ctr.game.addEffect(x, y, 0)
        elseif PXY>=net.enum.EBigMapGridStatus_ONE and PXY<=net.enum.EBigMapGridStatus_EIGHT then
            if mdt.life<=0 and not mdt.isChallenge and not mdt.isNewbie then
                local view = util.showDialog('Dialog', 'Common.BuyLife')
                view:setcosttype('diamond')
                return
            end
            local unopen = 0
            local mine = 0
            local function iterRect(func)
                for dx0=-1,1 do
                for dy0=-1,1 do
                    if (dx0~=0 or dy0~=0 ) and y+dy0>=0 and y+dy0<mdt.h and x+dx0>=0 and x+dx0<mdt.w then
                        local PY = mdt.point[y+dy0]
                        local PXY0 = nil
                        if PY then
                            PXY0 = PY[x+dx0]
                        end
                        func(PXY0, x+dx0, y+dy0)

                    end 
                end
                end
            end
            iterRect(function(PXY0)
                if PXY0==net.enum.EBigMapGridStatus_UNOPEN then
                    unopen=unopen+1
                elseif PXY0==net.enum.EBigMapGridStatus_MARK or PXY0==net.enum.EBigMapGridStatus_EXPLOSION then
                    mine=mine+1
                end
            end)
            if unopen==0 then
                event.dispatch('ChangeFace',3)
                return
            end
            if PXY==mine then
                if mdt.life<=0 and not mdt.isChallenge and not mdt.isNewbie then
                    local view = util.showDialog('Dialog', 'Common.BuyLife')
                    view:setcosttype('diamond')
                    return
                end
                iterRect(function(PXY0, x0, y0)
                    if PXY0==net.enum.EBigMapGridStatus_UNOPEN then
                        ctr.game.addEffect(x0, y0, 0)
                    end
                end)
                if mdt.isChallenge then
                    net.msg.NC_ChallengeClickGrid(x, y)
                else
                    if mdt.UseItemBoom then
                        net.msg.NC_ApplyUseItem(50001)
                        mdt.useboomx = x 
                        mdt.useboomy = y
                    end
                    net.msg.NC_ClickGrid(x, y)
                end
            elseif PXY==unopen+mine then
                if mdt.life<=0 and not mdt.isChallenge and not mdt.isNewbie then
                    local view = util.showDialog('Dialog', 'Common.BuyLife')
                    view:setcosttype('diamond')
                    return
                end
                iterRect(function(PXY0, x0, y0)
                    if PXY0==net.enum.EBigMapGridStatus_UNOPEN then
                        ctr.game.addEffect(x0, y0, 0)
                    end
                end)
                if mdt.isChallenge then
                    net.msg.NC_ChallengeClickGrid(x, y)
                elseif mdt.isNewbie then
                    event.dispatch('onNextNewbieStep')
                else
                    if mdt.UseItemBoom then
                        net.msg.NC_ApplyUseItem(50001)
                        mdt.useboomx = x 
                        mdt.useboomy = y
                    end
                    net.msg.NC_ClickGrid(x, y)  
                end
            else
                ctr.game.addEffect(x, y, 3)
                audio.playEffect('wrong')
                event.dispatch('ChangeFace',3)
            end
        elseif PXY == net.enum.EBigMapGridStatus_ZERO or PXY == net.enum.EBigMapGridStatus_MARK then
            if not mdt.isChallenge and not mdt.isNewbie then
                mdt.clickpos = {}
                mdt.clickpos = {x=x,y=y}
                event.dispatch('ShowPlayerInfo')
                event.dispatch('ChangeFace',3)
            end
        elseif PXY == net.enum.EBigMapGridStatus_EXPLOSION then
            event.dispatch('ChangeFace',3)
        end
    end
end

function game.clickGrid(x, y, nErr, nGUID)
    local id = tostring(x)..'_'..tostring(y)
    local eff = effect[id]
    if eff and eff.state==0 then
        eff.node:removeFromParent()
    end
    if nErr==1 then
        game.addEffect(x, y, 3)
        if nGUID==nil or nGUID == mdt.player.nGUID and not mdt.isChallenge then
            event.dispatch('onShake')
            audio.playEffect('boom')
            mdt.boomx = x
            mdt.boomy = y
            event.dispatch('ShowBoomEffect')
        end
    elseif nErr==2 then
        game.clearEffect()
    end
end

function game.flagGrid(x, y, nErr, nGUID)
    local id = tostring(x)..'_'..tostring(y)
    local eff = effect[id]
    if eff and eff.state==0 then
        eff.node:removeFromParent()
    end
    if nErr==0 then
        game.addEffect(x, y, 2)
    elseif nErr==1 then
        game.addEffect(x, y, 3)
        if nGUID==nil or nGUID == mdt.player.nGUID and not mdt.isChallenge then
            event.dispatch('onShake')
            audio.playEffect('wrong')
        end
    elseif nErr==2 then
        game.clearEffect()
    end
end

ctr.game = game
return ctr.game