cc.exports.ctr = ctr or {}
local login = {}
-- 游戏登录相关 登录LoginServer 完成后登录GameServer

local function regListener()
    if login.gsListener2 then
        event.remove(login.gsListener2)
        login.gsListener2 = nil
    end
    login.gsListener2 = event.addEvent('onDisconnectGameServer', ctr.login.onDisconnectGameServer, 1)
end

local function asyncWaitEvent(eventname)
    local fa = async.bindDelay(30)
    local fb = async.bindEvent(eventname)
    async.call(async.funcOr(fa,fb))
    if fa:isOver() then 
        return false
    end
    return true
end

function login.onStart()
    util.showDialog(nil, "Main.Start")

    local dateStr = os.date()
    local dateFmt = string.sub(dateStr, 1, 8)

    if mdr.loginSaving then
        if mdr.assess and mdr.assess == "never" then
            mdt.dontShowRate = true
        else
            if mdr.loginSaving ~= dateFmt then
                mdt.allowRate = true
            end
        end
    else
        mdr.loginSaving = dateFmt
        mdr.save()
        mdt.allowRate = false
    end
end

function login.connectToGetList(id)
    cc.exports.net = ndpnet
    net.setType(net.enum.ECT_Login)
    local server = static.getServerInfo(id)
    mdlogin.setCurLoginServerID(id)       --当前尝试登陆或已经登陆的服务器ID
    http.account.resetDownloadInfo(id)
    mdt.login.login_adr = server.adr
    mdt.login.login_port = server.port
    net.connect(mdt.login.login_adr, mdt.login.login_port)
    async.create(function()
        if not asyncWaitEvent('onConnectLoginServer') then

            if util.isShowDialog('Common.Waiting') then
                util.closeDialog('Common.Waiting')
            end
            
            --点击重新连接
            local dis = util.showDialog(nil, 'Common.DisconnectDialog')
            dis:setDislogInfo(function() ctr.player.restart() end)

            util.showDialog(nil,'Notice.Notice')

            return 
        end
        net.msg.NC_EnterLogin()
    end)
end

--获取服务器ID，规则：
--如果有上一次登录信息则直接登录上一次服务器
--否则ping一下服务器列表中的服务器，取ping值最低者(ping值超过3000放弃),如果没有则提示用户重新打开游戏
function login.findServerID()

end

function login.connectToGameServer(ip, port)
    print("-=----------------connectToGameServer:",ip, port)
    net.setType(net.enum.ECT_Game)
    net.connect(ip, port)
    local gameServerID = mdlogin.getLastlistServerID()
    async.create(function()
        if not asyncWaitEvent('onConnectGameServer') then 
        
            util.showDialog(nil, 'Common.DisconnectDialog')

            return 
        end
        
        net.msg.NC_EnterGame(gameServerID)
        while(true) do 
            local fa = async.bindDelay(30)
            local fb = async.bindEvent('NS_LoadPlayer')
            async.call(async.funcOr(fa,fb))
            if fa:isOver() then 
                event.dispatch('onConnectTimeOut')
                return
            end
            local data = fb:get()
            if not data.bEmpty then break end
        end
        mdt.isReconnet = false
        net.msg.NC_LoadMap()
        local fa = async.bindEvent('NS_LoadMap')
        local fb = async.bindEvent('NS_InformSwitchMap')
        async.call(async.funcOr(fa, fb))
        ctr.player.enterMainScene()
    end)
end

function login.reconnect()
    if mdt.isReconnet then
        return 
    end

    if util.isShowDialog("Common.DisconnectDialog") then
        util.closeDialog("Common.DisconnectDialog")
    end
    if util.isShowDialog("Common.Waiting") then
        util.closeDialog("Common.Waiting")
    end

    mdt.isReconnet = true
    mdt.CanPickReward = nil
    login.onStartLogin()
end

-- 绑定账号
function login.bind(data)
    print('bind start !!!!!!!!!!!!!!!!!!!!')
    async.create(function()
        ctr.player.showWaiting()
        local isBind = false
        local title = static.language[30080][device.language]
        local curAccountInfo = mdlogin.getAccountAndPassward(mdlogin.getCurLoginServerID())
        mdlogin.setOldAccountAndPassward(mdlogin.getCurLoginServerID(), curAccountInfo.account, curAccountInfo.passward)
        mdlogin.setAccountAndPassward(mdlogin.getCurLoginServerID(), data.thirdPlatformName, curAccountInfo.passward)
        mdlogin.setLoginType(mdlogin.getCurLoginServerID(), 2)

        local icondata = http.account.asyncDownloadPlatformIcon(data.thirdPlatformIconUrl, mdt.player.nGUID)
        local needUpload = true


        local iconName = cc.FileUtils:getInstance():getWritablePath()..'download/upload/head.png'

        local iconSize = nil --io.filesize(iconName)

        if io.exists(iconName) then
            iconSize = io.filesize(iconName)
            needUpload = false
        else
            needUpload = true
        end

        if icondata then

            io.writefile(iconName, icondata)

            local newSize = io.filesize(iconName)
            if newSize and newSize == iconSize then
                needUpload = false
                print("icon same dont need upload")
            else
                needUpload = true
            end

        end

        if needUpload and icondata then
            print(" need upload head ")
            net.msg.NC_RequestUploadHead()

            async.waitForEvent('NS_RequestUploadHead')
             
            local ret2 = http.account.asyncUpload(mdt.nHeadIndex, icondata, 1)
            if ret2 and ret2.result=='success' then
                local data = {}
                data.nHeadIndex = mdt.nHeadIndex
                net.msg.NC_UploadHeadComplete(data)

                mdr.save()

                print("上传图片成功！",ret2.pic)
            else
                print("上传图片失败！")
            end
        end


        ctr.player.hideWaiting()
    end)
end

function login.uploadHead()

    async.create(function()
    local iconName = cc.FileUtils:getInstance():getWritablePath()..'download/upload/head.png'

    if not io.exists(iconName) then
        mdr.forceUpload = true
        return
    end

    net.msg.NC_RequestUploadHead()

    async.waitForEvent('NS_RequestUploadHead')

    local icondata = io.readfile(iconName)

    local ret2 = http.account.asyncUpload(mdt.nHeadIndex, icondata, 1)

    if ret2 and ret2.result=='success' then
        local data = {}
        data.nHeadIndex = mdt.nHeadIndex
        net.msg.NC_UploadHeadComplete(data)

        mdr.forceUpload = true
        mdr.save()

        print("上传图片成功！",ret2.pic)
    else
        print("上传图片失败！")
    end

    end)
end

--账号解绑
function login.disband()
    local title = static.language[30081][device.language]
    ctr.player.showMessageBox(title, 2, function(ret)
        if ret then
            local oldAccountInfo = mdlogin.getOldAccountAndPassward(mdlogin.getCurLoginServerID())
            mdlogin.setAccountAndPassward(mdlogin.getCurLoginServerID(), oldAccountInfo.account, oldAccountInfo.passward)
            mdlogin.setLoginType(mdlogin.getCurLoginServerID(), 1)
            ctr.player.restart()
        end
    end)
    
end


function login.onDisconnectGameServer()

end

-- 是否是本地账号
function login.isLocalAccount()
end
-- 是否是Facebook账号
function login.isFacebookAccount()
    local loginType = mdlogin.getLoginType(mdlogin.getCurLoginServerID())
    return loginType == 2
end

-- -------------------------------------------------------------------------------------------------
-- 服务器消息处理
-- -------------------------------------------------------------------------------------------------
function login.NS_EnterLogin(nErrorCode)
    mdt.player = mdt.player or { }
    mdlogin.setLastServerID(mdlogin.getCurLoginServerID())
    local accountInfo = mdlogin.getAccountAndPassward(mdlogin.getCurLoginServerID())
    if accountInfo.account == "" and not mdt.player.szUserName and not mdt.player.szPassWord then
        --新玩家
        print("NS_EnterLogin set account")
        mdlogin.setLoginType(mdlogin.getCurLoginServerID(), 0)
        mdt.player.szUserName = accountInfo.account
        mdt.player.szPassWord = accountInfo.passward
    end

    if static.isInnerTest then
        mdt.player.szUserName = accountInfo.account
        mdt.player.szPassWord = accountInfo.passward
    end


    net.setType(net.enum.ECT_Login)
end

function login.onStartLogin()
    if not util.isShowDialog("Common.Waiting") then
        util.showDialog(nil, "Common.Waiting")
    end
    ctr.login.connectToGameServer(mdt.login.szGatewayIP, mdt.login.nGatewayPort)
end

ctr.login = login
return ctr.login
