cc.exports.ctr = ctr or {}
local player = {}

-- 进游戏时调用
function player.init()
    if mdr.isHasSaveData() then
        mdr.load()
    else
        mdr.init()
    end
    mdt.init()
    static.initUI()
    player.initNet()
    player.initTime()
end
----------------------------------------------------------------
-- for 单机 
----------------------------------------------------------------
-- 开始新游戏
function player.newGame()
	static.init()
	mdl.init()
    mdt.init()
end

-- 继续游戏
function player.continueGame()
    static.init()
    mdl.load()
    mdt.init()
end

-- 保存游戏
function player.save()
    mdl.save()
end

-- 重置游戏
function player.restart()
    mdt.isInGame = false
    if util.isShowDialog("Common.DisconnectDialog") then
        util.closeDialog("Common.DisconnectDialog")
    end
    if util.isShowDialog("Common.Waiting") then
        util.closeDialog("Common.Waiting")
    end
    util.enterScene('UpdatorScene')
    display.removeUnusedSpriteFrames()
    audio.stopMusic()
    net.close()
end

----------------------------------------------------------------
-- for 网游
----------------------------------------------------------------
function player.enterMainScene()
    static.init()
    -- if mdr.ClickIcon == nil then
    --     mdr.ClickIcon = false
    -- end
    if not mdr.ClickIcon then
        sdkManager.talkingdata:setEvent("30",{ClickIcon = "ClickIcon"})
        sdkManager.appsflyer:setEvent("30",{ClickIcon = "ClickIcon"})
        mdr.ClickIcon = true
        mdr.save()
    end
    util.enterScene('MainScene')
    net.wait(1)
end

function player.initNet()
    util.schedule(6, function()

        if net and net.isConnected() then
            net.msg.NC_Ping()
        end
    end)
end

function player.initTime()
    util.schedule(6, function()
        if mdt.BoxTime ~= nil then
            local time = os.time()
            for _,v in pairs(mdt.BoxTime) do
                if v[2] ~= -1 and v[1]+v[2] <= time then
                    event.dispatch('BoxTimeOver')
                    break
                end
            end
        end
    end)
end

function player.showWaiting(name)
    util.showDialog('Dialog', 'Common.Waiting')
end

function player.hideWaiting(name)
    util.closeDialog('Common.Waiting')
end

function player.showMessageBox(txt, msgType, callback)
    local view = util.showDialog(nil, 'Common.MessageBox')
    view:setText(txt)
    view:setOKListener(callback)
    view:setType(msgType)
    return view
end

function player.uploadFlag(imageFullPath,callback)
    async.create(function()
        if type(imageFullPath) then
            local file = io.open(imageFullPath, "rb")
            if file then
                local imageData = file:read("*a")
                 io.close(file)
                 if imageData and string.len(imageData) > 0 then
                    local ret2 = http.account.asyncUpload(mdt.nFlagIndex,imageData,2)  -- 1上传头像  2上传旗子
                    if ret2 and ret2.result=='success' then
                        local data = {}
                        data.nFlagIndex = mdt.nFlagIndex
                        net.msg.NC_UploadFlagComplete(data)
                        http.account.saveFlag(mdt.player.nGUID, ret2.pic, imageData)
                        --print('-------------旗子上传成功')
                        --print("执行Flag本地保存......",ret2.pic) 
                        if type(callback) == "function" then
                            callback()
                        end
                    else
                        --print('-------------旗子上传失败')
                    end
                end
            end
        end
    end)
end

function player.downLoadFlag(imageId,callback)
    local result = nil
    if nil == player.curDownloadFlag then
        player.curDownloadFlag = {}
    end
    local imageFullPath = string.format("%s%s.png",device.writablePath,imageId)
    --print("-----检测图片地址:",imageFullPath)
    if cc.FileUtils:getInstance():isFileExist(imageFullPath) then
        result = imageFullPath
        --print("-----Bingo!:本地已经存在图片:",imageFullPath)
    else
        --print("-----本地未发现图片:",imageFullPath)
        local curFlag = string.format("flag%s",imageId)
        --print("检测是否正在下载该图片:",curFlag,imageId)
        if nil == player.curDownloadFlag[curFlag] then
            player.curDownloadFlag[curFlag] = imageId
            local imageFullUrl = string.format("http://%s/MineShareServer/uploadFlag/%s.png",static.SERVER_LIST[mdlogin.getCurLoginServerID()].downloadFlagURL,imageId)
            --print("图片下载地址:",imageFullUrl)
            http.download(imageFullUrl, imageFullPath, function(response)
                if nil == response then
                    print("下载棋子失败!")
                else
                    print("下载棋子成功！",imageId,response,imageFullPath)
                    if type(callback) == "function" then
                        callback(imageId,imageFullPath)
                    end
                end
            end)
        end
    end
    return result
end

function player.doValidateOrder(receiptdata)
    local rechargeServerId = nil
    if static.text then
        rechargeServerId = static.textlistserver
    else
        rechargeServerId = mdlogin.getLastlistServerID()
    end

    if util.isIOS() then
    	local url = string.format("http://%s/MineShareServer/applereceive?receiptdata=%s&channel=&guid=%s&serverId=%s",static.SERVER_LIST[mdlogin.getCurLoginServerID()].validateOrder,string.urlencode(receiptdata),mdt.player.nGUID.a,rechargeServerId)
	    http.doGet(url, nil, function(response)
            if response then
                dump(response)
            end
	    end)
    end
end

function player.SendLoadPlayerData(eType)
	net.msg.NC_LoadPlayer(eType)
end

function player.NS_LoadPlayer(ns)
    if 0 == ns.nErrorCode then
		if  true == ns.bEmpty then
			--Sleep(1);
			net.msg.NC_CreatePlayer(mdt.player.szUserName, 34000001)

			--m_ePlayerStatus = EPlayerStatus_CreatePlayerStart;

            --print(string.format("# Player[%s][%d] Create Player ", mdt.player.szUserName, mdt.player.nGUID.v))
		else
		    --print(string.format("# Player[%s][%d] Load Data OK................ ", mdt.player.szUserName, mdt.player.nGUID.v))
			--SendLoadTankData();
            ns:copyTo(mdt.player)
            mdt.nextcost = ns.nNextBuyLifeCost
            mdt.player.sMineMapData.szName = ns.sMainData.szName
            mdt.lifeRecoveryTM = ns.sMainData.nNextRecoveryLifeTime.v
            mdt.life = ns.sMainData.nCurLife
            mdt.mypvpcoin = ns.sChallengeData.nChallengeScore
            mdt.player.gold = mdt.player.sCurrency.m_nCurrency[net.enum.ECurrency_Gold+1]
            mdt.player.diamond = mdt.player.sCurrency.m_nCurrency[net.enum.ECurrency_Diamond+1]
            mdt.cursorindex = ns.sMainData.nCursorIndex
            mdt.flagindex = ns.sMainData.nFlagUrlIndex
            mdt.themeindex = ns.sMainData.nThemeIndex
            mdt.player.country = ns.sMainData.nCountry
            mdt.uploadFlagUrlIndex = ns.sMainData.nUploadFlagUrlIndex
            mdt.ChangeNationalityNum = ns.sMainData.nChangeNationalityNum
            mdt.player.headindex = ns.sMainData.nHeadIndex
            mdt.mapID = ns.sMineMapData.nCurMapId
            mdt.nFirstChargeGiftIsBuy = ns.sMainData.nFirstChargeGiftIsBuy
            mdt.FristCharge = false
            mdt.adReward = ns.sMainData.nIntegralWallDayAddMoney

            if mdt.cursorindex == 1 then
                mdt.cursorindex = 20101
            end
            if mdt.flagindex == 1 then
                mdt.flagindex = 10101
            end
            if mdt.themeindex == 1 then
                mdt.themeindex = 30101
            end
            -- mdt.theme = ns.sMainData.nThemeIndex
            mdt.theme = mdt.themeindex - 30100  -- TODO
            if mdt.theme < 0 then mdt.theme = 1 end
            mdt.x = ns.sMineMapData.nPosX
            mdt.y = ns.sMineMapData.nPosY
            mdt.tempx = ns.sMineMapData.nPosX
            mdt.tempy = ns.sMineMapData.nPosY
            -- if mdr.pic then
            --     net.msg.NC_HeadUrlInfo(mdr.pic)
            --     mdt.player.sMainData.nHeadIndex = mdr.pic
            --     mdr.pic = nil
            --     mdr.save()
            -- end
            mdt.ItemModsOpen = ns.sMainData.nModFunctionFlag
			-- 增加道具;
			--SendPlayerBuyItem();

			--m_ePlayerStatus = EPlayerStatus_InGame_LoadTankStart;
		end
	else
		--print(string.format("# Player[%s][%d] Load Player Falied ", mdt.player.szUserName, mdt.player.nGUID.v))
	end
    print("============================================NS_LoadPlayer")
    dump(ns)
end

function player.NS_CreatePlayer(ns)
	if 0 == ns.nErrorCode then
		ctr.player.SendLoadPlayerData(net.enum.ELPDT_LoginLoad);
	else
        --print(string.format("# Player[%s][%d] Create Player Falied ", mdt.player.szUserName, mdt.player.nGUID.v))
	end
end

function player.NS_SynchroCurrency(ns)
    mdt.player.sCurrency = ns.sCurrency:copyTo()
    mdt.player.gold = mdt.player.sCurrency.m_nCurrency[net.enum.ECurrency_Gold+1]
    mdt.player.diamond = mdt.player.sCurrency.m_nCurrency[net.enum.ECurrency_Diamond+1]

    event.dispatch("OnRefreshGoldOrDiamondRecharge")
    print("============================================NS_SynchroCurrency")
    dump(ns)
end

function player.NS_PlayerLevelUp(ns)
   mdt.player.sData.nLevel = ns.nLevel    
end

ctr.player = player
return ctr.player