cc.exports.ctr = ctr or {}
local server = {}
local msg = ndpserver.msg
local tag = ndpserver.tag

local room = {}
local mapW = static.MapWidth
local mapH = static.MapHeight
function server.update(dt) 
    for _, man in pairs(room.manList) do
        if man.isDead then
            man.deadTick = man.deadTick - dt
            if man.deadTick<=0 then
                ctr.server.resurrect(man.client)
            end
        end
    end
end

function server.createGame(port)
    ndpserver.listen(port)

    -- create map
    room.point = {}
    room.mark = {}
    room.manList = {}
    room.clientList = {}
    for i=1,mapW do
        room.point[i] = {}
        room.mark[i] = {}
    end

    --  0:space >0:num  -1:mine 
    local list = {}
    for j=1, mapW*mapH*0.2 do
        local x = math.random(1, mapW)
        local y = math.random(1, mapH)
        if room.point[x][y]==9 then
            j=j-1
        else
            room.point[x][y] = 9
            list[#list+1] = { x=x, y=y}
        end
    end

    local function addNum(x, y)
        if x>0 and y>0 and x<=mapW and y<=mapH then
            local n = room.point[x][y]
            if n~=9 then
                room.point[x][y] = (n or 0) + 1
            end
        end
    end

    for _, v in pairs(list) do
        local x = v.x
        local y = v.y

        addNum(x-1, y-1)
        addNum(x-1, y)
        addNum(x-1, y+1)
        addNum(x, y-1)
        addNum(x, y+1)
        addNum(x+1, y-1)
        addNum(x+1, y)
        addNum(x+1, y+1)
    end

    mdt.isServer = true

end

function server.enterGame(client, username)

end
 
function server.getClient(client)
    for _,v in pairs(room.manList) do
        if v.client==client then
            return v
        end
    end
end

function server.getGuid(guid)
    for _,v in pairs(room.manList) do
        if v.guid==guid then
            return v
        end
    end
end

function server.refreshData(client, x,y,w,h)
    
    if x<1 then x=1 end
    if y<1 then y=1 end
    if x>mapW then x=mapW end
    if y>mapH then y=mapH end
    if x+w>mapW then w=mapW-x+1 end
    if y+h>mapH then h=mapH-y+1 end
    
    local data = {}
    for x0 = x, x+w-1 do
        local p = room.point[x0]
        local m = room.mark[x0]
        for y0 = y, y+h-1 do
            local d = p[y0]
            local mark = m[y0]
            if not mark then
                d=-1
            else
                if d==-1 then
                    if mark==1 then
                        d=-2 
                    else
                        d=-3
                    end
                end
            end
            data[#data+1] = d or 0
        end
    end

    local ns = ndpserver.tag.NS_Respone:create()
    ns.type = 0
    ns.x = x
    ns.y = y
    ns.w = w
    ns.h = h
    ns.data = data
    --ndpserver.send(client, ns)
    return ns
end


function server.click(client, nc)
    local mark = room.mark[nc.x][nc.y]
    if mark then return end
    local mode = nc.mode
    local minX = nc.x
    local minY = nc.y
    local maxX = nc.x
    local maxY = nc.y
    local v = room.point[nc.x][nc.y]
    v=v or 0
    if v>0 then
        room.mark[nc.x][nc.y] = 1
        if mode == 2 then
            server.dead(client)
        end
    elseif v==0 then
        local function iterMark(x, y)
            if x<1 or y<1 or x>mapW or y>mapH then return end
            local mark0 = room.mark[x][y]
            if mark0 then return end
            local v0 = room.point[x][y]
            v0 = v0 or 0
            room.mark[x][y] = 1
            minX = math.min(minX, x)
            maxX = math.max(maxX, x)
            minY = math.min(minY, y)
            maxY = math.max(maxY, y)
            if v0==0 then
                for i=x-1,x+1 do
                for j=y-1,y+1 do
                    if i~=x or j~=y then
                        iterMark(i,j)
                    end
                end
                end
                
            end
        end
        iterMark(nc.x, nc.y)

        if mode == 2 then
            server.dead(client)
        end
    elseif v==-1 then
        if mode == 1 then
            server.dead(client)

            room.mark[nc.x][nc.y] = 1
        else
            room.mark[nc.x][nc.y] = 2
        end
    end

    local ns = ctr.server.refreshData(client, minX, minY, maxX-minX+1, maxY-minY+1)
    ndpserver.sendAll(ns)
end

function server.dead(client)
    local man = ctr.server.getClient(client)
    man.isDead = true
    man.deadTick = 5
    local ns = ndpserver.tag.NS_Dead:create()
    ns.guid = man.guid
    ndpserver.sendAll(ns)
end

function server.resurrect(client)
    local man = ctr.server.getClient(client)
    man.isDead = false
    man.deadTick = 0
    local ns = ndpserver.tag.NS_Resurrect:create()
    ns.guid = man.guid
    ndpserver.sendAll(ns)
end

function server.move(client, nc)
    local man = server.getClient(client)
    if not man then return end

    man.px = nc.px
    man.py = nc.py
    man.dx = nc.dx
    man.dy = nc.dy

    local ns = ndpserver.tag.NS_Move:create()
    
    ns.guid = man.guid
    ns.px = man.px
    ns.py = man.py
    ns.dx = man.dx
    ns.dy = man.dy

    ndpserver.sendAll(ns)

end


function msg.NC_EnterLogin(client, nc)
    local ns = tag.NS_EnterLogin:create()

    ndpserver.send(client, ns)
end

function msg.NC_LoginVerfiy(client, nc)
    local ns = tag.NS_LoginVerfiy:create()
    ns.szGatewayIP = socket.dns.toip(socket.dns.gethostname())
    ns.nGatewayPort = 6666

    ndpserver.send(client, ns)
end

function msg.NC_EnterGame(client, nc)
    local ns = tag.NS_EnterGame:create()

    ndpserver.send(client, ns)  
end

function msg.NC_LoadPlayer(client, nc)
    local ns = tag.NS_LoadPlayer:create()
    ns.sData = tag.tagPlayerMainData:create()
    ns.sCurrency = tag.tagPlayerCurrency:create()
    ns.nLoginType = 1
    ns.bEmpty = false
    ndpserver.send(client, ns)  
end

function msg.NC_LoadMap(client, nc)
    local ns = tag.NS_LoadMap:create()
    ns.nPosX = 10
    ns.nPosY = 10
    ns.nWidth = mapW
    ns.nHeight = mapH
    ndpserver.send(client, ns)
end

function msg.NC_LoadRect(client, nc)
    local ns = tag.NS_RectGridChange:create()
    ns.nPosX = nc.nPosX
    ns.nPosY = nc.nPosY
    ns.nWidth = nc.nWidth
    ns.nHeight = nc.nHeight
    local state = {}
    for j=1, ns.nHeight do
        for i=1, ns.nWidth do
            local PX = room.point[nc.nPosX+i]
            local PXY = PX and PX[nc.nPosY+j] or 0
            local MX = room.mark[nc.nPosX+i]
            local MXY = MX and MX[nc.nPosY+j] or 0
            if MXY == 0 then
                PXY = net.enum.EBigMapGridStatus_UNOPEN
            end
            state[#state+1] = 0 -- PXY -- math.random(0,11)
        end
    end
    ns.byState = state
    ns.byGuid = {}
    ndpserver.send(client, ns)
end

function msg.NC_LoadThumbnail(client, nc)
    local ns = tag.NS_LoadThumbnail:create()

    --for j=0, 11 do
    local j = nc.nIndex
        ns.nIndex = j
        ns.byState = {}
        for i=1,static.MapWidth*60/8 do
            ns.byState[i] = 255 -- math.random(0,122)
        end
        ndpserver.send(client, ns)
    --end
end

function msg.NC_ClickGrid(client, nc)
    ctr.server.click(client,{ x=nc.nPosX, y=nc.nPosY, mode=1 })
--    util.delay(0.5, function()
--    local ns = tag.NS_ClickGrid:create()
--    ns.nErrorCode = 0
--    ns.nPosX = nc.nPosX
--    ns.nPosY = nc.nPosY
--    ndpserver.send(client,ns)
--    end)
end


ctr.server = server
return ctr.server