local AdManager = class("AdManager")

function AdManager:init()
self.sdks = {
    [1] = sdkManager.applovin, --applovin,
    [2] = sdkManager.vungle, --vungle,
    [3] = sdkManager.unityads,--unityads,
    [4] = sdkManager.applovin, --applovin, adcolony
}

    if util.isAndroid() then
        self.sdks[4] = sdkManager.adcolony

        if not static.isHaiWai then
            self.sdks[1] = sdkManager.oneway
            self.sdks[2] = sdkManager.oneway
            self.sdks[3] = sdkManager.oneway
            self.sdks[4] = sdkManager.oneway
        end
    end

end

function AdManager:isADAvailable(adid)
    if static.isInnerTest then
        return false
    end

    if adid == 99 then
        for _, v in ipairs(self.sdks) do
            if v:isAdsReady() then
                return true
            end
        end
        return false
    end

    local isReady = false

    if self.sdks[adid]:isAdsReady() then
        isReady = true
     end
     return isReady
end

function AdManager:playAds(adid, callback)
    if static.isInnerTest then
        return 
    end
    

    util.showDialog('Dialog', 'Common.Waiting')
    audio.pauseMusic()

    if adid == 99 then
        for _, v in ipairs(self.sdks) do
            if v:isAdsReady() then
                v:showAds(callback)
                break
            end
            
        end
    else
        if self.sdks[adid]:isAdsReady() then
            self.sdks[adid]:showAds(callback)
        end
    end

end


cc.exports.AdManager = AdManager

return AdManager
