local AndroidPay = class("AndroidPay",sdkManager:getSDK("sdkBase"))

AndroidPay["id"]="androidpay"

function AndroidPay:pay(ipaID)

    if not util.isShowDialog('Common.Waiting') then
        util.showDialog('Dialog', 'Common.Waiting')
    end

	local param = {["sku"] = ipaID}
    local args={json.encode(param)}

    local luaj = require "cocos.cocos2d.luaj"
    local classname = "org/cocos2dx/lua/AppActivity"
    local sigs = "(Ljava/lang/String;)V"

    local ok, ret = luaj.callStaticMethod(classname, "pay", args, sigs)

    local function payCallback(result)
        if util.isShowDialog('Common.Waiting') then
            util.closeDialog('Common.Waiting')
        end

        if result == "err" then
            print("pay error")
        else
            print("pay success")
            sdkManager.talkingdata:setPaySuccess(mdt.payOrderID)
            sdkManager.appsflyer:setPaySuccess(mdt.payOrderID)
        end

    end

    util.SendLuaFuncID2Java(payCallback)
end


return AndroidPay
