local SDKFacebook = class("SDKFacebook",sdkManager:getSDK("sdkBase"))

	SDKFacebook["id"]="facebook"
	SDKFacebook["cmd"]={
		LOGIN=1001, --授权登录
		SHARE=1002, --分享
		LOGOUT=1003,--注销


		CB_LOGIN_SUCCESS=2010, --[回调]授权登录_成功
		CB_LOGIN_FAILED=2011, --[回调]授权登录_失败 --一般不用做处理，会有提示框
		CB_LOGOUT=2030 --[回调]授权登录
	}

	--[[登录]]
	function SDKFacebook:login(callback)
		if self:isAndroid() or self:isIOS() then
			self:setCallback(self.cmd.LOGIN,callback)
			sdkManager:luaBridge(self:createParameter(self.id,self.cmd.LOGIN))  
		end
	end
	--[[注销]]
	function SDKFacebook:logout(callback)
		if self:isAndroid() or self:isIOS() then
			self:setCallback(self.cmd.LOGOUT,callback)
			sdkManager:luaBridge(self:createParameter(self.id,self.cmd.LOGOUT))
		end
	end
	--[[分享]]
	function SDKFacebook:share()
		if self:isAndroid() or self:isIOS() then
			local function cbShare()
				local param={}
				param["contentTitle"]="Survival Of Primitive"
				param["imageUrl"]="https://lh3.googleusercontent.com/dSGtGWk5Re3LbkXfTplvInfI3jXGZ0t0KhrjjQF8JsmSszMXMETnoxV_t8i2d51-iQ=w300"
				param["contentUrl"]="https://itunes.apple.com/us/app/man-huang-ri-ji/id1087652287?l=zh&ls=1&mt=8"
				param["contentDescription"]="A text-based survival adventure game with a great story line."
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SHARE,param))
			end
			util.delay(1,cbShare)
		end
	end
	--[[回调==登录]]
	function SDKFacebook:processLogin(param)
		local cbFunc = self:getCallback(self.cmd.LOGIN)
		if type(cbFunc) == "function" then
			cbFunc(param)
		end
	end
	--[[回调==分享]]
	function SDKFacebook:processShare(isCompleted)
	end
	--[[回调==注销]]
	function SDKFacebook:processLogout()
		local cbFunc = self:getCallback(self.cmd.LOGOUT)
		if type(cbFunc) == "function" then
			cbFunc()
		end
	end
	--[[回调处理]]
	function SDKFacebook:handler(response)
		if self:isAndroid() or self:isIOS() then
			if type(response)=="table" then
				local cmd=response["cmd"]
				if type(cmd)=="number" then
					if cmd==self.cmd.CB_LOGIN_SUCCESS then
						self:processLogin(response.param)
					elseif cmd==self.cmd.CB_LOGOUT then
						self:processLogout()
					end
				end
			end
		end
	end

return SDKFacebook