local SDKTalkingdata = class("SDKTalkingdata",sdkManager:getSDK("sdkBase"))

	SDKTalkingdata["id"] = "talkingdata"
	SDKTalkingdata["cmd"] = {
		SET_ACCOUNT_INFOS = 1001, --设置Account 参数:playerID,playerName
		SET_PAY = 1002, --设置玩家支付
		SET_PAY_SUCCESS = 1003, --设置玩家支付成功
		SET_EVENT = 1004, --设置自定义事件
	}

	--[[设置玩家信息]]
	function SDKTalkingdata:setAccountInfos(playerId,playerName,gender,age,server,channel)
		if self:isIOS() or self:isAndroid() then
			if type(playerId) == "string" then
				local param = {}
				param["playerId"] = playerId
				if type(playerName) == "string" then
					param["playerName"] = playerName 
				end
				if not (type(gender) == "number" and (gender==0 or gender == 1 or gender == 2)) then --0:unknow 1:male 2:female
					param["gender"] = 0
				end
				param["gender"] = gender
				if type(age) ~= "number" then
					param["age"] = 0
				end
				param["age"] = age
				param["server"] = server
				param["channel"] = channel
				dump(param)
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_ACCOUNT_INFOS,param))
			end
		end
	end
	--[[设置支付]]
	function SDKTalkingdata:setPay(orderId,iapId,price,currencyType)
		currencyType =  currencyType or "CNY"
		if self:isIOS() or self:isAndroid() then
			if type(orderId) == "string" and type(iapId) == "string" and type(price) == "number" then
				local param = {["orderId"] = orderId,["iapId"] = iapId,["currencyAmount"] = price,["virtualCurrencyAmount"] = price ,["currencyType"]=currencyType}
				mdt.payOrderID = orderId
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_PAY,param))
			end
		end
	end
	--[[设置支付成功]]
	function SDKTalkingdata:setPaySuccess(orderId)
		if self:isIOS() or self:isAndroid() then
			if type(orderId) == "string" then
				local param = {["orderId"] = orderId}
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_PAY_SUCCESS,param))
			end
		end
	end
	--[[设置事件]]
	function SDKTalkingdata:setEvent(eventId,eventInfo)
		if nil ~= eventId then
			eventId = tostring(eventId)
			if self:isIOS() or self:isAndroid() then
				local param = {["eventId"] = eventId,["eventInfo"] = eventInfo}
				sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SET_EVENT,param))
			end
			printInfo("【设置埋点】: %s",eventId)
		end
	end

return SDKTalkingdata