--
-- Author: MrC
-- Date: 2016-05-11 11:23:48
--
--UnityAds 视频广告
local SDKUnityAds = class("SDKUnityAds",sdkManager:getSDK("sdkBase"))
								
	SDKUnityAds["id"]="unityads"
	SDKUnityAds["isFetchedCompleted"]=false
	SDKUnityAds["cmd"]={
		SHOW_ADS=1001, -- 显示广告
	    CHECK_ADS=1002, -- 检查广告是否获取成功
		CB_VIDEO_COMPLETED=2001, -- 广告播放完毕
	    CB_VIDEO_DID_HIDE=2002, -- 关闭广告
	    CB_VIDEO_DID_SHOW=2003, -- 开始播放广告
	    CB_VIDEO_FETCH_COMPLETED=2004, -- 广告获取成功
	    CB_VIDEO_FETCH_FAILED=2005, -- 广告获取失败
	    CB_VIDEO_STARTED=2006, -- 广告开始播放播放
	    CB_VIDEO_WILL_HIDE=2007, -- 广告准备关闭
	    CB_VIDEO_WILL_LEAVE_APPLICATION=2008, -- 广告消失
	    CB_VIDEO_WILL_SHOW=2009, -- 广告播放准备中
	}


	--[[显示广告]]
	function SDKUnityAds:showAds(callback)
		if self:isAndroid() or self:isIOS() then
			-- if self:getAdsStatus() then
		    	self:setCallback(self.cmd.SHOW_ADS,callback)
		        sdkManager:luaBridge(self:createParameter(self.id,self.cmd.SHOW_ADS))
		    -- else
		    	-- print("=======no adsStatus")
		        -- if type(callback)=="function" then
		        -- 	callback()
		        -- end
		    -- end
		end
	end
	--[[设置当前广告播放状态]]
	function SDKUnityAds:setAdsStatus(isFetchedCompleted)
	    self.isFetchedCompleted=isFetchedCompleted
	end
	--[[获取当前广告播放状态]]
	function SDKUnityAds:isAdsReady()
        if util.isIOS() then
        	    return self.isFetchedCompleted
        elseif util.isAndroid() then
            local adsInfo = sdkManager:luaBridge(self:createParameter(self.id,self.cmd.CHECK_ADS))
            return sdkManager:checkAdAvalible(adsInfo)
        end
	end
	--[[获取当前广告播放状态]]
	function SDKUnityAds:getAdsStatus()
	    return self.isFetchedCompleted
	end
	--[[检查广告是否获取成功]]
	function SDKUnityAds:checkAds()
	    sdkManager:luaBridge(self:createParameter(self.id,self.cmd.CHECK_ADS))
	end
	--[[看完广告处理]]
	function SDKUnityAds:processCompleted(isPlayCompleted)
		self:getCallback(self.cmd.SHOW_ADS)((isPlayCompleted=="yes"))
	end
	--[[广告回调处理]]
	function SDKUnityAds:handler(response)
		local cmd=response["cmd"]
		if type(cmd)=="number" then
			if cmd==self.cmd.CB_VIDEO_FETCH_COMPLETED then
				print("【服务器已经准备好广告(UnityAds)，可以点击播放广告了！】")
	            self:setAdsStatus(true)
	        elseif cmd==self.cmd.CB_VIDEO_FETCH_FAILED then
	        	print("【服务器抓取广告(Unityads)失败！】")
	        	self:setAdsStatus(false)
	        elseif cmd==self.cmd.CB_VIDEO_DID_HIDE then
	        	print("【广告(Unityads)已经关闭！】")
                sdkManager.talkingdata:setEvent("33",{AD3 = "AD2"})
                sdkManager.appsflyer:setEvent("33",{AD3 = "AD2"})
	            self:processCompleted(response.param)
			end
		end
	end

return SDKUnityAds