local sdkBase = class("sdkBase")

	sdkBase["callbacks"] = {}
	sdkBase["cmd"] = {
		CMD_COMMON_SET_DEBUG = 9001,
	}
	
	--[[逻辑处理]]
	function sdkBase:handler(response)
		printInfo(string.format("%s 没有实现handler方法！",self.__cname))
	end
	--[[生成参数]]
	function sdkBase:createParameter(sdkId,cmd,jsonInfo)
		local result = {}
		if type(sdkId) == "string" and type(cmd) == "number" then
			result["id"] = sdkId
			result["cmd"] = cmd
		end
		if type(jsonInfo) == "table" then
			if sdkManager:isIOS() then
				result["param"] = json.encode(jsonInfo)
			else
				result["param"] = jsonInfo
			end
		end
		return result;
	end
	--[[绑定指定key值的回调]]
	function sdkBase:setCallback(key,callback)
		if key and type(callback) == "function" then
			self.callbacks[string.format("%s%s",self.id,tostring(key))] = callback
		end
	end
	--[[获取指定key值的回调]]
	function sdkBase:getCallback(key)
		local result = function(...) printInfo("【%s】:No callback in key %s",self.id,tostring(key)) end
		if key then
			if self.callbacks[string.format("%s%s",self.id,tostring(key))] then
				result = self.callbacks[string.format("%s%s",self.id,tostring(key))]
			end
		end
		return result
	end
	--[[设置Debug模式]]
	function sdkBase:setDebug(isDebug)
		if type(isDebug) == "boolean" then
			sdkManager:luaBridge(self:createParameter(self.id,self.cmd.CMD_COMMON_SET_DEBUG))
		end
	end
	--[[检查是否Boolean类型，如果不是则设置默认值]]
	function sdkBase:checkBoolean(variable,defaultValue)
		local result = false
		if type(variable) == "boolean" then
			result = variable
		elseif type(defaultValue) == "boolean" then
			result = defaultValue
		end
		return result
	end
	--[[检查是否String类型，如果不是则设置默认值]]
	function sdkBase:checkString(variable,defaultValue)
		local result = ""
		if type(variable) == "string" then
			result = variable
		elseif type(defaultValue) == "string" or nil == defaultValue then
			result = defaultValue
		end
		return result
	end
	--[[检查是否Table类型，如果不是则设置默认值]]
	function sdkBase:checkTable(variable,defaultValue)
		local result = ""
		if type(variable) == "table" then
			result = variable
		elseif type(defaultValue) == "table" or nil == defaultValue then
			result = defaultValue
		end
		return result
	end
	--[[判断是否Android]]
	function sdkBase:isAndroid()
		return sdkManager:isAndroid()
	end
	--[[判断是否iOS]]
	function sdkBase:isIOS()
		return sdkManager:isIOS()
	end

return sdkBase