cc.exports.mdlogin = mdlogin or {}

require('json')

--登录相关信息存储
function mdlogin.init()

end

function mdlogin.load()
    if not mdlogin.isHasSaveData() then
        return
    end
    local key = 'LOGIN_DATA'
    local data = cc.UserDefault:getInstance():getStringForKey(key)
    local m = json.decode(data)
    for k,v in pairs(m) do
        mdlogin[k]=v
    end
end

function mdlogin.isHasSaveData(num)
    local key = 'LOGIN_DATA'
    local data = cc.UserDefault:getInstance():getStringForKey(key)
    return data~=""
end

function mdlogin.save()
    local key = 'LOGIN_DATA'
    local data = json.encode(mdlogin)
    cc.UserDefault:getInstance():setStringForKey(key, data)
end

--设置最后一次登录的服务器ID
function mdlogin.setLastServerID(serverID)
    mdlogin.lastServerID = serverID
    mdlogin.save()
end

--获取最后一次登录服务器ID
function mdlogin.getLastServerID()
    return mdlogin.lastServerID or ""
end

--设置当前要登录的服务器ID
function mdlogin.setCurLoginServerID(serverID)
    mdlogin.curServerID = serverID
    mdlogin.save()
end

--设置登录的小服务器ID
function mdlogin.setLastListServerID(serverID)
    mdlogin.lastlistServerID = serverID
    mdlogin.save()
end

function mdlogin.getLastlistServerID()
    return mdlogin.lastlistServerID or 0
end

--获取当前要登录的服务器ID
function mdlogin.getCurLoginServerID()
    return mdlogin.curServerID or ""
end

--设置登录账号密码
function mdlogin.setAccountAndPassward(serverID, account, passward)
    mdlogin.account = mdlogin.account or {}
    mdlogin.account[serverID] = mdlogin.account[serverID] or {}
    mdlogin.account[serverID].account = account
    mdlogin.account[serverID].passward = passward
    mdlogin.save()
end

--获取登录账号密码
function mdlogin.getAccountAndPassward(serverID)
    local accountInfo = {}
    accountInfo.account = ""
    accountInfo.passward = ""

    if not mdlogin.account then     --新安装的客户端，没有账号信息
        return accountInfo
    end

    if mdlogin.account[serverID] then
        accountInfo.account = mdlogin.account[serverID].account or ""
        accountInfo.passward = mdlogin.account[serverID].passward or ""
    end

    return accountInfo
end

--设置旧账号密码
function mdlogin.setOldAccountAndPassward(serverID, account, passward)


    mdlogin.account = mdlogin.account or {}
    mdlogin.account[serverID] = mdlogin.account[serverID] or {}
    mdlogin.account[serverID].oldAccount = account
    mdlogin.account[serverID].oldPassward = passward
    mdlogin.save()
end

--获取旧账号密码
function mdlogin.getOldAccountAndPassward(serverID)
    local accountInfo = {}
    accountInfo.oldAccount = ""
    accountInfo.oldPassward = ""

    if not mdlogin.account then     --新安装的客户端，没有账号信息
        return accountInfo
    end

    if mdlogin.account[serverID] then
        accountInfo.oldAccount = mdlogin.account[serverID].oldAccount or ""
        accountInfo.oldPassward = mdlogin.account[serverID].oldPassward or ""
    end

    return accountInfo
end

--设置登陆状态
function mdlogin.setLoginType(serverID, loginType)
    mdlogin.account = mdlogin.account or {}
    mdlogin.account[serverID] = mdlogin.account[serverID] or {}
    mdlogin.account[serverID].loginType = loginType
    mdlogin.save()
end

--获取登陆状态
function mdlogin.getLoginType(serverID)
    if not mdlogin.account then     --新安装的客户端，没有账号信息
        return 0
    end

    if mdlogin.account[serverID] then
        return mdlogin.account[serverID].loginType or 0
    end

    return 0
end

--是否开启过新手引导
function mdlogin.getIsNewbieBeging(serverID)
    if not mdlogin.account then
        return true
    end

    if mdlogin.account[serverID] and mdlogin.account[serverID].isnewbiebegin ~= nil then
        return mdlogin.account[serverID].isnewbiebegin
    end

    return true
end

--设置是否开启过新手引导
function mdlogin.setIsNewbieBeging(serverID, isnewbiebegin)
    mdlogin.account = mdlogin.account or {}
    mdlogin.account[serverID] = mdlogin.account[serverID] or {}
    mdlogin.account[serverID].isnewbiebegin = isnewbiebegin
    mdlogin.save()
end

--
function mdlogin.getNewbieagainStep(serverID)
    if not mdlogin.account then
        return false
    end

    if mdlogin.account[serverID] and mdlogin.account[serverID].NewbieagainStep ~= nil then
        return mdlogin.account[serverID].NewbieagainStep
    end

    return false
end

--
function mdlogin.setNewbieagainStep(serverID, NewbieagainStep)
    mdlogin.account = mdlogin.account or {}
    mdlogin.account[serverID] = mdlogin.account[serverID] or {}
    mdlogin.account[serverID].NewbieagainStep = NewbieagainStep
    mdlogin.save()
end

--新手引导点击退出
function mdlogin.getNewbieagainReturn(serverID)
    if not mdlogin.account then
        return false
    end

    if mdlogin.account[serverID] and mdlogin.account[serverID].NewbieagainReturn ~= nil then
        return mdlogin.account[serverID].NewbieagainReturn
    end

    return false
end

--
function mdlogin.setNewbieagainReturn(serverID, NewbieagainReturn)
    mdlogin.account = mdlogin.account or {}
    mdlogin.account[serverID] = mdlogin.account[serverID] or {}
    mdlogin.account[serverID].NewbieagainReturn = NewbieagainReturn
    mdlogin.save()
end

--新手引导是否完成
function mdlogin.getIsNewbieComplete(serverID)
    if not mdlogin.account then
        return false
    end

    if mdlogin.account[serverID] and mdlogin.account[serverID].isNewbieComplete ~= nil then
        return mdlogin.account[serverID].isNewbieComplete
    end

    return false
end

--
function mdlogin.setIsNewbieComplete(serverID, isNewbieComplete)
    mdlogin.account = mdlogin.account or {}
    mdlogin.account[serverID] = mdlogin.account[serverID] or {}
    mdlogin.account[serverID].isNewbieComplete = isNewbieComplete
    mdlogin.save()
end

--talkingdata埋点相关
function mdlogin.getNewbieagainFalse(serverID)
    if not mdlogin.account then
        return false
    end

    if mdlogin.account[serverID] and mdlogin.account[serverID].NewbieagainFalse ~= nil then
        return mdlogin.account[serverID].NewbieagainFalse
    end

    return false
end

--
function mdlogin.setNewbieagainFalse(serverID, NewbieagainFalse)
    mdlogin.account = mdlogin.account or {}
    mdlogin.account[serverID] = mdlogin.account[serverID] or {}
    mdlogin.account[serverID].NewbieagainFalse = NewbieagainFalse
    mdlogin.save()
end

return mdlogin