cc.exports.mdt = mdt or {}

function mdt.init()
    mdt.x = 0
    mdt.y = 0
    mdt.login = {}
    mdt.player = {}
    mdt.player.info = {}
    mdt.players = {}
    mdt.world = {}
    mdt.map = {}
    mdt.point = {}
    mdt.pointInfo = {}
    mdt.challenge = {}
    mdt.effect = {}
    mdt.theme = 0
    mdt.w=0
    mdt.h=0
    mdt.msgboard = {}
    mdt.click_list = {}
end

mdt.ADS_COOLDOWN_ID = 
{
    ["BUY_LIFE"] = 1,
    ["CHALLENGE"] = 2,
    ["SUPPOT"] = 3,
    ["TREASURE"] = 4,
    ["BOX"] = 5,
}

--ȡùidӦɹidȴ
function mdt.getCooldownTimeByID(cid)
    if mdt.adCooldown then
        local special = {}
        for _, v in ipairs(mdt.adCooldown) do
            if v.CoolDownID == cid then
                table.insert(special, v)
            end
        end

        table.sort(special, function(a, b)
            if a.ADID < b.ADID then
                return true
            end
        end)

        local minTime = 999999999
        for _, v in pairs(special) do
            if v.CoolDownTime < minTime and v.CoolDownTime ~= 0 then
                minTime = v.CoolDownTime
            end
        end

        return special, minTime

    end
end

function mdt.setCursor(nGUID, x, y, cursorIdx)
    if not x or not y then return end
    local PY = mdt.pointInfo[y]
    if not PY then
        PY = {}
        mdt.pointInfo[y] = PY
    end
    local PXY = PY[x]
    if PXY then
        PXY.cursor = nGUID
    else
        PY[x] = { cursor=nGUID, cursorIdx=cursorIdx }
    end
end

function mdt.setFlagset(flagset, x, y)
    if not x or not y then return end
    local PY = mdt.pointInfo[y]
    if not PY then
        PY = {}
        mdt.pointInfo[y] = PY
    end
    local PXY = PY[x]
    if PXY then
        PXY.flagset = flagset
    else
        PY[x] = { flagset=flagset }
    end
end

function mdt.setChallenge(x, y, isOpen, pointType,pointId)
    local v = mdt.challenge[y]
    if not v then 
        v = {}
        mdt.challenge[y] = v
    end
    local info = v[x]
    if not info then
        info = { open = isOpen, pointType = pointType, x=x, y=y ,pointId=pointId}
        v[x] = info
    else
        info.open = isOpen
        if pointType then
            info.pointType = pointType
        end
    end
    if mdt.challengepos == nil then
        mdt.challengepos = {}
    end
    mdt.challengepos[y] = {x=x,y=y,open=isOpen,pointType=pointType,pointId=pointId}   
end

function mdt.getChallenge(x, y)
    local v = mdt.challenge[y]
    if v then
        return v[x]
    end
    return nil
end

function mdt.iterChallenge(pointType)
    local function iter()
        for y, vy in pairs(mdt.challenge) do
            for x, v in pairs(vy) do
                if v.pointType==pointType then
                    coroutine.yield(v)
                end
            end
        end
    end

    local co = coroutine.create(iter)
    return function()
        local code, res = coroutine.resume(co)
        return res
    end
end

return mdt