require('json')
require('app.util.zbase')
cc.exports.http={}

--local function parserData(data, cb)
--    local v = data and json.decode('{ "body":'..ZZBase64.decode(data)..'}') or nil
--    if cb then cb(v) end
--end
local function Init()
    local init = require('app.net.http.init')
    init.init()
end

function http.doPost(URL, data, cb)
    local xhr = cc.XMLHttpRequest:new()
    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
    xhr:open("POST", URL)

    local function onReadyStateChanged()
        local response = xhr.response
        xhr:unregisterScriptHandler()
        if xhr.readyState == 4 and (xhr.status >= 200 and xhr.status < 207) then
            if cb then cb(response) end
        else
            if cb then cb(nil) end
            print("xhr.readyState is:", xhr.readyState, "xhr.status is: ",xhr.status)
        end
        
    end

    xhr:setRequestHeader("content-type", "text/html")
    xhr:registerScriptHandler(onReadyStateChanged)
    xhr:send(data)
end

function http.doGet(URL, data, cb)
    local xhr = cc.XMLHttpRequest:new()
    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
    xhr:open("GET", URL)

    local function onReadyStateChanged()
        local response = xhr.response
        xhr:unregisterScriptHandler()
        if xhr.readyState == 4 and (xhr.status >= 200 and xhr.status < 207) then
            if cb then cb(response) end
        else
            if cb then cb(nil) end
            print("xhr.readyState is:", xhr.readyState, "xhr.status is: ",xhr.status)
        end
        
    end

    xhr:setRequestHeader("content-type", "text/html")
    xhr:registerScriptHandler(onReadyStateChanged)
    xhr:send(data)
end

function http.download(URL, filename, cb)
    http.doGet(URL, nil, function(data)
        print(URL)
        if data and filename and filename~='' then
            io.writefile(filename, data, 'wb')
        end
        if cb then cb(data) end
    end)
end

Init()

return http