local account = {}
http.account = account
local picList = {}
local flagList = {}
local dir = cc.FileUtils:getInstance():getWritablePath()..'download/upload/'
local curDownloadUrlTemplate = "http://%s/MineShareServer/uploadHead/%s.png"
local curDownloadFlagUrlTemplate = "http://%s/MineShareServer/uploadFlag/%s.png"
local curUploadUrlTemplate = "http://%s/MineShareServer/upload?picType=%s&picName=%s"

local curDownloadUrl = ""
local curDownloadFlagUrl = ""
local curUploadUrl = ""

local function Init()
    cc.FileUtils:getInstance():createDirectory(dir)
    if io.exists(dir..'iconlist.json') then
        local str = io.readfile(dir..'iconlist.json')
        picList = json.decode(str)
        dump(picList)
    else

        picList = {}
    end
    if io.exists(dir..'flaglist.json') then
        local str = io.readfile(dir..'flaglist.json')
        flagList = json.decode(str)
    else
        flagList = {}
    end
end

function account.asyncDownloadPlatformIcon(url, guid)
    return async.bindCall(http.download, url, '', async.callback)
end

function account.asyncUpload(picName, filedata,picType)
    -- local url = mdt.login.shareURL..'upload?guid='..guid:getHexStr()
    local url = string.format(curUploadUrl,picType,picName)
    print("【上传地址】:",url)
    local response = async.bindCall(http.doPost, url, filedata, async.callback)
    local ret = nil
    if response then
        local ok, status = pcall(function() 
                ret = json.decode(response)
            end,
            function()
                
            end
        )
    end
    return ret
end

function account.saveIcon(guid, filename, filedata)
    -- io.writefile(dir..filename, filedata)
    local info = picList[guid:getHexStr()]
    if info then
        if io.exists(dir..info.file) then
            cc.FileUtils:getInstance():removeFile(dir..info.file)
        end
        info.file = filename
    else
        picList[guid:getHexStr()] = { file=filename }
    end
    io.writefile(dir..filename, filedata)
    io.writefile(dir..'iconlist.json', json.encode(picList))
end

function account.saveFlag(guid, filename, filedata)
    local info = flagList[guid:getHexStr()]
    if info then
        if io.exists(dir..info.file) then
            cc.FileUtils:getInstance():removeFile(dir..info.file)
        end
        info.file = filename
    else
        flagList[guid:getHexStr()] = { file=filename }
    end
    io.writefile(dir..filename, filedata)
    io.writefile(dir..'flaglist.json', json.encode(flagList))
end

function account.asyncGetIconName(guid, file)
    if file==nil or file=='' or tonumber(file) ==0 then return 'Image/guest.png' end
    local info = picList[guid:getHexStr()]
    dump(info)
    if info and info.file==file then
        return dir..info.file
    end
    --local url = mdt.login.shareURL..'upload/'..file
    local url = string.format(curDownloadUrl,file)
    local filedata = async.bindCall(http.download, url, '', async.callback)
    if filedata then
        account.saveIcon(guid, file, filedata)
        return dir..file
    end
    return nil
end

function account.asyncGetFlagName(guid, file)
    if file==nil or file=='' or tonumber(file) ==0 then return 'Image/country/DEFAULT.png' end
    local info = flagList[guid:getHexStr()]
    if info and info.file==file then
        return dir..info.file
    end
    local url = string.format(curDownloadFlagUrl,file)
    local filedata = async.bindCall(http.download, url, '', async.callback)
    if filedata then
        account.saveFlag(guid, file, filedata)
        return dir..file
    end
    return nil
end

function account.resetDownloadInfo(serverID)
    curDownloadUrl = static.SERVER_LIST[serverID].adr
    if static.SERVER_LIST[serverID].downloadURL then
        curDownloadUrl = static.SERVER_LIST[serverID].downloadURL
    end
    curDownloadUrl = string.format(curDownloadUrlTemplate,curDownloadUrl,"%s")

    curDownloadFlagUrl = static.SERVER_LIST[serverID].adr
    if static.SERVER_LIST[serverID].downloadFlagURL then
        curDownloadFlagUrl = static.SERVER_LIST[serverID].downloadFlagURL
    end
    curDownloadFlagUrl = string.format(curDownloadFlagUrlTemplate,curDownloadFlagUrl,"%s")

    curUploadUrl = static.SERVER_LIST[serverID].adr
    if static.SERVER_LIST[serverID].uploadURL then
        curUploadUrl = static.SERVER_LIST[serverID].uploadURL
    end
    curUploadUrl = string.format(curUploadUrlTemplate,curUploadUrl,"%s","%s")
end

Init()