cc.exports.ndpnet={}
local net = ndpnet
net.enum = {}
net.enum.ECT_Login = 1
net.enum.ECT_Game = 2
net.eType = net.enum.ECT_Login
event.addEvent('ApplicationExit', function()
    if net.close then
        net.close()
    end
end, 1) 
local function Init()
    net.tag = {}
    local tagNetCmd = cc.load("ndp").tagNetCmd
    local netLS = cc.load("ndp").netInterface:create()
    local netGS = cc.load("ndp").netInterface:create()
    tagNetCmd.setTag(net.tag)
    tagNetCmd.setEnum(net.enum)
    tagNetCmd.setIgoreList({ [398092119]=1, [133037124]=1 })
    net.tagNetCmd = tagNetCmd
    net.send = function(...)
        if net.eType == 1 then
            netLS:send(...) 
        else
            netGS:send(...) 
        end
    end
    net.connect = function(...)
        if net.eType == 1 then
            netLS:connect(...) 
        else
            netGS:connect(...)
        end
    end

    net.getPingTime = function(...)
        return netLS:getPingTime(...)
    end

    net.listen = function(...)
        if net.eType == 1 then
            netLS:listen(...) 
        else
            netGS:listen(...)
        end
    end

    net.close = function()
        if net.eType == 1 then
            netLS:close()
        else
            netGS:close()
        end
    end

    net.isConnected = function(eType)
        if eType and eType== 1 then
            return netLS:isConnected()
        else
            return netGS:isConnected()
        end
    end

    net.wait = function(...)
        if net.eType == 1 then
            netLS:wait(...)
        else
            netGS:wait(...)
        end
    end

    net.msg = {}

    net.onConnect = nil

    require('app.net.ndp.NDPServer')

--    local init = require('app.net.ndp.init')
--    init.init()


    netLS:on('connect', function()
        print('LoginServer Connected')
        event.dispatch('onConnectLoginServer')
    end)
    netLS:on('recv', function(data)
        local name = data.__cname
        local handler = net.msg[name]
        if handler then
            handler(data)
        end
        event.dispatch(name, data)
    end)
    netLS:on('close', function()
        print('LoginServer Closed')
    end)
    netGS:on('connect', function()
        print('GameServer Connected')
        event.dispatch('onConnectGameServer')
    end)
    netGS:on('recv', function(data)
        local name = data.__cname
        local handler = net.msg[name]
        if handler then
            handler(data)
        end
        event.dispatch(name, data)
    end)
    netGS:on('close', function()
        if not mdt.isInGame then
            return
        end
        print('NDP Net Closed')

        if mdt.isReconnet or util.isShowDialog('Common.DisconnectDialog') then
            return
        end

        util.delay(1.5, function()
        if mdt.disconnectTime then
            util.unschedule(mdt.disconnectTime)
        end
        print('NDP Net Closed to reconnect')
            ctr.login.reconnect()
        end)
    end)

end

function net.setType(type)
    net.eType = type
end

function net.GetInitFiles()
    local init = require('app.net.ndp.init')
    return init.init()
end

Init()

return net