cc.exports.ndpserver={}
local net = ndpserver
net.enum = {}
net.enum.ECT_Login = 1
net.enum.ECT_Game = 2
net.eType = net.enum.ECT_Login
event.addEvent('ApplicationExit', function()
    if net.close then
        net.close()
    end
end, 1) 
local function Init()
    net.tag = ndpnet.tag
    local tagNetCmd = cc.load("ndp").tagNetCmd
    local netLS = cc.load("ndp").netInterface:create()
    local netGS = cc.load("ndp").netInterface:create()
--    tagNetCmd.setTag(net.tag)
--    tagNetCmd.setEnum(net.enum)
--    tagNetCmd.setIgoreList({ [398092119]=1, [133037124]=1 })
    net.tagNetCmd = ndpnet.tagNetCmd
    net.send = function(client, ...)
        if net.eType == 1 then
            netLS:sendTo(client, ...) 
        else
            netGS:sendTo(client, ...) 
        end
    end

    net.sendAll = function(ns, cb)
        for _,client in pairs(net.getClientList()) do
            if cb then
                cb(client, ns)
            end
            net.send(client, ns)
        end
    end

    net.connect = function(...)
        if net.eType == 1 then
            netLS:connect(...) 
        else
            netGS:connect(...)
        end
    end

    net.listen = function(...)
        if net.eType == 1 then
            netLS:listen(...) 
        else
            netGS:listen(...)
        end
    end

    net.close = function()
        if net.eType == 1 then
            netLS:close()
        else
            netGS:close()
        end
    end

    net.isConnected = function(eType)
        if eType and eType== 1 then
            return netLS:isConnected()
        else
            return netGS:isConnected()
        end
    end

    net.msg = {}

    net.onConnect = nil

--    local init = require('app.net.ndp.init')
--    init.init()
    netLS:on('connect', function()
        print('LoginServer Connected')
        event.dispatch('onConnectLoginServer')
    end)
    netLS:on('recv', function(data, client)
        local name = data.__cname
        local handler = net.msg[name]
        if handler then
            handler(client, data)
        end
        event.dispatch(name, data)
    end)
    netLS:on('close', function()
        print('LoginServer Closed')
    end)
    netGS:on('connect', function()
        print('GameServer Connected')
        event.dispatch('onConnectGameServer')
    end)
    netGS:on('recv', function(data, client)
        local name = data.__cname
        local handler = net.msg[name]
        if handler then
            handler(client, data)
        end
        event.dispatch(name, data)
    end)
    netGS:on('close', function()
        print('NDP SERVER GameServer Closed')
    end)

    net.getClientList = function()
        if net.eType == 1 then
            return netLS.client
        else
            return netGS.client
        end
    end
end



function net.setType(type)
    net.eType = type
end

Init()

return net