cc.exports.event = {}
local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
local dispatchList = {}

function event.addNodeEvent(eventname, listenerCallback, node)
	local listener = cc.EventListenerCustom:create(eventname,listenerCallback)
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener, node)
    return listener
end

function event.addEvent(eventname, listenerCallback, priority)
	local listener = cc.EventListenerCustom:create(eventname,listenerCallback)
    eventDispatcher:addEventListenerWithFixedPriority(listener, priority or 1)
    return listener
end

function event.remove(listener)
	eventDispatcher:removeEventListener(listener)
end

function event.dispatch(eventname, usedata)
	local event = cc.EventCustom:new(eventname)
    event._usedata = usedata
    eventDispatcher:dispatchEvent(event)
    -- event:stopPropagation() to stop current dispatch
end

function event.get(dispatchName)
    local dispatch = dispatchList[dispatchList]
    if dispatch then
        return dispatch
    end

    dispatch = cc.load('event').new()
    dispatch:bind(event)
    dispatchList[dispatchList] = dispatch
    return dispatch
end

return event