local http = class("http")
	
	http["uploadUrl"] = "http://10.21.1.7/minesweeper/uploadImage.php"
	--[[设置上传地址]]
	function http:setUploadUrl(uploadUrl)
		if type(uploadUrl) == "string" then
			self.uploadUrl = uploadUrl
		end
		return self
	end
	--[[获取上传地址]]
	function http:getUploadUrl()
		return self.uploadUrl
	end
	--[[发起Http-Get请求，获取图片]]
	function http:downloadImage(imageUrl,callback,extraData)
		print("请求下载图片:",imageUrl)
	    local xhr = cc.XMLHttpRequest:new()
	    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_ARRAY_BUFFER
	    xhr:open("GET",imageUrl)
	    local function onReadyStateChange()
	        local statusString = "Http Status Code:"..xhr.statusText
	        print(string.format("[get:status]:%s",statusString))
	        print(string.format("[get:response]:%s",xhr.response))
	        if type(callback) == "function" then
	        	local curImageName = string.format("net%s.png",tostring(os.time()))
	        	for key in string.gmatch(imageUrl,".*/(%d+%.png)") do
		            curImageName = key
		        end
		        if type(callback) == "function" then
		        	local isSuccess = false
		        	if self:generateImageInDefaultPath(curImageName,xhr.response) then
		        		isSuccess = (string.find(xhr.statusText,"200") and true or false)
	        		end
        			callback(--[[xhr.statusText,]]isSuccess,curImageName,extraData)
        		end
	        end
	    end
	    xhr:registerScriptHandler(onReadyStateChange)-- 注册脚本回调方法
	    xhr:send() 
	end
	function http:uploadImage(imageName,callback,extraData)
		if type(imageName) == "string" and type(callback)=="function" then
			local imagePath = string.format("%s%s",device.writablePath,imageName)
			if cc.FileUtils:getInstance():isFileExist(imagePath) then
				local file = assert(io.open(imagePath,"rb"))
				local byte = file:read("*a")
				if string.len(byte) > 0 then
					self:doUploadImage(byte,callback,extraData)
				end
				file:close()
			end
		end
	end
	--[[发起Http-Post请求，上传图片]]
	function http:doUploadImage(imageByteInfo,callback,extraData)
		local xhr = cc.XMLHttpRequest:new()
	    xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING 
	    xhr:open("POST",self.uploadUrl)
	    local function onReadyStateChange()
	        local statusString = "【Http Status Code】:"..xhr.statusText
	        print(string.format("【post:status】:%s",statusString))
	        print(string.format("【post:imageByteInfo】:%s",imageByteInfo))
	        print(string.format("【post:response】:%s",xhr.response))
	        if type(callback) == "function" then
	        	local isSuccess = (string.find(xhr.statusText,"200") and true or false)
	            callback(isSuccess--[[xhr.statusText]],xhr.response,extraData)
	        end
	    end
	    xhr:registerScriptHandler(onReadyStateChange)-- 注册脚本回调方法
	    xhr:send(imageByteInfo) -- 发送Post请求,注意paramStr的构造
	end
	--[[发起Http-Get请求]]
	function http:get(url,callback,extraId)
		--TODO
	end
	--[[发起Http-Post请求]]
	function http:post(flag,url,paramStr,callback,extraData)
	    -- local xhr = cc.XMLHttpRequest:new()
	    -- xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_JSON 
	    -- xhr:open("POST",url)
	    -- local function onReadyStateChange()
	    --     local statusString = "【Http Status Code】:"..xhr.statusText
	    --     print(string.format("【post:status】:%s",statusString))
	    --     print(string.format("【post:param】:%s",paramStr))
	    --     print(string.format("【post:response】:%s",xhr.response))
	    --     local response=xhr.response
	    --     if xhr.response then
	    --     	response=ZZBase64.decode(xhr.response)
	    --     	dump(response)
	    --     end
	    --     if type(callback)=="function" and type(flag)=="string" then
	    --     	local isSuccess=(string.find(xhr.statusText,"200") and true or false)
	    --         callback(flag,isSuccess--[[xhr.statusText]],response,extraData)
	    --     end
	    -- end
	    -- print(string.format("【发起post请求】:%s%s",url,paramStr))
	    -- xhr:registerScriptHandler(onReadyStateChange)-- 注册脚本回调方法
	    -- xhr:send(paramStr) -- 发送Post请求,注意paramStr的构造
	end
	function http:generateImageInDefaultPath(imageName,byteTable)
		local result = false
		if type(imageName) == "string" and type(byteTable) == "table" then
			local imageInfo = ""
			local imagePath = string.format("%s%s",device.writablePath,imageName)
			local file = assert(io.open(imagePath,"wb"))
			local size = table.nums(byteTable)
			if type(size) == "number" and size-1>0 then
			    for i = 1,size do
			        imageInfo = imageInfo..string.char(byteTable[i])
			    end
			    file:write(imageInfo)
			end
		    file:close()
		    print("【generateImage】",imageName,size)
		    result = cc.FileUtils:getInstance():isFileExist(imagePath)
		end
		return result
	end

cc.exports.http = http
return http