cc.exports.lang = lang or {}

function lang.get(txt)
    if type(txt)=='table' then
        return txt[mdr.settings.lang]
    end
    return txt
end

-- for UIText
cc.exports.Text_setString = Text_setString or ccui.Text.setString
local Text = ccui.Text
function Text:setString(txt)
    Text_setString(self, lang.get(txt))
end

cc.exports.Text_setFontName = Text_setFontName or ccui.Text.setFontName
local Text = ccui.Text
function Text:setFontName(fontname)
    if device.language == 'tha' then
        fontname = "Font/tha.TTF"
    elseif device.language == 'kr' then
        fontname = "Font/kor.TTF"
    elseif device.language == 'tw' then
        fontname = "Font/cht.TTF"
    elseif device.language == 'en' then
        fontname = "Font/en.TTF"
    elseif device.language == 'cn' then
        fontname = "Font/SIMHEI.TTF"
    else
        return
    end
    Text_setFontName(self, fontname)
end

-- for Button
cc.exports.Button_setTitleText = Button_setTitleText or ccui.Button.setTitleText
local Button = ccui.Button
function Button:setTitleText(txt)
    Button_setTitleText(self, lang.get(txt))
end

-- for debug
local langList = { 'cn', 'en', 'tn' }
function lang.prev()
    local i = table.indexof(langList, mdr.settings.lang)
    i = i - 1
    i = i>0 and i or i+#langList
    mdr.setLanguage(langList[i])
end

function lang.next()
    local i = table.indexof(langList, mdr.settings.lang)
    i = i + 1
    i = i<=#langList and i or 1
    mdr.setLanguage(langList[i])
end

return lang