local BoxView = class("BoxView", cc.load("mvc").LayoutBase)
BoxView.RESOURCE_FILENAME = "Box.BoxView"

function BoxView:onCreate()
    self:addEvent('NS_LoadBox')
    self:addEvent('NS_OpenBox')
    util.scheduleNode(1, function()
        if self.box ~= nil then
            if #self.box > 0 then
                self:CountDown()
            end
        end
    end, self)
    self.time = {}
    self.getbox = {}
end

function BoxView:onEnter()
    self.ui.Time1:setString(static.language[30198][device.language])
    self.ui.Time2:setString(static.language[30198][device.language])
    self.ui.Time3:setString(static.language[30198][device.language])
    self.ui.Time4:setString(static.language[30198][device.language])
    net.msg.NC_LoadBox()
    self.ui.Box1:setVisible(false)
    self.ui.Box2:setVisible(false)
    self.ui.Box3:setVisible(false)
    self.ui.Box4:setVisible(false)
    self.ui.GetImage1:setVisible(true)
    self.ui.GetImage2:setVisible(true)
    self.ui.GetImage3:setVisible(true)
    self.ui.GetImage4:setVisible(true)
--    self.ui.GetImage1:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
--    self.ui.GetImage2:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
--    self.ui.GetImage3:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
--    self.ui.GetImage4:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)

    self.adCoolDown = {}
end

function BoxView:NS_LoadBox(ev,ns)
    self.box = {}
    for k , v in pairs(ns.sBox) do
        self.box[v.nSlot_ID] = v
    end
    for i=1,#self.box do
        self.time[i]=self.box[i].nBox_CD
        if self.box[i].nBox_ID ~= 0 then
            self:TimeDonw(i)
        end
    end
    self:setkey()

    self.adCoolDown = {} 
    table.insert(self.adCoolDown, ns.nCoolDownTime_4_1)
    table.insert(self.adCoolDown, ns.nCoolDownTime_4_2)
    table.insert(self.adCoolDown, ns.nCoolDownTime_4_3)
    table.insert(self.adCoolDown, ns.nCoolDownTime_4_4)
end

function BoxView:NS_OpenBox(ev,ns)
    if ns.nErrorCode == 0 then
        self.ui['Time'..self.openbox]:setString(static.language[30198][device.language])
        self.time[self.openbox] = nil
        self.box[self.openbox].nBox_ID = 0

        local key = mdt.BoxTime[self.openbox][3]
        if key then
            sdkManager.locojoybj:cancelNotify(key)
        end

        mdt.BoxTime[self.openbox][2]=-1
        self.ui['Box'..self.openbox]:setVisible(false)
        self.ui['GetImage'..self.openbox]:setVisible(true)
        self.ui['GetImage'..self.openbox]:loadTexture("Image/darkUI/chest_empty.png",0)
    end
end

function BoxView:CountDown()
    for i = 1,#self.box do
        if self.time[i] ~= nil and self.time[i]>0 then
            self.time[i] = self.time[i] - 1
            self:TimeDonw(i)
        elseif self.time[i] ~= nil and self.time[i] <= 0 then
            if self.box[i].nBox_ID ~= 0 then
                self.ui['Box'..i]:setVisible(true)
                self.ui['GetImage'..i]:setVisible(false)
                if self.getbox[i] ~= nil then
                    if self.getbox[i] == 1 then
                        self.ui['baoxiang'..i]:setTexture("Image/donghua/png/saolei/chest1_0.png")                   
                    elseif self.getbox[i] == 2 then
                        self.ui['baoxiang'..i]:setTexture("Image/donghua/png/saolei/chest2_0.png")
                    elseif self.getbox[i] == 3 then
                        self.ui['baoxiang'..i]:setTexture("Image/donghua/png/saolei/chest3_0.png")
                    else
                        self.ui['baoxiang'..i]:setTexture("Image/donghua/png/saolei/chest4_0.png")
                    end
                end
                self.ui['Time'..i]:setString('00:00:00')
            end
        end
    end
end

function BoxView:TimeDonw(i)
    local hour = math.floor(self.time[i]/3600)
    local min = math.floor((self.time[i] - hour*3600)/60)
    local sec = math.floor(self.time[i] - hour*3600 - min*60)
    local hourstr = ''
    if hour < 10 then
        hourstr = '0'..hour
    else
        hourstr = tostring(hour)
    end

    local minstr = ''
    if min < 10 then
        minstr = '0'..min
    else
        minstr = tostring(min)
    end

    local secstr = ''
    if sec < 10 then
        secstr = '0'..sec
    else
        secstr = tostring(sec)
    end
    self.ui['Time'..i]:setString(hourstr..':'..minstr..':'..secstr)
end

function BoxView:onExit()

end

function BoxView:setkey()
    for i = 1 , #self.box do
        if self.box[i].nBox_ID ~= 0 then
            if self.box[i].nBox_CD ~= 0 then
                self.ui['Box'..i]:setVisible(false)
                self.ui['GetImage'..i]:setVisible(true)
                local box = nil 
                for _,v in pairs(static.box) do
                    if tonumber(v.id) == self.box[i].nBox_ID then
                        box = v
                        self.getbox[i]=v.boxLevel
                        break
                    end
                end
                if box.boxLevel == 1 then
                    self.ui['GetImage'..i]:loadTexture("Image/donghua/png/saolei/chest1_0.png",0)
                elseif box.boxLevel == 2 then
                    self.ui['GetImage'..i]:loadTexture("Image/donghua/png/saolei/chest2_0.png",0)
                elseif box.boxLevel == 3 then
                    self.ui['GetImage'..i]:loadTexture("Image/donghua/png/saolei/chest3_0.png",0)
                else
                    self.ui['GetImage'..i]:loadTexture("Image/donghua/png/saolei/chest4_0.png",0)
                end
            else
                self.ui['Box'..i]:setVisible(true)
                self.ui['GetImage'..i]:setVisible(false)
                local box = nil 
                for _,v in pairs(static.box) do
                    if tonumber(v.id) == self.box[i].nBox_ID then
                        box = v
                        self.getbox[i]=v.boxLevel
                        break
                    end
                end
                if box.boxLevel == 1 then
                    self.ui['baoxiang'..i]:setTexture("Image/donghua/png/saolei/chest1_0.png")                   
                elseif box.boxLevel == 2 then
                    self.ui['baoxiang'..i]:setTexture("Image/donghua/png/saolei/chest2_0.png")
                elseif box.boxLevel == 3 then
                    self.ui['baoxiang'..i]:setTexture("Image/donghua/png/saolei/chest3_0.png")
                else
                    self.ui['baoxiang'..i]:setTexture("Image/donghua/png/saolei/chest4_0.png")
                end
            end
        end
    end
end

function BoxView:checkADToOpenBox(boxid, diamond)
    local adid = 0
    for k, v in pairs(self.adCoolDown) do
        if v == 0 then
            adid = k
            break
        end
    end

    if adid == 0 or not AdManager:isADAvailable(99) then --ûп
        net.msg.NC_OpenBox(boxid,diamond)
    else
        local view = util.showDialog('Dialog', 'Common.ADBoxDialog')
        view:setPageType(mdt.ADS_COOLDOWN_ID["BOX"], function () 
            mdt.curboxid = self.box[boxid].nBox_ID
            net.msg.NC_OpenBox(boxid,diamond, adid)
            end, function () 
            mdt.curboxid = self.box[boxid].nBox_ID
            net.msg.NC_OpenBox(boxid,diamond)
--                net.msg.NC_OpenBox(boxid,diamond, adid)
            end)

    end
end

-- Event for GetImage1 callback (addClickEventListener)
function BoxView:OpenBox(node, eventType, userdata)
    print("BoxView:OpenBox-----------------------")
    if self.box[tonumber(userdata)].nBox_ID ~= 0 then 
        if self.time[tonumber(userdata)] <= 0 then
            mdt.curboxid = self.box[tonumber(userdata)].nBox_ID
            self:checkADToOpenBox(tonumber(userdata), 0)
        else
            local cost = 0 
            for _,v in pairs(static.box) do
                if tonumber(v.id) == self.box[tonumber(userdata)].nBox_ID then
                    cost = v.boxOpenNum
                    break
                end
            end         
            local view = util.showDialog(nil, 'Common.ConfirmDialog')
            view:setkey(
            cost,
            function()
                if mdt.player.diamond < cost then
                    util.showDialog('Dialog3','Common.NotEnough'):setkey(3)
                else
                    mdt.curboxid = self.box[tonumber(userdata)].nBox_ID
                    self:checkADToOpenBox(tonumber(userdata), 1)
                end
            end ,
            3,30010)
        end
        self.openbox = tonumber(userdata)
    end
end

-- Event for BG callback (addClickEventListener)
function BoxView:onClose(node, eventType, userdata)
    util.closeDialog('Box.BoxView')
end

return BoxView
