local Cell = class("Cell", cc.load("mvc").LayoutBase)
Cell.RESOURCE_FILENAME = "Cell.Cell"

local inited = false
local imgCell = nil
local imgCell0 = nil
local imgCell1 = nil
local imgCell2 = nil
local imgFlagset = {}
local imgFlagnone = nil
local imgN = {}
local imgMine = nil
local imgCursor = {}
local imgMap = nil

local imgNumPath = ""

function Cell.Init()
    local path = 'Image/Theme'..mdt.theme..'/'
    imgCell = display.loadImage(path..'cell.png')
    imgCell2 = display.loadImage(path..'cell_light.png')
    imgCell0 = display.loadImage(path..'cell0.png')
    imgCell1 = display.loadImage(path..'cell1.png')
    imgFlagset[1] = display.loadImage(path..'flagset.png')
    for k, v in pairs(static.item) do
        if math.floor(static.item[k].id / 10000)==1 then
            local item = nil
            for k1,v1 in pairs(static.shop) do
                if static.shop[k1].itemCode == static.item[k].id then
                    item = static.shop[k1]
                end
            end
            if item.numID>0 then
                imgFlagset[static.item[k].id] = display.loadImage(static.item[k].imageId)
            end
        end
    end
    imgFlagnone = display.loadImage(path..'flagnone.png')
    imgMine = display.loadImage(path..'mine.png')
    for i=1,8 do
        imgN[i] = display.loadImage(path..i..'.png')
    end
    for i=0, 21 do
        local id = (i+1)*100 + 20001
        imgCursor[id] = display.loadImage('Image/cursor/'..i..'.png')
    end
    
--    dump(imgFlagset)
    inited = true

    imgNumPath = ""
end

function Cell.InitMapPic()

    if nil == mdt.mapID then
        mdt.mapID = mdr.mapID or 1
    end
    if imgMap then
        imgMap:release()
    end
    imgMap = cc.Image:new()
    imgMap:initWithImageFile('Image/map/'..mdt.mapID..'.png')
    imgMap:retain()

    print("map path ============="..'Image/map/'..mdt.mapID..'.png')
    if imgMap then
        print("MAP IS OK")
    else
        print("MAP IS ERROR")
    end
end

function Cell:onCreate()
--    if not inited then
--        Cell.Init()
--    end
    self:setSelect(false)

    
    self.imgBack = nil
    self.imgNum = nil
    self.cursor = false
    self.ui.num:setVisible(false)
    self.ui.cursor:setVisible(false)
    self:addEvent("onRefreshCustomFlag")
end

function Cell:onEnter()
--    self.ui.btn:setVisible(true)
--    self.ui.pic:setVisible(false)   
--    self.ui.num:setVisible(false)
end

function Cell:onExit()

end

function Cell:setLocation(x0, y0)
    self.x = x0
    self.y = y0

    local visible = true
    if x0<0 or y0<0 or x0>=mdt.w or y0>=mdt.h then
        visible=false
    end

    if visible~=self.visible then
        self.visible = visible
        self:setVisible(visible)
    end

    if not visible then
        return
    end
    self:setPosition(x0*mdt.CW, y0*mdt.CW)

    local p = mdt.point[self.y]
    local v = p and p[self.x]
    local pi = mdt.pointInfo[self.y]
    local vi = pi and pi[self.x]
    -- local info = mdt.pointPlayerInfo[self.y]

    v = v or -1
    local flagidx = 0
    if vi and vi.flagset then
        flagidx = vi.flagset
    end
    local imgBack = imgCell0
    local imgNum = nil
    -- map back color
    local map1Color = 0
    if mdt.w then
        local mapx = math.floor(self.x*static.MapWidth/mdt.w)
        local mapy = math.floor(self.y*static.MapHeight/mdt.h)
        local MPXY = imgMap:getPixel(mapx,static.MapHeight-mapy-1)
        for i=1,3 do
            local a = MPXY % 0x100 
            if a<230 then
                map1Color = 1
                break
            end
            MPXY = math.floor(MPXY / 0x100)
        end
        if map1Color>0 then
            imgBack = imgCell1
        end
    end
    if v==9 then
        if self.x%2 == 0 and self.y%2 == 1 or
           self.x%2 == 1 and self.y%2 == 0 then
            imgBack = imgCell
        else
            imgBack = imgCell2
        end
        if not mdt.isNewbie and mdt.mode==2 then
            imgNum = imgFlagnone
            imgNumPath = 'Image/Theme'..mdt.theme..'/'..'flagnone.png'
        end
        self.iscountry = false
    elseif v==10 then
        if self.x%2 == 0 and self.y%2 == 1 or
           self.x%2 == 1 and self.y%2 == 0 then
            imgBack = imgCell
        else
            imgBack = imgCell2
        end
        if flagidx > 40000 then
            self.curCustomFlag = flagidx
            local curFlag = ctr.player.downLoadFlag(flagidx,function(imageId,downLoadPath)
                local customFlagInfo ={}
                customFlagInfo.imageId = imageId
                customFlagInfo.downLoadPath = downLoadPath
                event.dispatch("onRefreshCustomFlag",customFlagInfo)
            end)
            --print("------------flagidx--->",flagidx,"ʼ!! ::",curFlag)
            if curFlag then
                --print("ѾͼƬ:",curFlag)
                imgNum = display.loadImage(curFlag)
                imgNumPath = curFlag
            end
        else
            if flagidx == 10101 then
                flagidx = 1
            end
            imgNum = imgFlagset[flagidx]  --ͨ
            imgNumPath = 'Image/Theme'..mdt.theme..'/'..'flagset.png'

        end
        self.iscountry = false
    elseif v==11 then
        imgBack = imgCell
        imgNum = imgMine
        imgNumPath = 'Image/Theme'..mdt.theme..'/'..'mine.png'
        self.iscountry = false
    elseif v>0 then
        imgNum = imgN[v]
        imgNumPath = 'Image/Theme'..mdt.theme..'/'..v..'.png'
        self.iscountry = false
    elseif v==0 then
        if not mdt.isChallenge and not mdt.isNewbie then
            if mdt.pointPlayerInfo[self.y][self.x].countryindex ~= 0 then
                local image = static.country[mdt.pointPlayerInfo[self.y][self.x].countryindex].nameID
                imgNum = display.loadImage('Image/country/'..image..'.png')
                self.iscountry = true
                imgNumPath = 'Image/country/'..image..'.png'

            end
        end
    end

    if imgBack~=self.imgBack then
        self.ui.Image_1:setTexture(imgBack)
        self.imgBack=imgBack
    end

    if self.iscountry then
        self.ui.Spine_1:setVisible(true)
    else
        self.ui.Spine_1:setVisible(false)
    end

    if imgNum~=self.imgNum then
        if imgNum then
            if self.imgNum==nil then
                self.ui.num:setVisible(true)
            end
            if tolua.isnull(imgNum) then
                print("imgNum null path is ".. imgNumPath )
                imgNum = display.loadImage(imgNumPath)
            end
            -- print(imgNumPath .. "-----------------")
            self.ui.num:setTexture(imgNum)
            if self.iscountry ~= nil and self.iscountry then

                self.ui.num:setOpacity(80)
            else
                self.ui.num:setOpacity(255)
            end
        else
            self.ui.num:setVisible(false)
        end
        self.imgNum = imgNum
    end

    -- cursor
    local cursor = nil

    if vi and vi.cursor then
        cursor = imgCursor[vi.cursorIdx]
    end
    if self.cursor~=cursor then
        if cursor then
            if tolua.isnull(cursor) then
                print("cursor null try reload ")
                cursor = display.loadImage('Image/cursor/'..vi.cursorIdx..'.png')
            end

            self.ui.cursor:setVisible(true)
            self.ui.cursor:setTexture(cursor)
        else
            self.ui.cursor:setVisible(false)
        end
        self.cursor=cursor
    end
end

function Cell:check()
    self:setLocation(self.x, self.y)
end

function Cell:setSelect(flag)
    --self.ui['select']:setVisible(flag)
end

function Cell:onRefreshCustomFlag(ev,ns)
    if type(ns) == "table" then
        if self.curCustomFlag == ns.imageId and ns.downLoadPath then
            if self.ui and self.ui.num then
                self.ui.num:setVisible(true)
                self.ui.num:setTexture(display.loadImage(ns.downLoadPath))
            end
        end
    end
end


return Cell

