local Challenge = class("Challenge", cc.load("mvc").LayoutBase)
Challenge.RESOURCE_FILENAME = "Challenge.Challenge"

local clickDelay = 0
function Challenge:onCreate()
    --self:addEvent('NS_LoadMap')
    --self:addEvent('NS_RectGridChange')
    self:addEvent('NS_ChallengeGridStateChange')
    self:addEvent('NS_ChallengeClickGrid')
    self:addEvent('NS_ChallengeFlagGrid')
    self:addEvent('NS_ChallengeComplete')
    self:addEvent('ChallengeOver')

    --self:addEvent('onMapGo')
    self:addEvent('onThemeChanged')
    self:addEvent('onRefreshCell')
    self:addEvent('onPlayBoom')
    if util.isShowDialog('Common.Waiting') then util.closeDialog('Common.Waiting') end
    mdt.isChallenge = true
    ctr.game.init(self.ui.Inner)
    if mdt.chainfo == nil then
        util.showDialog('Dialog', 'Challenge.Ready')
    end  
    mdt.isclickchallenge = true 
end

function Challenge:onEnter()
    ctr.game.createCell()

    
    util.delay(0, function()
        ctr.game.refreshCell()
        ctr.game.LoadMap()    
    end)
    self.isComplete = false
    self.isplay = false
    self.IsBoom = false
end

function Challenge:onExit()

end

function Challenge:onThemeChanged()
    require('app.views.Cell.Cell').Init()
    ctr.game.refreshCell()
end

function Challenge:onRefreshCell()
    ctr.game.refreshCell()
end
--function Challenge:NS_RectGridChange(ev, ns)
--    ctr.game.refreshCell()
--    ctr.game.refreshEffect()
--end

function Challenge:NS_ChallengeGridStateChange(ev, ns)
    for _,v in pairs(ns.byData) do
        if v.nState == 11 then
            self.myposX = v.nPosX
            self.myposY = v.nPosY
            self.IsBoom = true
        end
    end
    if not self.IsBoom then
        event.dispatch('ChangeChallengeFace',2)
    end
    ctr.game.refreshCell()
    ctr.game.refreshEffect()
end

function Challenge:NS_ChallengeClickGrid(ev, ns)
    local x = ns.nPosX
    local y = ns.nPosY
    self.x = ns.nPosX
    self.y = ns.nPosY
    self.myposX = ns.nPosX
    self.myposY = ns.nPosY
    local nErr = ns.nErrorCode
    ctr.game.clickGrid(x,y,nErr, ns.nGUID)
end

function Challenge:NS_ChallengeFlagGrid(ev, ns)
    local x = ns.nPosX
    local y = ns.nPosY
    self.x = ns.nPosX
    self.y = ns.nPosY
    self.myposX = ns.nPosX
    self.myposY = ns.nPosY
    local nErr = ns.nErrorCode
    ctr.game.flagGrid(x,y,nErr, ns.nGUID)
end

function Challenge:NS_ChallengeComplete(ev, ns)
    self.Challengeresult = ns
    if ns.nReliveDiamond == 0 then
        if ns.nCompleteType == 1 and ns.nUserTime < 600 then
            if not self.isplay then
                event.dispatch('onShake')
                audio.playEffect('boom')
                self:onPlayBoom()
                self.isplay = true
            end
        end
        if ns.nCompleteType == 1 then
            if mdr.ChallengeFail == nil then
                mdr.ChallengeFail = false
                mdr.save()
            end
            if not mdr.ChallengeFail then
                sdkManager.talkingdata:setEvent("45",{BigFailNum = "BigFailNum"})
                sdkManager.appsflyer:setEvent("45",{BigFailNum = "BigFailNum"})
                mdr.ChallengeFail = true
                mdr.save()
            end
            sdkManager.talkingdata:setEvent("41",{BigFail = "BigFail"})
            sdkManager.appsflyer:setEvent("41",{BigFail = "BigFail"})
            util.delay(1,function()
                if ns.nReliveDiamond == 0 then
                    if not self.isComplete then
                        local view = util.showDialog('Dialog', 'Challenge.Complete')
                        view:setData(ns)
                        self.isComplete = true
                    end
                end
            end)
        else
            if mdr.ChallengeSuccess == nil then
                mdr.ChallengeSuccess = false
                mdr.save()
            end
            if not mdr.ChallengeSuccess then
                sdkManager.talkingdata:setEvent("44",{BigWinNum = "BigWinNum"})
                sdkManager.appsflyer:setEvent("44",{BigWinNum = "BigWinNum"})
                mdr.ChallengeSuccess = true
                mdr.save()
            end
            sdkManager.talkingdata:setEvent("40",{BigWin = "BigWin"})
            sdkManager.appsflyer:setEvent("40",{BigWin = "BigWin"})
            local view = util.showDialog('Dialog', 'Challenge.Complete')
            view:setData(ns)
        end
    end
end

function Challenge:ChallengeOver()
    local view = util.showDialog('Dialog', 'Challenge.Complete')
    view:setData(self.Challengeresult)
end

function Challenge:onPlayBoom()
    local effect = self:getApp():createView('spine.Baozha')
    effect:setPosition({x=self.myposX*120 + 60,y=self.myposY*120 + 60})
    ctr.game.Inner:addChild(effect)
    event.dispatch('ChangeChallengeFace',1)
end

-- Event for GameView callback (addTouchEventListener)
function Challenge:onTouch(node, eventType, userdata)
    local function click(bp, ep, mode)
        if self.bClicked then return end

--        if self.clickClock then
--            if os.clock()-self.clickClock<clickDelay then return end
--        end

--        self.clickClock = os.clock()

        mode = mode or 1
        self.bClicked = true

        ctr.game.click(bp, ep, mode)
    end

    if eventType == 0 then
        self.beganPos = node:getTouchBeganPosition()
        self.lastTouchPos = self.beganPos
        self.bMove = false
        self.bClicked = false
        self.doubleAct = util.delay(0.3, function() 
            if self.bMove then return end
            click(self.beganPos, self.lastTouchPos, 2)
        end, self)
    elseif eventType==1 then
        local mp = node:getTouchMovePosition()
        local dis = cc.pGetDistance(self.beganPos, mp)
        if dis>50 then
            self.bMove = true
        end
        local dp = cc.pSub(mp, self.lastTouchPos)
        local size = self.ui.GameView:getContentSize()
        ctr.game.moveMap(dp.x, dp.y, size)
        self.lastTouchPos = mp

    elseif eventType==2 then
        if not self.bMove then
            local ep = node:getTouchEndPosition()
            click(self.beganPos, ep)
        end
        util.unschedule(self.doubleAct)
    else
        util.unschedule(self.doubleAct)
    end
end


return Challenge
