local ADBoxDialog = class("ADBoxDialog", cc.load("mvc").LayoutBase)
ADBoxDialog.RESOURCE_FILENAME = "Common.ADBoxDialog"

function ADBoxDialog:onCreate()

    self:addEvent('NS_RequestAllCoolDownItem')
end

function ADBoxDialog:onEnter()
	print("enter ADBoxDialog")

    self.isShowADCoolDN = false
    self.refreshAdTime = false

    self.ui.OK:onEnabled(false)
    self.ui.time:setVisible(false)

--    self.ui.OK:onSetText(static.language[30171][device.language])
    self.ui.OK.ui.btnText:onAD()
    self.ui.Cancel:onSetText(static.language[10002][device.language])

end

function ADBoxDialog:setPageType(PID, boxCallback, dropCallback)
    self.pageID = PID
    self.boxCallback = boxCallback
    self.dropCallback = dropCallback
    print("PID = " .. PID)

    if self.pageID == mdt.ADS_COOLDOWN_ID.SUPPOT then
        self.ui.Buy:setString(static.language[30188][device.language])
    elseif self.pageID == mdt.ADS_COOLDOWN_ID.TREASURE then
        self.ui.Buy:setString(static.language[30189][device.language])
    elseif self.pageID == mdt.ADS_COOLDOWN_ID.BOX then
        self.ui.Buy:setString(static.language[30189][device.language])
    end

    if self.pageID == mdt.ADS_COOLDOWN_ID.SUPPOT then
        if not AdManager:isADAvailable(99) then
            print("no ad available")
            self.ui.OK:onEnabled(false)
            return
        end

        net.msg.NC_RequestAllCoolDownItem()
        util.scheduleNode(1, function()
            self:refreshTM() 
        end, self)
    elseif self.pageID == mdt.ADS_COOLDOWN_ID.TREASURE or self.pageID == mdt.ADS_COOLDOWN_ID.BOX then
        self.ui.OK:onEnabled(true)
    end

end

function ADBoxDialog:NS_RequestAllCoolDownItem(env,ns)
 	print("NS_RequestAllCoolDownItem")
    if self.pageID ~= mdt.ADS_COOLDOWN_ID.SUPPOT then
        return
    end

    dump(ns)

    local cdtimes, minTime = mdt.getCooldownTimeByID(self.pageID)

    local avilable = false

    if cdtimes then
        for _, v in ipairs(cdtimes) do
            if v.CoolDownTime == 0 and AdManager:isADAvailable(v.ADID) then
                self.toPlayAdID = v.ADID
                avilable = true
                break
            end
        end
    end

    if avilable then
        self.isShowADCoolDN = false
        self.ui.time:setVisible(false)
        mdt.adCooldowntime = 0
        self.ui.OK:onEnabled(true)
    else
        mdt.adCooldowntime = minTime
        self.isShowADCoolDN = true
        self:refreshADCooldown()
        self.ui.time:setVisible(true) 
    end


end

function ADBoxDialog:refreshTM()
    if self.pageID ~= mdt.ADS_COOLDOWN_ID.SUPPOT then
        return
    end

    if self.isShowADCoolDN and mdt.adCooldowntime and mdt.adCooldowntime >= 0 then
        self:refreshADCooldown()
    end
end

function ADBoxDialog:refreshADCooldown()
    if mdt.adCooldowntime == 0 then
        net.msg.NC_RequestAllCoolDownItem()

        self.isShowADCoolDN = false
--        self.ui.time:setVisible(false)
--        mdt.adCooldowntime = 0
--        self.ui.OK:onEnabled(true)
    else
        local hour = math.fmod(math.floor(mdt.adCooldowntime / 3600), 24)
        local min = math.fmod(math.floor(mdt.adCooldowntime / 60), 60)
        local sec = math.floor(math.fmod(mdt.adCooldowntime, 60))

        local tStr = string.format("%02d:%02d:%02d", hour, min, sec)

        self.ui.time:setString(tStr)
    end
end

function ADBoxDialog:onExit()

end

-- Event for Panel_start callback (addClickEventListener)
function ADBoxDialog:onOK(node, eventType, userdata)
    if self.pageID == mdt.ADS_COOLDOWN_ID.TREASURE then
        net.msg.NC_UpdateCoolDownTime(self.pageID or 4, 1, 0)
    elseif self.pageID == mdt.ADS_COOLDOWN_ID.BOX then
        if self.dropCallback then
            self.dropCallback()
        end
    end

    util.closeDialog('Common.ADBoxDialog')
end

-- Event for Panel_start_0 callback (addClickEventListener)
function ADBoxDialog:onOK2(node, eventType, userdata)
    if self.pageID == mdt.ADS_COOLDOWN_ID.SUPPOT then

        if self.toPlayAdID and AdManager:isADAvailable(self.toPlayAdID) then
            AdManager:playAds(self.toPlayAdID, function ()
                print("watch ad open box")
                net.msg.NC_UpdateCoolDownTime(self.pageID or 3, 1, self.toPlayAdID)

                if util.isShowDialog('Common.Waiting') then util.closeDialog('Common.Waiting') end

                audio.resumeMusic()

                sdkManager.talkingdata:setEvent("70",{BigFailNum = "Support"})
                sdkManager.appsflyer:setEvent("70",{BigFailNum = "Support"})
                util.closeDialog('Common.ADBoxDialog')
            end
            )
        end
    elseif self.pageID == mdt.ADS_COOLDOWN_ID.TREASURE then

        if AdManager:isADAvailable(99) then
            AdManager:playAds(99, function ()
                print("watch ad open box")
                net.msg.NC_UpdateCoolDownTime(self.pageID or 4, 2, 1)

                if util.isShowDialog('Common.Waiting') then util.closeDialog('Common.Waiting') end

                audio.resumeMusic()

                util.closeDialog('Common.ADBoxDialog')
            end
            )
        end
    elseif self.pageID == mdt.ADS_COOLDOWN_ID.BOX then
        if AdManager:isADAvailable(99) then
            AdManager:playAds(99, function ()

                if self.boxCallback then
                    self.boxCallback()
                end

                if util.isShowDialog('Common.Waiting') then util.closeDialog('Common.Waiting') end

                audio.resumeMusic()
                sdkManager.talkingdata:setEvent("71",{Double = "Double"})
                sdkManager.appsflyer:setEvent("71",{Double = "Double"})

                util.closeDialog('Common.ADBoxDialog')
            end
            )
        end
    end

end

return ADBoxDialog
