local BuyLife = class("BuyLife", cc.load("mvc").LayoutBase)
BuyLife.RESOURCE_FILENAME = "Common.BuyLife"


function BuyLife:onCreate()
    self:addEvent("NS_ShareAddLife")
    self:addEvent('NS_RequestAllCoolDownItem')


    util.scheduleNode(1, function()
        self:refreshTM()
    end, self)
end

function BuyLife:NS_RequestAllCoolDownItem(env,ns)

    local cdtimes, minTime = mdt.getCooldownTimeByID(mdt.ADS_COOLDOWN_ID["BUY_LIFE"])

    local avilable = false

    if cdtimes then
        for _, v in ipairs(cdtimes) do
            if v.CoolDownTime == 0 and AdManager:isADAvailable(v.ADID) then
                self.toPlayAdID = v.ADID
                avilable = true
                break
            end
        end
    end

    if avilable then
        self.isShowADCoolDN = false
        self.ui.time:setVisible(false)
        mdt.adCooldowntime = 0
        self.ui.Cancel:onEnabled(true)
    else
        mdt.adCooldowntime = minTime
        self.isShowADCoolDN = true
        self:refreshADCooldown()
--        self.ui.time:setVisible(true) 
    end
end

function BuyLife:onEnter()
    self.curData = os.date("%Y%m%d")
    if nil ==  mdr.BuyLife then
       mdr.BuyLife = {}
    end
    if nil == mdr.BuyLife[self.curData] then
        mdr.BuyLife[self.curData] = 2
		mdr.save()
    end
    self:refreshTM()
    self.ui.Text_4:setString(mdr.BuyLife[self.curData])
    self.ui.Text_1:setString(static.language[30009][device.language])
    self.ui.OK.ui.btnText:onSetBuyLife(mdt.nextcost)
    self.ui.ShareTxt:setString(static.language[20008][device.language])
    self.ui.Text_2:setString(static.language[30085][device.language])
--    self.ui.Cancel:onSetText(static.language[30171][device.language])

    self.ui.Cancel.ui.btnText:onAD()
    self.ui.Text_3:setString(static.language[30162][device.language])

    self.ui.txtCoin:setString(mdt.player.gold)

    self.ui.Cancel:onEnabled(false)
    self.ui.time:setVisible(false)
    net.msg.NC_RequestAllCoolDownItem()

    if mdt.adReward and mdt.adReward == 0 then
    --     print("buy life checkSDKReward")
        sdkManager.locojoybj:checkSDKReward()
    end
end

function BuyLife:onExit()

end

function BuyLife:refreshTM()
    local isShowTime = false
    if mdt.lifeRecoveryTM and mdt.lifeRecoveryTM>0 then
        local time = os.date('%M:%S', mdt.lifeRecoveryTM+0.99)
        self.ui.LifeTime:setString(time)
    else
        self.ui.LifeTime:setString(static.language[30011][device.language])
    end

    -- if AdManager:isADAvailable(99) then
    --     if self.toPlayAdID then
    --         self.ui.time:setVisible(false)
    --     else
    --         self.ui.time:setVisible(true)
    --     end
    -- else
    --     self.ui.time:setVisible(false)
    -- end

    if self.isShowADCoolDN and mdt.adCooldowntime and mdt.adCooldowntime >= 0 then
        self:refreshADCooldown()
    end
end

function BuyLife:refreshADCooldown()
    if mdt.adCooldowntime == 0 then
        self.isShowADCoolDN = false
        self.ui.time:setVisible(false)
        mdt.adCooldowntime = 0
        self.ui.Cancel:onEnabled(true)
        net.msg.NC_RequestAllCoolDownItem()
    else
        local coolDn = os.date('%M:%S', mdt.adCooldowntime)
        self.ui.time:setString(coolDn)
    end
end

function BuyLife:setcosttype(type)

    self.ui.OK.ui.btnText:onReset()
    mdt.buylifenextcost = mdt.nextcost
    self.ui.OK.ui.btnText:onSetBuyLifetype("Image/coin.png",mdt.nextcost)

end

-- Event for BG callback (addClickEventListener)
function BuyLife:onClose(node, eventType, userdata)

end

-- Event for Panel_start callback (addClickEventListener)
function BuyLife:onOK(node, eventType, userdata)
    if mdt.player.gold < mdt.nextcost then
        util.showDialog('Dialog3','Common.NotEnough'):setkey(1)
    else
        net.msg.NC_BuyLife(1,0)
        mdt.mycostype = 'gold'
        util.playClose(self)
    end
end

function BuyLife:onAD(node, eventType, userdata)
    if tonumber(mdt.player.diamond) < 10 then
        util.showDialog('Dialog3','Common.NotEnough'):setkey(3)
    else
        net.msg.NC_BuyLife(3,0)
        mdt.mycostype = 'diamond'
        util.playClose(self)
    end
end


-- Event for Panel_share callback (addClickEventListener)
function BuyLife:onShare(node, eventType, userdata)
    if self.toPlayAdID and AdManager:isADAvailable(99) then
        AdManager:playAds(99, function ()
            print("watch ad buy life")
            net.msg.NC_UpdateCoolDownTime(mdt.ADS_COOLDOWN_ID["BUY_LIFE"] or 1, 1, self.toPlayAdID)

            if util.isShowDialog('Common.Waiting') then util.closeDialog('Common.Waiting') end

            audio.resumeMusic()

            sdkManager.talkingdata:setEvent("67",{BigFailNum = "BuyLife"})
            sdkManager.appsflyer:setEvent("67",{BigFailNum = "BuyLife"})

            util.playClose(self)
        end
        )
    else
        util.playClose(self)
    end

--    net.msg.NC_UpdateCoolDownTime(mdt.ADS_COOLDOWN_ID["BUY_LIFE"] or 1, 1, self.toPlayAdID)
--    util.closeDialog('Common.BuyLife')
end

function BuyLife:NS_ShareAddLife(env,ns)
    if ns.nResult == 0 then
        mdr.BuyLife[self.curData] = mdr.BuyLife[self.curData] - 1
        if mdr.BuyLife[self.curData] < 0 then
            mdr.BuyLife[self.curData] = 0
        end
        mdr.save()
        sdkManager.talkingdata:setEvent("24",{ShareLife = tostring(mdr.BuyLife[self.curData])})
        sdkManager.appsflyer:setEvent("24",{ShareLife = tostring(mdr.BuyLife[self.curData])})
    end
    util.playClose(self)
end

return BuyLife

