local DisconnectDialog = class("DisconnectDialog", cc.load("mvc").LayoutBase)
DisconnectDialog.RESOURCE_FILENAME = "Common.DisconnectDialog"

function DisconnectDialog:onCreate()
    self:addEvent('onConnectGameServer')
end

function DisconnectDialog:onEnter()
    self.ui.Continue:setString(static.language[30014][device.language])
    self.ui.Button1:onSetText(static.language[10017][device.language])
end

function DisconnectDialog:onExit()

end

function DisconnectDialog:setDislogInfo(callback, infoStrIndex)
    if infoStrIndex then
        self.ui.Continue:setString(static.language[infoStrIndex][device.language])
    end
    self.callback = callback
end

-- Event for BG callback (addClickEventListener)
function DisconnectDialog:onClose(node, eventType, userdata)
    
end

-- Event for OK callback (addClickEventListener)
function DisconnectDialog:onOK(node, eventType, userdata)
    mdt.outTimes = 1

    if self.callback then

        local tCallback = self.callback

        util.closeDialog("Common.DisconnectDialog", function() 
            print("DisconnectDialog callback")
            tCallback()
        
        end)

        print("DisconnectDialog call back")
    else
        if mdt.disconnectTime then
            util.unschedule(mdt.disconnectTime)
        end
        util.closeDialog("Common.DisconnectDialog", function() 
        
            print("DisconnectDialog reconnect")

            ctr.login.reconnect() 
        
        end)


    end
end


function DisconnectDialog:onConnectGameServer()
    util.playClose(self)
end

return DisconnectDialog
