local ServerDialog = class("ServerDialog", cc.load("mvc").LayoutBase)
ServerDialog.RESOURCE_FILENAME = "Common.ServerDialog"

function ServerDialog:onCreate()

end

function ServerDialog:onEnter()
    self.serverItems = {}

    self.ui.OK:onEnabled(false)

    self.ui.Buy:setString(static.language[30227][device.language])
    self.ui.OK:onSetText(static.language[10001][device.language])
    
    self.ui.Text_16:setString(static.language[30194][device.language])
    self.ui.Text_16_0:setString(static.language[30196][device.language])
    self.ui.Text_16_1:setString(static.language[30195][device.language])
    self.ui.Text_16_2:setString(static.language[30193][device.language])


    self:createUI()
end

function ServerDialog:onExit()

end

function ServerDialog:setCurrentSelect(itemData, serverID)
    self.selectServer = itemData
    self.selectServerID = serverID
    self.ui.OK:onEnabled(true)
end

function ServerDialog:createUI()
    local count = 0
    local allServerInfo = static.getAllServerData()

    local layer = ccui.Layout:create()
    for k,v in pairs(allServerInfo) do 
        local item = util.createView('Common.ServerItem')
        item:setAnchorPoint(0.5, 1)

        local posX = self.ui.Panel_1:getContentSize().width * 0.25
        local posY = self.ui.Panel_1:getContentSize().height * 0.9 - (item:getContentSize().height * 1.2 * math.floor(count / 2))
        if count % 2 == 1 then
            posX = self.ui.Panel_1:getContentSize().width * 0.75
        end

        item:setPosition(posX, posY)
        item:setItemData(allServerInfo[k], k)
        item:setTarget(self)
        self.ui.Panel_1:addChild(item)

        count = count + 1
        self.serverItems[k] = item
    end
    
    self:checkPingTime()
end

function ServerDialog:checkPingTime()

    local minTimeOut = 2.0


    for k, v in pairs(self.serverItems) do
        local itemData = v.serverData
        local pintTime = itemData.pingTime
        local canconnect = true
        if math.abs(minTimeOut - pintTime) < 0.1 then
            canconnect = false
        end
        v:setPingTime(math.floor(pintTime * 1000), canconnect)
    end
end

function ServerDialog:OnItemSelect()
    for k, v in pairs(self.serverItems) do
        v:resetstate()
    end
end

function ServerDialog:makeChoose()

    mdlogin.setLastServerID(self.selectServerID)
    event.dispatch('ConnectGetServerList')
    util.closeDialog('Common.ServerDialog')
end
-- OK
function ServerDialog:onOK2(node, eventType, userdata)
    print(self.selectServerID)

end

-- CANCEL
function ServerDialog:onOK(node, eventType, userdata)

end

-- Event for BG callback (addClickEventListener)
function ServerDialog:onClose(node, eventType, userdata)

end

return ServerDialog
