local ServerDialog2 = class("ServerDialog2", cc.load("mvc").LayoutBase)
ServerDialog2.RESOURCE_FILENAME = "Common.ServerDialog2"

function ServerDialog2:onCreate()

end

function ServerDialog2:onEnter()
    self.serverItems = {}

    self.ui.OK:onEnabled(false)
    self.ui.Buy:setString(static.language[30228][device.language])
    self.ui.OK:onSetText(static.language[10001][device.language])

    self:createUI()
end

function ServerDialog2:createUI()
    local count = 0
    local allServerInfo = mdt.allServerInfo
    local servers = mdt.allServerInfo
    if mdt.recommendServerID and mdt.recommendServerID ~= 0 then
        servers = {}
        for k,v in pairs(allServerInfo) do 
            if v.nClientShowServerId == mdt.recommendServerID then
                table.insert(servers, v)
            end
        end

        for k,v in pairs(allServerInfo) do 
            if v.nClientShowServerId ~= mdt.recommendServerID then
                table.insert(servers, v)
            end
        end
    end


    local layer = ccui.Layout:create()
    for k,v in pairs(servers) do 
        local item = util.createView('Common.ServerListItem') 
        item:setAnchorPoint(0.5, 1)
        local posX = self.ui.Panel_1:getContentSize().width * 0.25
        local posY = self.ui.Panel_1:getContentSize().height * 0.9 - (item:getContentSize().height * math.floor(count / 2))
        if count % 2 == 1 then
            posX = self.ui.Panel_1:getContentSize().width * 0.75
        end
        item:setPosition(posX, posY)
        item:setItemData(v)
        item:setTarget(self)
        self.ui.Panel_1:addChild(item)

        count = count + 1
        self.serverItems[k] = item
    end

end

function ServerDialog2:setCurrentSelect(itemData)
    self.selectServer = itemData
    self.ui.OK:onEnabled(true)
end

function ServerDialog2:onExit()

end

function ServerDialog2:makeChoose()
    mdt.curSelectGSData = self.selectServer
    event.dispatch('ChangeGameServer')
    util.closeDialog('Common.ServerDialog2')
end

-- OK
function ServerDialog2:onOK2(node, eventType, userdata)

end

-- Event for Panel_start_0 callback (addClickEventListener)
function ServerDialog2:onOK(node, eventType, userdata)
    util.closeDialog('Common.ServerDialog2')
end

function ServerDialog2:OnItemSelect()
    for k, v in pairs(self.serverItems) do
        v:resetstate()
    end
end

-- Event for BG callback (addClickEventListener)
function ServerDialog2:onClose(node, eventType, userdata)

end

return ServerDialog2
