local ServerItem = class("ServerItem", cc.load("mvc").LayoutBase)
ServerItem.RESOURCE_FILENAME = "Common.ServerItem"

function ServerItem:onCreate()
    self:addEvent("resetstate")
end

function ServerItem:onEnter()
    self.isCouldTouch = false

    self.ColorRed = {r = 253, g = 62, b = 57}
    self.ColorGreen = {r = 0, g = 211, b = 99}
    self.ColorOrange = {r = 249, g = 182, b = 0}
    self.ColorGray = {r = 171, g = 171, b = 171}
    self.ColorWhite = {r = 255, g = 255, b = 255}


    self.greenLimit = 300
    self.orangeLimit = 600

end

function ServerItem:onExit()

end

function ServerItem:resetstate()
    self.ui.Button_Server:setBright(true)
    self.ui.ms:setTextColor(self.msColor)
end

function ServerItem:setItemData(data, serverID)
    self.serverData = data
    self.serverID = serverID
    self.ui.serverTxt:setString(static.language[data.name][device.language])
end

function ServerItem:setPingTime(ms, touchAble)
    if touchAble then
        if ms < self.greenLimit then
            self.msColor = self.ColorGreen
        elseif ms < self.orangeLimit and ms >= self.greenLimit then
            self.msColor = self.ColorOrange
        elseif ms >= self.orangeLimit then
            self.msColor = self.ColorRed
        end
    end

    if touchAble then
        self.ui.ms:setString(ms..'ms')
    else
        self.ui.ms:setString(static.language[30225][device.language])
        self.msColor = self.ColorGray
    end

    self.ui.ms:setTextColor(self.msColor)


    self.isCouldTouch = touchAble
end

function ServerItem:setTarget(target)
    self.target = target
end

-- Event for SelectServer callback (addClickEventListener)
function ServerItem:onselect(node, eventType, userdata)
    if not self.isCouldTouch then
        return
    end

    self.target:OnItemSelect()
    self.target:setCurrentSelect(self.serverData, self.serverID)
    self.ui.Button_Server:setBright(false)

    self.ui.ms:setTextColor(self.ColorWhite)

    self.target:makeChoose()
end

function ServerItem:changestate()
--    event.dispatch('resetstate')
--    event.dispatch('ClearList')
--    self.ui.Button_Server:setBright(false)
--    self.ui.Button_Server:setTouchEnabled(false)
--    mdt.isserverlist = true
--    ctr.login.connectToGetList(self.serverID)
--    self.serverchage:setServerID(self.serverID)
end

return ServerItem
