local serverchange = class("serverchange", cc.load("mvc").LayoutBase)
serverchange.RESOURCE_FILENAME = "Common.serverchange"

function serverchange:onCreate()
    self:addEvent('NS_ServerList')
    self:addEvent('ClearList')
end

function serverchange:onEnter()
    self.selectServerID = nil
    self.lastServerID = mdlogin.getLastServerID()
    if self.lastServerID == "" then
        self.lastServerID = mdt.servertime[0]
    end
    self.curserverid = self.lastServerID
    self.lastlistServerID = mdlogin.getLastlistServerID()
    self:refreshUI()
end

function serverchange:onExit()

end

function serverchange:NS_ServerList(ev,ns)
    if #ns.serverInfo > 0 then
        if self.lastlistServerID == 0 then
             self.lastlistServerID = ns.recommendServerInfo.nClientShowServerId
             if self.lastlistServerID == 0 then
                self.lastlistServerID = 1
             end
        end
        self:CreateListItem(ns)
        self.ui.Button1:onBright(true)
        self.ui.Button1:onEnabled(true)
        event.dispatch('ShowStartBtn')
    else
        print("#ns.serverInfo<=0")
    end
end

function serverchange:ClearList()
    self.ui.Serverlist:removeAllChildren()
    self.ui.Button1:onBright(false)
    self.ui.Button1:onEnabled(false)
end

-- Event for BG callback (addClickEventListener)
function serverchange:onClose(node, eventType, userdata)

end

-- Event for Panel_start callback (addClickEventListener)
function serverchange:onOK(node, eventType, userdata)

    if self.selectServerID ~= nil and self.selectServerID ~= self.curserverid then
        local title = static.language[30217][device.language]
        ctr.player.showMessageBox(title, 2, function(ret)
            if ret then
               if self.selectServerID then
                    mdlogin.setLastServerID(self.selectServerID)
                    --ctr.player.restart()
                    if util.isShowDialog('Main.Start') then
                        util.closeDialog('Common.serverchange')
                    else
                        util.closeDialog('Common.serverchange')
                        util.showDialog(nil, 'Main.Start')
                    end
                end
            end
        end)
    else
        if self.selectServerID then
            mdlogin.setLastServerID(self.selectServerID)
            --ctr.player.restart()
            if util.isShowDialog('Main.Start') then
                util.closeDialog('Common.serverchange')
            else
                util.closeDialog('Common.serverchange')
                util.showDialog(nil, 'Main.Start')
            end
        end
    end
end

function serverchange:CreateListItem(ns)
    self.ui.Serverlist:removeAllChildren()
    local sign = 1
    local layer = nil
    for k,v in pairs(ns.serverInfo) do
        local item = util.createView('Common.ServerListItem')
        item:setAnchorPoint(0.5,0.5)
        if sign%2 == 1 then
            layer = ccui.Layout:create()
            layer:setTouchEnabled(false)
            layer:setContentSize(self.ui.Serverlist:getContentSize().width,item:getContentSize().height+10)
            self.ui.Serverlist:pushBackCustomItem(layer)
        end
        layer:addChild(item)
        if sign%2 == 1 then
            item:setPosition(layer:getContentSize().width/4,0)
        else
            item:setPosition(layer:getContentSize().width/4*3,0)
        end
        sign = sign + 1
        item.ui.serverTxt:setString(v.szClientShowServerName)
        item.listserverID = v.nClientShowServerId
        item:setkey(self.lastlistServerID,v)
    end
end

function serverchange:refreshUI()
    local sign = 1
    local layer = nil
    local allServerInfo = static.getAllServerData()
    for k,v in pairs(allServerInfo) do
        local item = util.createView('Common.ServerItem')
        item:setAnchorPoint(0.5,0.5)
        if sign%2 == 1 then
            layer = ccui.Layout:create()
            layer:setTouchEnabled(false)
            layer:setContentSize(self.ui.Gridlist:getContentSize().width,item:getContentSize().height+10)
            self.ui.Gridlist:pushBackCustomItem(layer)
        end
        layer:addChild(item)
        if sign%2 == 1 then
            item:setPosition(layer:getContentSize().width/4,0)
        else
            item:setPosition(layer:getContentSize().width/4*3,0)
        end
        sign = sign + 1
--        item.ui.serverTxt:setString(k.." "..v.name)
        item.ui.serverTxt:setString(v.name)
        item.serverID = k
        item.serverchage = self
        item:setkey(self.lastServerID)
    end
end

function serverchange:setServerID(serverID)
    self.selectServerID = serverID
end

return serverchange
