local CoverScene = class("CoverScene", cc.load("mvc").ViewBase)
CoverScene.RESOURCE_FILENAME = "CoverScene"

function CoverScene:onCreate()
    --ide.startServer()
    ctr.player.init()
    if (not sdkManager) or (not sdkManager.talkingdata) then
        sdkManager:init(function()
            sdkManager:registerSDK("SDKMrC")
            sdkManager:registerSDK("SDKFacebook")
            sdkManager:registerSDK("SDKTalkingdata")
            sdkManager:registerSDK("SDKApplePay")
            sdkManager:registerSDK("SDKUnityAds")
            sdkManager:registerSDK("SDKAppLovin")
            sdkManager:registerSDK("SDKVungle")
            sdkManager:registerSDK("SDKAppsFlyer")
            sdkManager:registerSDK("SDKLocojoyBJ")
            sdkManager:registerSDK("AndroidPay")
            sdkManager:registerSDK("SDKOneway")
            sdkManager:registerSDK("SDKUC")
            sdkManager:registerSDK("SDKHuawei")
            if not static.isHaiWai then
                sdkManager:registerSDK("TDAdTracking")
            end
            if util.isAndroid() then
                sdkManager:registerSDK("SDKAdcolony")
            end
        end)
        AdManager:init()
        mdlogin.load()
    end
    local curLanguage = sdkManager.mrc:getLanguage() 
    if util.isAndroid() or util.isIOS() then 
        if string.find(curLanguage,"zh%-Hant") or string.find(curLanguage,"tw")  then
            device.language = "tw"
        elseif string.find(curLanguage,"zh%-Hans") or string.find(curLanguage,"zh") then
            device.language = "cn"
        elseif string.find(curLanguage,"ru") then
            device.language = "ru"
        elseif string.find(curLanguage,"fr") then
            device.language = "fr"
        elseif string.find(curLanguage,"es") then
            device.language = "es"
        elseif string.find(curLanguage,"de") then
            device.language = "de"
        elseif string.find(curLanguage,"ko") then
            device.language = "ko"
        elseif string.find(curLanguage,"pt") then
            device.language = "pt"
        elseif string.find(curLanguage,"ja") then
            device.language = "ja"
        elseif string.find(curLanguage,"it") then
            device.language = "it"
        elseif string.find(curLanguage,"id") then
            device.language = "id"
        else
            device.language = "en"
        end
    else
        device.language = "cn"
    end
    
    if static.isHaiWai ~= nil and not static.isHaiWai then
        device.language = "cn"
    end

    event.addEvent('applicationDidEnterBackground', function()

        -- if mdt.isInGame then
        --     if mdt.BoxTime ~= nil then
        --         local time = os.time()
        --         for _,v in pairs(mdt.BoxTime) do
        --             if v[2] ~= -1 and v[1] + v[2] > time then
        --                 local needTime = time - v[1]
        --                 print("box needtime = "..needTime)
        --                 local key = "box_countDown_"..needTime..math.random(0, 1000)
        --                 sdkManager.locojoybj:callNotify(key, needTime)
        --             end
        --         end
        --     end
        -- end


    end, 1) 
    event.addEvent('applicationWillEnterForeground', function()

        print('CoverScene   --     applicationWillEnterForeground')


    end, 1)

    mdt.isInGame = false
    mdt.isReconnet = false

    if not static.isInnerTest then
        self.schedule = util.scheduleNode(1, function()
        if mdt.sdkInitResult == "ok" then
            self:setShowPercent(100)
            self.ui.loading_right:setVisible(true)

            util.unscheduleNode(self.schedule)

            print("CoverScene:callSDKLogin")

            if static.isHaiWai then

                if mdr.token ~= nil then
                    print("CoverScene:callSDKLogin -------- token login ")
                    sdkManager.locojoybj:TokenLogin()
                else 
                    print(" self:play login ")
                    self:play("login")
                end

            else

                local curAccountInfo = mdlogin.getAccountAndPassward(mdlogin.getCurLoginServerID())
                if curAccountInfo.account == "" and curAccountInfo.passward == "" then --º
                    print("GN --- CHECK ACCOUNT NONE")
                    self:play("loginGN")

                    if not mdt.isWXInstall then
                        self.ui.Panel_WX:setVisible(false)
                    end
                else
                    ctr.login.onStart() 
                    --login type normal  account and password saving in file
                end


            end

        elseif mdt.sdkInitResult == "err" then
            self.ui.loadingTxt:setString(static.language[30213][device.language])
        end
    end, self)
	
	end
    self.ui.Panel_GN:setVisible(not static.isHaiWai)
   sdkManager.uc:initUCSdkToJava()
  -- sdkManager.huawei:initHuaweiSdkToJava()
end

function CoverScene:onEnter()
    if device.language == "cn"then
        self.ui.Image_1:loadTexture('Image/newUI/logo_cn.png',0)
    end
    self.ui.Guest:onSetText(static.language[30199][device.language])
    self.ui.GuestGN:onSetText(static.language[30250][device.language])
    self.ui.WX:onSetText(static.language[30251][device.language])
--    self.ui.FB:onSetText(static.UI['FB'][device.language])
    local list = ndpnet.GetInitFiles()
    -- self.ui.loadingTxt:setString(static.UI['onLoading'][device.language])
    local num = math.random(80001,80007)--math.random(80002,80008)-80001
    -- self.ui.loadingTips:setString(static.UI['tips'..num][device.language])
    self.ui.loadingTips:setString(static.language[num][device.language])
    self.ui.loadingTxt:setString(static.language[30102][device.language])
--    self.ui.loco_guest:setVisible(false)
--    self.ui.loco_fb:setVisible(false)
    mdt.sdkInitResult = "init"
    cc.exports.net = ndpnet
    local sCount = util.getTableSize(static.SERVER_LIST)

    local step = math.floor(90 / (sCount + 1))
    local sign = 1

    self.ui.loading_left:setVisible(true)

    async.create(function ()
        for k,v in pairs(list) do
            require(v)
            async.delay(0)
            local p = math.floor(k /#list * 100)
            if p >= 90 then
                p = 90
            end
            self:setShowPercent(p)
            if p % step == 0 and sign <= sCount then
                self:checkPingTime(sign)
                sign = sign + 1
            end
        end

        if not static.isInnerTest then
            sdkManager.locojoybj:callCmdInitSDK()
        else
            self:checkToLogin()
        end
    end)

    
    local tLayer = display.newLayer():onKeypad(handler(self, self.onKeypad))
    self.ui.BG:addChild(tLayer)

    audio.preloadSound()
end

function CoverScene:onKeypad( event )
    if event == "backClicked" then
        sdkManager.locojoybj:showQuit()
    end
end

function CoverScene:checkPingTime(index)
    local minTimeOut = 2.0
    local sKeys = table.keys(static.SERVER_LIST)
    local toPingKey = sKeys[index]
    local sData = static.SERVER_LIST[toPingKey]

    local pingTime = net.getPingTime(sData.adr, sData.port, minTimeOut)
    sData['pingTime'] = pingTime
end

function CoverScene:setShowPercent(percent)
    self.ui.Text_1:setString(percent..'%')
    self.ui.loading:setPercent(percent)
end

function CoverScene:callSDKLogin()
    mdt.sdkInitResult = "ok"
end

function CoverScene:handleSdkInitError()
    mdt.sdkInitResult = "err"
    print("mdt.sdkInitResult  = err")
end

function CoverScene:onExit()

end

-- Event for Start callback (addClickEventListener)
function CoverScene:onStart(node, eventType, userdata)
    ctr.login.onStart()
end

-- Event for btnClose callback (addClickEventListener)
function CoverScene:onClose(node, eventType, userdata)

end

-- Event for loco_guest callback (addClickEventListener)
function CoverScene:onGuest(node, eventType, userdata)

    if not util.isShowDialog('Common.Waiting') then
        util.showDialog(nil, 'Common.Waiting')
    end

    sdkManager.locojoybj:loginGuest()
end

-- Event for loco_fb callback (addClickEventListener)
function CoverScene:onFBLogin(node, eventType, userdata)

    if not util.isShowDialog('Common.Waiting') then
        util.showDialog(nil, 'Common.Waiting')
    end
    sdkManager.locojoybj:loginFacebook()
end

function CoverScene:checkToLogin()
    print("CoverScene:checkToLogin")
    if static.isInnerTest then
        self:onStart()
        return
    end
end

cc.exports.OnSdkInit = function(result)
    mdt.SDKINIT_RESULT = result
    require("app.views.CoverScene"):checkToLogin()
end

cc.exports.OnSdkCallback = function(param)
    print("lua on sdk callback = " .. param)
    
    param = string.gsub(param, "\\", "")

    util.delay(0.1, function() sdkManager:callBack(param) end)
end


-- Event for loco_guest callback (addClickEventListener)
function CoverScene:onOK(node, eventType, userdata)

end

-- Event for Panel_Guest_GN callback (addClickEventListener)
function CoverScene:onGuestGN(node, eventType, userdata)
    sdkManager.locojoybj:loginGNGuest()
end

-- Event for Panel_WX callback (addClickEventListener)
function CoverScene:onWXLogin(node, eventType, userdata)
    sdkManager.locojoybj:loginGNWeChat()
end

return CoverScene
