local Main = class("Main", cc.load("mvc").LayoutBase)
Main.RESOURCE_FILENAME = "Main.Main"

local clickDelay = 0.3

function Main:onCreate()
    self:addEvent('NS_LoadMap')
    self:addEvent('NS_RectGridChange')
    self:addEvent('NS_GridStateChange')
    self:addEvent('NS_ClickGrid')
    self:addEvent('NS_FlagGrid')
    
    self:addEvent('onMapGo')
    self:addEvent('onThemeChanged')
    self:addEvent('onRefreshCell')

    mdt.isChallenge = false
    ctr.game.init(self.ui.Inner)

--    util.scheduleNode(2,function ()
--        for _,v in pairs (mdt.click_list) do
--            if v.op == 1 then
--                net.msg.NC_ClickGrid(v.x, v.y)
--            elseif v.op == 2 then
--                net.msg.NC_FlagGrid(v.x, v.y)
--            end
--            print('i = '.."("..v.x..","..v.y..")")
--        end
--        end,self)
end

function Main:onEnter()

    local tLayer = display.newLayer():onKeypad(handler(self, self.onKeypad))
    self.ui.GameView:addChild(tLayer)

    ctr.game.createCell()

    if mdt.isMapLoad then
        ctr.game.LoadMap()
    end
end

function Main:onKeypad( event )
    if event == "backClicked" then
        sdkManager.locojoybj:showQuit()
    end
end

function Main:onExit()

end


function Main:onMapGo(ev, p)

    ctr.game.sendSetPos(p.x, p.y)
    print("===执行onMapGo:",p.x,p.y)
    ctr.game.LoadMap()
    ctr.game.refreshCell()
    local size = self.ui.GameView:getContentSize()
    ctr.game.moveMap(0,0, size)
    -- event.dispatch('Beaconappear',false)
    self.curpos = nil
end

function Main:onThemeChanged()
    require('app.views.Cell.Cell').Init()
    ctr.game.refreshCell()
end

function Main:onRefreshCell()
    ctr.game.refreshCell()
end

function Main:NS_LoadMap(ev, ns)
    ctr.game.LoadMap()
end

function Main:NS_RectGridChange(ev, ns)
    ctr.game.refreshCell()
    ctr.game.refreshEffect()
end

function Main:NS_GridStateChange(ev, ns)
    ctr.game.refreshCell()
    ctr.game.refreshEffect()
end

function Main:NS_ClickGrid(ev, ns)
    local x = ns.nPosX
    local y = ns.nPosY
    local nErr = ns.nErrorCode
    local combo = ns.nComboNum
    local comLevel = ns.nComboLevel
    local clickScore = ns.nClickGridScore
    if clickScore > 0 then
        self:playGetScore(x, y, clickScore)
    end
end

function Main:NS_FlagGrid(ev, ns)
    local x = ns.nPosX
    local y = ns.nPosY
    local nErr = ns.nErrorCode
    local combo = ns.nComboNum
    local comLevel = ns.nComboLevel
    local clickScore = ns.nClickGridScore
    if clickScore > 0 then
        self:playGetScore(x, y, clickScore)
    end
end

function Main:playGetScore(x, y, score)
    local view = util.createView('donghua.defen')
    local px, py = self.ui.Inner:getPosition()
    local posX = x * mdt.CW + mdt.CW / 2
    local posY = y * mdt.CW + mdt.CW / 2
    view:setPosition(posX, posY)
    view:setScoreAndPlay(score)
    self.ui.Inner:addChild(view)
end

-- Event for GameView callback (addTouchEventListener)
function Main:onTouch(node, eventType, userdata)
    if mdt.isplayerinfo ~= nil and mdt.isplayerinfo then
        event.dispatch('CloseInfo')
        return
    end
    mdt.canchangeface = true
    local function click(bp, ep, mode)
        if self.bClicked then return end

--        if self.clickClock then
--            if os.clock()-self.clickClock<clickDelay then 
--                print('os time = '..os.clock().." ".."self.click = "..self.clickClock)
--            end
--        end

--        self.clickClock = os.clock()

        mode = mode or 1
        self.bClicked = true
        ctr.game.click(bp, ep, mode)
    end

    if eventType == 0 then
        self.beganPos = node:getTouchBeganPosition()
        self.lastTouchPos = self.beganPos
        self.bMove = false
        self.bClicked = false
        self.doubleAct = util.delay(0.3, function() 
            if self.bMove then return end
            click(self.beganPos, self.lastTouchPos, 2)
        end, self)
    elseif eventType==1 then
        local mp = node:getTouchMovePosition()
        local dis = cc.pGetDistance(self.beganPos, mp)
        if dis>50 then
            self.bMove = true
        end
        local dp = cc.pSub(mp, self.lastTouchPos)
        local size = self.ui.GameView:getContentSize()
        ctr.game.moveMap(dp.x, dp.y, size)
        self.lastTouchPos = mp
--         if self.curpos ~= nil then
--            local mypos = {x=mdt.x,y=mdt.y}
--            event.dispatch('BeaconRotate',{mypos = mypos,pos = self.curpos})           
--            if self.curpos.x > mdt.x and self.curpos.x - 200 > mdt.x or 
--               self.curpos.x < mdt.x and self.curpos.x + 200 < mdt.x or
--               self.curpos.y > mdt.y and self.curpos.y - 200 > mdt.y or
--               self.curpos.y < mdt.y and self.curpos.y + 200 < mdt.y then 
--                self.curpos = nil
--                event.dispatch('Beaconappear',false)
--            end
--        end
--        for k ,v in pairs(mdt.challengepos) do
--            if self.curpos == nil then
--                local pos = v
--                if pos.pointType ~= 0 or pos.open == true then
--                    if pos.x > mdt.x and pos.x - 200 <= mdt.x or 
--                       pos.x < mdt.x and  pos.x + 200 >= mdt.x then
--                        if  pos.y > mdt.y and pos.y - 200 <= mdt.y or 
--                            pos.y < mdt.y and pos.y + 200 >= mdt.y then                 
--                             self.curpos = v
--                        end
--                    end
--                end
--            end
--        end
    elseif eventType==2 then
        if not self.bMove then
            local ep = node:getTouchEndPosition()
            click(self.beganPos, ep)
        end
        util.unschedule(self.doubleAct)
    else
        util.unschedule(self.doubleAct)
    end
    
    
end

return Main
