local Start = class("Start", cc.load("mvc").LayoutBase)
Start.RESOURCE_FILENAME = "Main.Start"


function Start:onCreate()
    self:addEvent('NS_ChangeRoleName')
    self:addEvent('NS_ServerList')
    self:addEvent('HideStartBtn')
    self:addEvent('ShowStartBtn')
    self:addEvent('ConnectGetServerList')
    self:addEvent('ChangeGameServer')
    self:addEvent('eventCheckServerStatus')
end

function Start:onEnter()
    if device.language == "cn"then
        self.ui.Image_1:loadTexture('Image/newUI/logo_cn.png',0)
    end
    if not mdr.MGTime then
        mdr.MGTime = os.date("%x",os.time())
        mdr.MGP = false
        self.ui.redtip2:setVisible(false)
    end

    if mdr.MGTime == os.date("%x",os.time()) and mdr.MGP == true then
        self.ui.redtip2:setVisible(false)
    else
        self.ui.redtip2:setVisible(false)
    end
    mdr.save()
    self.ui.Setting:setBright(mdr.settings.sound and mdr.settings.music)  
    
    self.ui.Start2:onSetText(static.language[30042][device.language])
    self.ui.weihu:setString(static.language[30181][device.language])

    self.ui.Text_25:setString(static.language[20009][device.language])

    
    if mdr.fristgame == nil then
        mdr.fristgame = true
    end

    if mdr.fristgame then
        mdr.fristgame = false
        mdr.save()
    end

    util.delay(0.1, function() self:serverLogic() end)
    

--    if static.text then
--        self.ui.Panel_8:setVisible(false)
--    end
end

function Start:ConnectGetServerList()
    print("Start:ConnectGetServerList in Start -- step (2)")

    if not util.isShowDialog('Common.Waiting') then
        util.showDialog(nil, 'Common.Waiting')
    end

    local serverID = mdlogin.getLastServerID()
    ctr.login.connectToGetList(serverID)

    local server = static.getServerInfo(serverID)
    self.ui.server.ui.name:setString(static.language[server.name][device.language])

end

function Start:serverLogic()
    print("Start:serverLogic in Start -- step (1)")


    local isShowServerChoose = true
    local lastServerID = mdlogin.getLastServerID()
    if lastServerID ~= "" then
        isShowServerChoose = false
    end
    

    local MinPingTime = 9999
    local serverKey = nil
    if isShowServerChoose then  --find fast server
        for k, v in pairs(static.SERVER_LIST) do
            if v.pingTime < MinPingTime then
                serverKey = k
                MinPingTime = v.pingTime
            end
        end

        if serverKey then
            print("auto choose the min pingtime server id = " .. serverKey)
            mdlogin.setLastServerID(serverKey)
        end
    end

    self:ConnectGetServerList()
end

function Start:RefreshPage()

end

function Start:onExit()
    
end

function Start:ShowStartBtn()
    self.ui.Panel_start:setVisible(true)
    self.ui.weihu:setVisible(false)
end

function Start:HideStartBtn()
    if util.isShowDialog('Common.Waiting') then
        util.closeDialog('Common.Waiting')
    end
    self.ui.Panel_start:setVisible(false)
    self.ui.weihu:setVisible(true)
end

function Start:NS_ServerList(ev,ns)
    --{nServerStatus=0 class={} szClientShowServerName="测试" nClientShowServerId=1 }
    --{nServerStatus=0 class={} szClientShowServerName="" nClientShowServerId=0 }

    mdt.allServerInfo = ns.serverInfo
    self.recommendServerInfo = ns.recommendServerInfo
--    self.lastServerInfo = ns.lastServerInfo

    mdt.recommendServerID = ns.recommendServerInfo.nClientShowServerId
    print("  recommendServerID  "..mdt.recommendServerID)

    self:checkShowCurrentGameServer()
end

function Start:eventCheckServerStatus()
    self:checkShowCurrentGameServer()
end

function Start:checkShowCurrentGameServer()
    print("Start:checkShowCurrentGameServer -- step(3) ")
    local serverName = ""
    local gameServerID = 1
    if mdlogin.getLastlistServerID() ~= 0 then
        gameServerID = mdlogin.getLastlistServerID()

        for k, v in pairs(mdt.allServerInfo) do
            if v.nClientShowServerId == gameServerID then
                serverName = v.szClientShowServerName
                break
            end
        end
        print(" ------ the selected server is lastServer ")
    elseif self.recommendServerInfo and self.recommendServerInfo.szClientShowServerName ~= "" and self.recommendServerInfo.nClientShowServerId ~= 0 then
        print(" ------ the selected server is recommendServer ")
        serverName = self.recommendServerInfo.szClientShowServerName
        gameServerID = self.recommendServerInfo.nClientShowServerId
    elseif mdt.allServerInfo then
        print(" ------ the selected server is defaultServer ")
        local defaultKey = 1
        if #mdt.allServerInfo > 0 then
            serverName = mdt.allServerInfo[defaultKey].szClientShowServerName
            gameServerID = mdt.allServerInfo[defaultKey].nClientShowServerId
        end
    end

    if serverName ~= "" then
        mdlogin.setLastListServerID(gameServerID)
        self.ui.Text_server:setString(serverName)

        self:checkServerStatus(gameServerID)
    end

    
end

function Start:checkServerStatus(serverID)
    self:ShowStartBtn()

    if mdt.allServerInfo[serverID] then
        if mdt.allServerInfo[serverID].nServerStatus == net.enum.EServerStatus_Stop then
            self:HideStartBtn()
        end
    end
end

function Start:ChangeGameServer() 
    if mdt.curSelectGSData then
        self.ui.Text_server:setString(mdt.curSelectGSData.szClientShowServerName)
        mdlogin.setLastListServerID(mdt.curSelectGSData.nClientShowServerId)
        self:checkServerStatus(mdt.curSelectGSData.nClientShowServerId)
    end
end

function Start:hidelistview()
    self.ui.ListView_3:setVisible(false)
    self.ui.Image_101:setVisible(false)
end

-- Event for Rules callback (addClickEventListener)
function Start:onGuide(node, eventType, userdata)
    util.showDialog(nil, 'Guide.Guide')
end

-- Event for Start callback (addClickEventListener)
function Start:onStart(node, eventType, userdata)
    if not static.isHaiWai then
        sdkManager.tdadtracking:setlogin(tostring(mdt.player.nGUID.a))
    end
    ctr.login.onStartLogin()
    if not mdr.GameStart then
        sdkManager.talkingdata:setEvent("31",{GameStart = "GameStart"})
        sdkManager.appsflyer:setEvent("31",{GameStart = "GameStart"})
        mdr.GameStart = true
        mdr.save()
    end
end

-- Event for BG callback (addClickEventListener)
function Start:onClose(node, eventType, userdata)
    util.closeDialog('Cover.ServerUI')
end

-- Event for Info callback (addClickEventListener)
function Start:onInfo(node, eventType, userdata)
    util.showDialog('Dialog', 'Info.Info')
end

-- Event for Setting callback (addClickEventListener)
function Start:onMenu(node, eventType, userdata)
    util.showDialog('Dialog', 'Menu.Menu')
end

-- Event for Shop callback (addClickEventListener)
function Start:onShop(node, eventType, userdata)
    util.showDialog('Dialog', 'Shop.Shop')
end

-- Event for Share callback (addClickEventListener)
function Start:onShare(node, eventType, userdata)
    util.showDialog('Dialog', 'Share.Share')
end

-- Event for Setting callback (addClickEventListener)
function Start:onMute(node, eventType, userdata)
    if mdr.settings.sound and mdr.settings.music then
        mdr.setMusic(false)
        mdr.setSound(false)
    else
        mdr.setMusic(true)
        mdr.setSound(true)
    end
    self.ui.Setting:setBright(mdr.settings.sound and mdr.settings.music)
end

function Start:doMoreGame(container,url)
    mdr.MGP = true
    mdr.MGTime = os.date("%x",os.time())
    mdr.save()
    self.ui.redtip2:setVisible(false)
    if util.isIOS() then
        self.webView = ccexp.WebView:create()
        self.webView:setPosition(0,0)
        self.webView:setContentSize(display.width,display.height)
        self.webView:setJavascriptInterfaceScheme("loco") 
        self.webView:setOnJSCallback(handler(self, self.onMoreGameJsCallBack))
        if not tolua.isnull(container) then
            local children=container:getChildren()
            for _,v in pairs(children) do
                container:removeChild(v, true)
            end
            container:addChild(self.webView)
        end
        self.webView:loadURL(url)
    elseif util.isAndroid() then
        --sdkManager.locojoybj:showMoreGame()
    else
        print("【更多游戏只能在移动端查看效果……】")
    end
end

function Start:NS_ChangeRoleName(ev,ns)
    if ns.nErrorCode == 1 then
        mdt.player.sMineMapData.szName = ns.szRoleName
        mdt.changenemecount = mdt.changenemecount + 1
        util.closeDialog("Common.ChangeName")
        self.ui.Image_3:setVisible(false)
        self.ui.Panel_start:setVisible(false)
        self.ui.weihu:setVisible(true)
    elseif ns.nErrorCode == 3 then
        ctr.player.showMessageBox(static.language[30100][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    elseif ns.nErrorCode == 4 then
        util.showDialog('Dialog3','Common.NotEnough'):setkey(3)
    elseif ns.nErrorCode == 5 then
        ctr.player.showMessageBox(static.language[30101][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    elseif ns.nErrorCode == 6 then
        ctr.player.showMessageBox(static.language[30106][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    elseif ns.nErrorCode == 7 then
        ctr.player.showMessageBox(static.language[30105][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    end
end

function Start:onMoreGameJsCallBack(sender,content)
		local cmdArr =string.split(content,"://")
        if table.nums(cmdArr)-1>0 then
			if cmdArr[2]=="close()" then
				self.webView:removeFromParent()  
			end
		end
	end
-- Event for Moregame callback (addClickEventListener)
function Start:onMoreGame(node, eventType, userdata)
    sdkManager.talkingdata:setEvent("55",{MoreGame = "MoreGame"})
    sdkManager.appsflyer:setEvent("55",{MoreGame = "MoreGame"})
    if static.isHaiWai then
        self:doMoreGame(self.ui.Web,"http://update2.locojoy.com/moregame_tj/index.html?r="..os.time())
    else
        self:doMoreGame(self.ui.Web,"http://update2.locojoy.com/moregame/index.html?appid=ttasl")
    end
end

-- Event for Gonggao callback (addClickEventListener)
function Start:onGongGao(node, eventType, userdata)
--    self:doMoreGame(self.ui.Web,"http://42.62.47.211:50000/saolei_ch_notice_html/andriod_notice.html")
    util.showDialog(nil,'Notice.Notice')
end

-- Event for Panel_start callback (addClickEventListener)
function Start:onRename(node, eventType, userdata)
--    local str = self.ui.TextField_1:getString()
    if string.len(str) > 0 then
        if string.find(str,"%p") == nil then
            if string.find(str,"%s") == nil then
                net.msg.NC_ChangeRoleName(str)
            else
                ctr.player.showMessageBox(static.language[30105][device.language], 1, function()
                    util.closeDialog('Common.MessageBox')
                end)
            end
        else
            ctr.player.showMessageBox(static.language[30105][device.language], 1, function()
                util.closeDialog('Common.MessageBox')
            end)
        end
    else
         ctr.player.showMessageBox(static.language[30101][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    end
end

-- Event for TextField_1 callback (addEventListener)
function Start:onCutInput(node, eventType, userdata)
    if string.len(content)>36 then
--        self.ui.TextField_1:setString( self.lastInput )
    else
        self.lastInput = content
    end
end

-- Event for Panel_2 callback (addClickEventListener)
function Start:OnClickServer(node, eventType, userdata)
    util.showDialog(nil,'Common.ServerDialog')
end

-- Event for Image_100 callback (addClickEventListener)
function Start:OnClick(node, eventType, userdata)

end

-- Event for Panel_FB callback (addClickEventListener)
function Start:onFacebook(node, eventType, userdata)

end

function Start:onClickGameServer(node, eventType, userdata)
    util.showDialog(nil,'Common.ServerDialog2')
end

return Start
