local Map = class("Map", cc.load("mvc").LayoutBase)
Map.RESOURCE_FILENAME = "Map.Map"


Map["curSVMapMarginBottom"] = 0 -- 滚动层margin-bottom的数值等于底部banner的height
Map["curTargetX"] = -1 -- 目标定位x坐标
Map["curTargetY"] = -1 -- 目标定位y坐标
Map["curTargetMine"] = cc.p(-1, -1) -- 目标定地雷格子坐标
Map["curSVMapOffsetPosition"] = cc.p(0, 0) -- 目标定地雷格子坐标
Map["curMapRate"] = 1 -- 地图横向地雷格子数和地图缩略图X轴像素比
Map["curBottomMenuCount"] = 3 -- 默认底部菜单个数 完成度大于90%则菜单个数为4
Map["curScheduleNC_ReaminBlobs"] = nil

function Map:onCreate()
    self:addEvent('NS_LoadThumbnail')
    self:addEvent('NS_RandomPos')
    self:addEvent('NS_ReaminBlobs')
    self:addEvent("onMapClose")
end

function Map:onEnter()
    self:runAnimation()
    self.curSVMapMarginBottom = self.ui.lyMap:getPositionY()
    self.curMapRate = mdt.w / 1200
    self.curTargetX = mdt.x / self.curMapRate
    self.curTargetY = mdt.y / self.curMapRate
    net.msg.NC_ReaminBlobs()
    self.curScheduleNC_ReaminBlobs = util.scheduleNode(5, function()
        if net.isConnected() then
            net.msg.NC_ReaminBlobs()
        end
    end , self)
    local function lerp(a, b, k)
        return(b - a) * k + a
    end
    self:onUpdate( function(dt)
        -- 平滑处理剩余地雷数的显示
        if mdt.world.nBlobs then
            if not self.nBlobs then
                self.nBlobs = mdt.world.nBlobs
            else
                self.nBlobs = lerp(self.nBlobs, mdt.world.nBlobs, dt / 5)
            end
            self:NS_ReaminBlobs()
        end
    end )
    self.ui.txtTransmit:setString(static.language[10006][device.language])
    self.ui.txtTransmitRandom:setString(static.language[10007][device.language])
    self.ui.txtList:setString(static.language[20021][device.language])
    self.ui.txtRemain:setString(static.language[30118][device.language])
    self.ui.txtCompleted:setString(static.language[30119][device.language])
    self.ui.txtRank:setString(static.language[20010][device.language])
    self:setMapImage(mdt.mapID)
    self.ui.lyIndexImgMap:setVisible(false)
    local curMapContentSize = self.ui.lyIndexImgMap:getContentSize()
    util.delay(0.2, function()
        self.curSVMapOffsetPosition = cc.p(self.ui.svMap:getPositionX() - self.ui.svMap:getContentSize().width / 2, self.curSVMapMarginBottom)
        ctr.player.showWaiting()
        self.ui.Panel_30:setVisible(true)
        net.msg.NC_LoadThumbnail(0)
        self:refreshUI()
    end )
    self.ui.svMap:scrollToPercentBothDirection(cc.p(self.curTargetX / 1200 * 100,(1600 - self.curTargetY) / 1600 * 100), 0.2, false)
    --    if mdt.ChallengeNewbie ~= nil and mdt.ChallengeNewbie then
    --        self.effect = self:getApp():createView('Newbie.Click')
    --        self.ui.btnList:addChild(self.effect)
    --        self.effect:setLocalZOrder(100)
    --        self.effect:setPosition({x=self.ui.btnList:getContentSize().width/2,y=self.ui.btnList:getContentSize().height/2})
    --        self.effect:play('dianji',true)
    --    end
end

function Map:onExit()
    util.unscheduleNode(self.curScheduleNC_ReaminBlobs, self)
end

function Map:setMapImage(typeIndex)
    if self.ui.lyIndexImgMap then
        local children = self.ui.lyIndexImgMap:getChildren()
        local childrenCount = self.ui.lyIndexImgMap:getChildrenCount()
        for i = 1, childrenCount do
            children[i]:setVisible(i == typeIndex)
        end
    end
end

function Map:refreshUI(isAuto)
    --    local curTargetMineX = math.ceil(self.curTargetX * self.curMapRate) + math.random(0, math.floor(self.curMapRate))
    --    local curTargetMineY = math.ceil(self.curTargetY * self.curMapRate) + math.random(0, math.floor(self.curMapRate))
    local curTargetMineX = math.ceil(self.curTargetX * self.curMapRate)
    local curTargetMineY = math.ceil(self.curTargetY * self.curMapRate)
    if not isAuto then
        self.curTargetMine = cc.p(curTargetMineX, curTargetMineY)
    end
    self.ui.txtMinePosXValue:setString("( x: " .. self.curTargetMine.x .. " , y: " .. self.curTargetMine.y .. " )")
    --  self.ui.txtMinePosYValue:setString(self.curTargetMine.y)
    self.ui.imgLocation:setPosition(cc.p(self.curTargetX, self.curTargetY))
end

function Map:NS_LoadThumbnail(ev, ns)
    local idx = ns.nIndex
    if idx < 9 then
        -- 1个字节包含8位，相当于8个位置，横条渲染，超行自动换行
        net.msg.NC_LoadThumbnail(idx + 1)
    else
        ctr.player.hideWaiting()
        self.ui.lyIndexImgMap:setVisible(true)
        local texture = ext.CreateAlphaMaskTexture(mdt.map, static.MapWidth, static.MapHeight)
        local spMask = cc.Sprite:createWithTexture(texture)
        self.ui.lyMask:addChild(spMask)
        spMask:setScale(2, -2)
        spMask:setPosition(cc.p(600, 800))
    end
end

function Map:NS_RandomPos(ev, ns)
    if ns.nErrorCode == 0 then
        self.curTargetMine = cc.p(ns.nPosX, ns.nPosY)
        self.curTargetX = math.floor((ns.nPosX - math.random(0, math.floor(self.curMapRate))) / self.curMapRate)
        self.curTargetY = math.floor((ns.nPosY - math.random(0, math.floor(self.curMapRate))) / self.curMapRate)
        self:refreshUI()
        self.ui.svMap:scrollToPercentBothDirection(cc.p(self.curTargetX / 1200 * 100,(1600 - self.curTargetY) / 1600 * 100), 0.3, false)
        util.delayNode(0.6, function()
            self:onTransmit()
        end )
    end
end

function Map:NS_ReaminBlobs(ev, ns)
    self.ui.txtRemainValue:setString(self.nBlobs and math.round(self.nBlobs) or '-----')
    -- --self.ui.Location:setString(self.nGrids and math.round(self.nGrids) or '-----')
    self.ui.txtCompletedValue:setString((mdt.world.nPercent or '--') .. '%')
    self:refreshMenu()
end

function Map:refreshMenu()
    if mdt.world.nPercent then
        if mdt.world.nPercent - 90 >= 0 then
            -- 大于90%，则出现随机传送
            self.ui.txtTransmitRandom:setString(static.language[10007][device.language])
            if self.curBottomMenuCount == 3 then
                self:play('info2', false)
                self.curBottomMenuCount = 4
            end
        else
            self.ui.btnTransmitRandom:loadTextureNormal("res/Image/map/telport.png")
            self.ui.btnTransmitRandom:loadTextureDisabled("res/Image/map/telport.png")
            self.ui.txtTransmitRandom:setString(static.language[10006][device.language])
            if self.curBottomMenuCount == 4 then
                self:play('info1', false)
                self.curBottomMenuCount = 3
            end
        end
    end
end

-- Event for btnTransmit callback (addClickEventListener)
function Map:onTransmit(node, eventType, userdata)
    event.dispatch('onMapGo', self.curTargetMine)
    -- event.dispatch('onMapGo', cc.p(self.curTargetX,self.curTargetY))
    util.playClose(self)
end

-- Event for btnTransmitRandom callback (addClickEventListener)
function Map:onTransmitRandom(node, eventType, userdata)
    if mdt.world.nPercent then
        if mdt.world.nPercent - 90 >= 0 then
            net.msg.NC_RandomPos()
        else
            self:onTransmit()
        end
    end
end

-- Event for btnList callback (addClickEventListener)
function Map:onList(node, eventType, userdata)
    if self.effect ~= nil then
        self.effect:removeFromParent()
    end
    util.showDialog('Dialog', 'Map.MapList')
end

-- Event for btnRank callback (addClickEventListener)
function Map:onRank(node, eventType, userdata)
    util.showDialog('Dialog', 'Rank.Rank')
end

-- Event for imgMap callback (addClickEventListener)
function Map:onClickMap(node, eventType, userdata)
    local mousePos = cc.pSub(node:getTouchBeganPosition(), self.curSVMapOffsetPosition)
    local offsetPos = self.ui.svMap:getInnerContainerPosition()
    self.curTargetX = math.round(mousePos.x + math.abs(offsetPos.x))
    -- self.curTargetX = self.curTargetX < 1 and 1 or self.curTargetX
    self.curTargetY = math.round(mousePos.y + math.abs(offsetPos.y) -10)
    self.curTargetY = self.curTargetY < 1 and 1 or self.curTargetY
    self:refreshUI()
end

-- Event for BG callback (addClickEventListener)
function Map:onClose(node, eventType, userdata)

end

function Map:onMapClose(arg1, arg2)
    util.playClose(self)
end

return Map