local MapList = class("MapList", cc.load("mvc").LayoutBase)
MapList.RESOURCE_FILENAME = "Map.MapList"

MapList["const"] = {
    COUNT_REFRESH = 10 --每次请求刷新的数据
}

MapList["curChallengeListData"]={}
MapList["curRequestIndex"] = 1 --默认请第一个据点开始请求
MapList["isRequesting"] = false --是否正在请求新数据
MapList["isFirstRefresh"] = true --是否刚进界面
MapList["isAutoRefresh"] = false --是否开始进行瀑布流刷新

function MapList:onCreate()
    self:addEvent('NS_ChallengePointListInfo')
    self:addEvent("onMapClose")
    self.ui.lvMap:addScrollViewEventListener(handler(self,self.onScrollList))
end

function MapList:initChallengListData()
    for v in mdt.iterChallenge(1) do
        table.insert(self.curChallengeListData,v.pointId)
    end
    for v in mdt.iterChallenge(0) do
        if true == v.open then
            table.insert(self.curChallengeListData,v.pointId)
        end
    end
end

function MapList:onEnter()
    self.isFirstRefresh = true
    self.isAutoRefresh = false
    self.curChallengeListData = {}
    self.ui.lvMap:removeAllItems()
    self.ui.txtTitle:setString(static.language[20021][device.language])
    self:initChallengListData()
    self:requestListInfo()
end

function MapList:onExit()
end

function MapList:onScrollList(sender,scrollEventType)
    if scrollEventType == ccui.ScrollviewEventType.scrolling then
        self.isAutoRefresh = true
    end
    if true == self.isAutoRefresh then
        local curOffsetY = sender:getInnerContainerPosition().y
        if curOffsetY == 0 then
            self:requestListInfo()
        end
        -- print("scrollEventType:",scrollEventType)
        -- if scrollEventType == ccui.ScrollviewEventType.scrollToBottom then
            -- self:requestListInfo()
        -- end
    end
end

-- Event for BG callback (addClickEventListener)
function MapList:onClose(node, eventType, userdata)

end

function MapList:NS_ChallengePointListInfo(ev,ns)
    self:refreshUI()
    -- ctr.player.hideWaiting()
    self.isRequesting = false
end

function MapList:onMapClose(arg1,arg2)
    util.playClose(self)
end

function MapList:requestListInfo()
    if false==self.isRequesting and #self.curChallengeListData - self.curRequestIndex >0 then
        local data = {list={}}
        local endCount = math.min(self.curRequestIndex+self.const.COUNT_REFRESH,#self.curChallengeListData)
        for i=self.curRequestIndex,endCount do
            table.insert(data.list,self.curChallengeListData[i])
        end
        self.curRequestIndex=endCount
        print("本次请求到：",endCount)
        -- ctr.player.showWaiting()
        net.msg.NC_ChallengePointListInfo(data)
        self.isRequesting = true
    end
end

function MapList:refreshUI()
    local refreshCount = #mdt.challengePointListInfo
    for i=1,refreshCount do
        local info = mdt.challengePointListInfo[i]
        if info and info.nId ~= 0 then
            if info.nPointType == 1 or true == info.nIsOpen then
                local curItem = util.getApp():createView("Map.MapListItem")
                curItem:setKey(info)
                self.ui.lvMap:pushBackCustomItem(curItem)
            end
        end
    end
    if false==self.isFirstRefresh then
        local position = self.curRequestIndex-refreshCount-3
        if position - 1 >0 then
            -- print("=====>>添加数量:",refreshCount," 总数",self.curRequestIndex, "定位",self.curRequestIndex-refreshCount-2)
            -- util.delay(0.2, function()
                self.ui.lvMap:jumpToItem(self.curRequestIndex-refreshCount-3,cc.p(0.5,0.5),cc.p(0.5,0.5))
                -- self.ui.lvMap:jumpToPercentVertical(percent)
            -- end)
        end
    end
    self.isFirstRefresh = false
end

return MapList