local BottleInfo = class("BottleInfo", cc.load("mvc").LayoutBase)
BottleInfo.RESOURCE_FILENAME = "MsgBoard.BottleInfo"

function BottleInfo:onCreate()
    self:addEvent('NS_LoadDriftBottleReply')
    self:addEvent('NS_ReplyDriftBottle')
    self:addEvent('NS_LikeDriftBottle')
    self:addEvent('NS_HateDriftBottle')
    self.scrollEnable = false
end

function BottleInfo:onEnter()
    self.ui.list:onScroll(function(node) 
        if self.scrollEnable and self.ui.list:getInnerContainerPosition().y>-80 then
            self.scrollEnable = false
            net.msg.NC_LoadDriftBottleReply(self.bottle.nBriefInfo.nId, self.nIndex, self.nIndex+10)
        end 
    end)
    self.isfrist = true
    self.ui.txtDaojishi:setString(static.language[30046][device.language])
    self.ui.btnReply:setTitleText(static.language[10008][device.language])
    self.ui.Reply:onSetText(static.language[10008][device.language])
    self.islikeorhate = false
end

function BottleInfo:onExit()

end

function BottleInfo:setData(bottle)
    event.dispatch('SetBtnstate',true)
    self.bottle = bottle
    local str = self.bottle.nBriefInfo.szTitle    
    local a = string.sub(str,0,1)
    if string.byte(a) >= 65 and string.byte(a) <= 90 or string.byte(a) >= 97 and string.byte(a) <= 122 then 
        self.ui.Text_2:setString(a)
        self.ui.txtTitle:setString(string.sub(str,2,string.len(str)))
    else
        self.ui.Text_2:setString('!')
        self.ui.txtTitle:setString(str)
    end   
    self.ui.list:removeAllChildren()
    local rps = self.bottle.nReply
    local view = nil
    if self.bottle.szPlayerName ~= mdt.player.sMainData.szRoleName then
        view = util.createView('MsgBoard.BottleInfoItem')
        self.ui.list:add(view)
        view:setTitle(self.bottle)
    else
        view = util.createView('MsgBoard.BottleInfoItem2')
        self.ui.list:add(view)
        view:setTitle(self.bottle)
    end
    for i=1, #rps do
        if rps[i].nPlayerId ~= mdt.player.nGUID then
            view = util.createView('MsgBoard.BottleInfoItem')
            self.ui.list:add(view)
            view:setReply(rps[i])
        else
            view = util.createView('MsgBoard.BottleInfoItem2')
            self.ui.list:add(view)
            view:setReply(rps[i])
        end
    end
    self.nIndex = #rps
    ccui.Helper:doLayout(self.ui.list)
    self.scrollEnable = true
    
    local lh = self.bottle.nBriefInfo.nIsLikeOrHate
    self:setLikeHate(lh)
    local hour = math.floor(bottle.nBriefInfo.nLastTime/3600)
    local min = math.floor((bottle.nBriefInfo.nLastTime-hour*3600)/60)
    local timetxt = ''
    if hour > 0 then
        timetxt = hour..static.language[30083][device.language]..min..static.language[30084][device.language]
    else
        timetxt = min..static.language[30084][device.language]
    end
    self.ui.txtTime:setString(timetxt)
    self.ui.txtLike:setString(self.bottle.nBriefInfo.nLikeNum)
    self.ui.txtHate:setString(self.bottle.nBriefInfo.nHateNum)
end

function BottleInfo:NS_ReplyDriftBottle(ev, ns)
    self.scrollEnable = false
    net.msg.NC_LoadDriftBottleReply(self.bottle.nBriefInfo.nId, self.nIndex, self.nIndex+ns.nReplyIndex)
    self.p = self.ui.list:getInnerContainerPosition()
end

function BottleInfo:NS_LoadDriftBottleReply(ev, ns)
    if ns.nReturnType~=0 then return end
    self.scrollEnable = false
    
    local index = ns.nStartIndex
    if self.nIndex < index + #ns.nReply then
        if #ns.nReply>0 then
            self.nIndex = index + #ns.nReply
        end
        local p = self.ui.list:getInnerContainerPosition()
        local h = 0
        for i=1, #ns.nReply do
            if ns.nReply[i].nPlayerId ~= mdt.player.nGUID then           
                local view = util.createView('MsgBoard.BottleInfoItem')
                self.ui.list:add(view)
                view:setReply(ns.nReply[i])
                h = h + view:getContentSize().height
            else
                local view = util.createView('MsgBoard.BottleInfoItem2')
                self.ui.list:add(view)
                view:setReply(ns.nReply[i])
                h = h + view:getContentSize().height
            end
        end
        ccui.Helper:doLayout(self.ui.list)
--        if self.isfrist then
--            self.isfrist = false
--        else
--            p.y = p.y - h
--        end
        util.delay(0, function()
            self.ui.list:setInnerContainerPosition({x=0,y=0})
            if #ns.nReply>0 then
                self.scrollEnable = true
            end
        end)
    end
end

function BottleInfo:NS_LikeDriftBottle(ev, ns)
    if ns.nReturnType==0 and ns.nDriftBottleId==self.bottle.nBriefInfo.nId then
        self:setLikeHate(1)
        self.ui.txtLike:setString(tonumber(self.ui.txtLike:getString())+1)
    end
end

function BottleInfo:NS_HateDriftBottle(ev, ns)
    if ns.nReturnType==0 and ns.nDriftBottleId==self.bottle.nBriefInfo.nId then
        self:setLikeHate(2)
         self.ui.txtHate:setString(tonumber(self.ui.txtHate:getString())+1)
    end
end

function BottleInfo:setLikeHate(n)
    self.ui.btnLike:setSelected(n==1)
    self.ui.btnHate:setSelected(n==2)
    self.ui.btnLike:setTouchEnabled(n==0)
    self.ui.btnHate:setTouchEnabled(n==0)
    if n==0 then
        self.islikeorhate = false
    else
        self.islikeorhate = true
    end
end

-- Event for btnReply callback (addClickEventListener)
function BottleInfo:onReply(node, eventType, userdata)
    util.showDialog('Dialog2', 'MsgBoard.BottleReply'):setID(self.bottle.nBriefInfo.nId)
end

-- Event for btnHate callback (addClickEventListener)
function BottleInfo:onHate(node, eventType, userdata)
    if not self.islikeorhate then
        net.msg.NC_HateDriftBottle(self.bottle.nBriefInfo.nId)
        self.islikeorhate = true
    end
end

-- Event for btnLike callback (addClickEventListener)
function BottleInfo:onLike(node, eventType, userdata)
    if not self.islikeorhate then
        net.msg.NC_LikeDriftBottle(self.bottle.nBriefInfo.nId)
        self.islikeorhate = true
    end
end

-- Event for Button_1 callback (addClickEventListener)
function BottleInfo:OnDelete(node, eventType, userdata)
    ctr.player.showMessageBox(static.language[30113][device.language], 2, function(ok)
        if ok then
            net.msg.NC_DeleteAttentionDriftBottle(self.bottle.nBriefInfo.nId)
            event.dispatch('ReturnHomePage')
        end
    end)   
end

-- Event for Button_21 callback (addClickEventListener)
function BottleInfo:OnRefresh(node, eventType, userdata)
    net.msg.NC_LoadDriftBottleReply(self.bottle.nBriefInfo.nId, self.nIndex, self.nIndex+100)
end

return BottleInfo
