local BottleReply = class("BottleReply", cc.load("mvc").LayoutBase)
BottleReply.RESOURCE_FILENAME = "MsgBoard.BottleReply"

function BottleReply:onCreate()

end

function BottleReply:onEnter()
    self.ui.Name:setString(static.language[20016][device.language])
    self.ui.txtContent:setPlaceHolder(static.language[30047][device.language])
    self.ui.btnWrite:onSetText(static.language[10008][device.language])
    self.ui.btnClose:onSetText(static.language[10002][device.language])
    self.lastInput = self.ui.txtContent:getString()
end

function BottleReply:onExit()

end

function BottleReply:setID(id)
    self.id = id
end

-- Event for BG callback (addClickEventListener)
function BottleReply:onClose(node, eventType, userdata)

end

-- Event for btnWrite callback (addClickEventListener)
function BottleReply:onWrite(node, eventType, userdata)
    local content = self.ui.txtContent:getString()
    
    if string.len(content) <= 0 then
        ctr.player.showMessageBox(static.language[30156][device.language], 1, function()
            util.closeDialog('Common.MessageBox')
        end)
    else
        net.msg.NC_ReplyDriftBottle(self.id, content)
        util.playClose(self)
    end
end

-- Event for Panel_1 callback (addClickEventListener)
function BottleReply:onStart(node, eventType, userdata)

end

-- Event for txtContent callback (addEventListener)
function BottleReply:onCutInput(node, eventType, userdata)
    if eventType == 0 then
        self.ui.txtContent:setPlaceHolder('')
    end
    local content = self.ui.txtContent:getString()
    if string.len(content)>220 then
        self.ui.txtContent:setText( self.lastInput )
    else
        self.lastInput = content
    end
end

return BottleReply
