local PromptList = class("PromptList", cc.load("mvc").LayoutBase)
PromptList.RESOURCE_FILENAME = "MsgBoard.PromptList"

function PromptList:onCreate()
    self:addEvent('NS_InsidePromptDayLoginReward')
    self:addEvent('NS_InsidePromptRefreshChallengePoint')
    self:addEvent('NS_InsidePromptChallengeReward')
    self:addEvent('NS_InsidePromptChallengeByAttack')
    self:addEvent('NS_DeleteInsidePrompt')
    self:addEvent('NS_LoadAllDriftBottleBrief')
    self:addEvent('NS_CreateDriftBottle')
    self:addEvent('NS_DeleteAttentionDriftBottle')
    self:addEvent('NS_FishDriftBottle')
end

function PromptList:onEnter()
    net.msg.NC_LoadAllInsidePrompt()
--    if mdt.msgboard.bottle==nil or #mdt.msgboard.bottle <= 0 then
--        net.msg.NC_LoadAllDriftBottleBrief()
--    else
--        self:NS_LoadAllDriftBottleBrief()
--    end
    net.msg.NC_LoadAllDriftBottleBrief()
    self.ui.Button1:onSetText(static.language[10010][device.language])
    self.ui.Button2:onSetText(static.language[10011][device.language])
    self.ui.txtcoin:setString(10)
    self.ui.txtfree:setString(static.language[10016][device.language])
    self.ui.wuping:setString(static.language[30182][device.language])
end

function PromptList:NS_LoadAllDriftBottleBrief()
    self.ui.txtfreetime:setString(mdt.Freefish..' / 10')
    self:RefreshPromptList()
end

function PromptList:NS_CreateDriftBottle()
    self:RefreshPromptList()
end

function PromptList:NS_DeleteAttentionDriftBottle()
    self:RefreshPromptList()
end

function PromptList:NS_FishDriftBottle()
    self.ui.txtfreetime:setString(mdt.Freefish..' / 10')
    async.create(function ()
        async.delay(3)
        self:RefreshPromptList()
        event.dispatch('ClosseRedP')
    end)   
end

function PromptList:NS_InsidePromptDayLoginReward(ev,ns)
    self:RefreshPromptList()
end

function PromptList:NS_InsidePromptRefreshChallengePoint(ev,ns)
    self:RefreshPromptList()
end

function PromptList:NS_InsidePromptChallengeReward(ev,ns)
    self:RefreshPromptList()
end

function PromptList:NS_InsidePromptChallengeByAttack(ev,ns)
    self:RefreshPromptList()
end

function PromptList:NS_DeleteInsidePrompt(ev,ns)
    self:RefreshPromptList()
end

function PromptList:RefreshPromptList()
    self.ui.wuping:setVisible(true)
    local txtappear = true
    self.ui.list:removeAllChildren()
    for _, prompt in pairs(mdt.msgboard.prompt) do
        local view = util.createView('MsgBoard.PromptItem')
        view:setData(prompt)
        self.ui.list:add(view)
    end
    local list = {}
    if mdt.AllNewbottle ~= nil then
        for i=#mdt.AllNewbottle,1,-1 do
            for j=#mdt.msgboard.bottle,1,-1 do
                if mdt.msgboard.bottle[j].nId == mdt.AllNewbottle[i] then
                    local view = util.createView('MsgBoard.BottleItem')
                    view:setData(mdt.msgboard.bottle[j])
                    self.ui.list:add(view)
                    list[mdt.msgboard.bottle[j].nId] = true
                    if txtappear then
                        self.ui.wuping:setVisible(false)
                        txtappear = false
                    end
                end
            end
        end
    end
    table.sort(mdt.msgboard.bottle,function (a,b)
        return a.nLastTime > b.nLastTime
    end)
    if mdt.msgboard.bottle ~= nil then
        for _, bottle in pairs(mdt.msgboard.bottle) do
            if list[bottle.nId] == nil then
                local view = util.createView('MsgBoard.BottleItem')
                view:setData(bottle)
                self.ui.list:add(view)
                if txtappear then
                    self.ui.wuping:setVisible(false)
                    txtappear = false
                end
            end
        end
    end
end

function PromptList:onExit()
    self.ui.Image_1:setVisible(false)
--    self.ui.Image_12:setVisible(false)
--    self.ui.Image_13:setVisible(false)
    self.ui.Panel_1:setVisible(false)
    self.ui.Panel_2:setVisible(false)
end

-- Event for btnWrite callback (addClickEventListener)
function PromptList:onWrite(node, eventType, userdata)
    if mdt.player.gold < 10 then
        util.showDialog('Dialog3','Common.NotEnough'):setkey(1)
    else
        util.showDialog('Dialog2', 'MsgBoard.BottleWrite')
    end
end

-- Event for btnFish callback (addClickEventListener)
function PromptList:onFish(node, eventType, userdata)
    if mdt.Freefish > 0 then
        util.showDialog('Dialog2', 'MsgBoard.BottleFish')
        net.msg.NC_FishDriftBottle()
    else 
        local cost = 0
        if tonumber(mdt.Buyfish+1) >= 5 then
            cost = 5
        else
            cost = mdt.Buyfish+1
        end
        if mdt.player.gold < cost then
             util.showDialog('Dialog3','Common.NotEnough'):setkey(1)
        else
            local view = util.showDialog('Dialog2','Common.ConfirmDialog')
                view:setkey(
                cost,
                function()               
                    util.showDialog('Dialog2', 'MsgBoard.BottleFish')
                    net.msg.NC_FishDriftBottle()             
                end,
                1,30010)
        end
    end
end

return PromptList
