local Setting = class("Setting", cc.load("mvc").LayoutBase)
Setting.RESOURCE_FILENAME = "Setting.Setting"

function Setting:onCreate()
    self:addEvent("NS_UnBindAccount")
end

function Setting:onEnter()
    self:OnSetMode(mdt.mode)
    self.ui.ReName:onSetText(static.language[10014][device.language])
    self.ui.ReCountry:onSetText(static.language[30226][device.language])
    self.ui.Name:setString(static.language[10018][device.language])
    self.ui.Button1:onSetText(static.language[10004][device.language])
    self.ui.Text_1:setString(static.language[30116][device.language])
    self.ui.Sound:setString(static.language[30044][device.language])
--    self.ui.SoundButton:setSelected(mdr.settings.music)
--    self.ui.SoundButton:setBright(mdr.settings.music)
    self.ui.Button1:onBright(mdlogin.account[mdlogin.getCurLoginServerID()].loginType == 2)
    self.ui.Button1:onEnabled(mdlogin.account[mdlogin.getCurLoginServerID()].loginType == 2)
    self.ui.SoundOn:setBright(not mdr.settings.music)
    self.ui.SoundOn:setTouchEnabled(not mdr.settings.music)
    self.ui.SoundOff:setBright(mdr.settings.music)
    self.ui.SoundOff:setTouchEnabled(mdr.settings.music)
--    if mdt.LastLoginType == 'Facebook' then
    self.ui.Button1:onEnabled(true)
    self.ui.Button1:onBright(true)
--    else
--        self.ui.Button1:onEnabled(false)
--        self.ui.Button1:onBright(false)
--    end
    if static.isHaiWai then
        self:play('haiwai')
    else
        self:play('guonei')
    end
    self.ui.duihuanma:onSetText(static.language[30247][device.language])
end

function Setting:onExit()

end

function Setting:OnSetMode(mode)
    if mode == 1 then
        self.ui.Shovel:setBright(false)
        self.ui.Shovel:setTouchEnabled(false)
--        self.ui.Shovelbg:setVisible(true)
        self.ui.Flag:setBright(true)
        self.ui.Flag:setTouchEnabled(true)
--        self.ui.Flagbg:setVisible(false)
    else
        self.ui.Flag:setBright(false)
        self.ui.Flag:setTouchEnabled(false)
--        self.ui.Flagbg:setVisible(true)
        self.ui.Shovel:setBright(true)
        self.ui.Shovel:setTouchEnabled(true)
--        self.ui.Shovelbg:setVisible(false)
    end
end

-- Event for BG callback (addClickEventListener)
function Setting:onClose(node, eventType, userdata)

end

-- Event for SoundButton callback (addEventListener)
function Setting:onSetMusic(node, eventType, userdata)
    
    if tonumber(userdata)==1 then
        self.ui.SoundOn:setBright(false)
        self.ui.SoundOn:setTouchEnabled(false)
        self.ui.SoundOff:setBright(true)
        self.ui.SoundOff:setTouchEnabled(true)
    else
        self.ui.SoundOn:setBright(true)
        self.ui.SoundOn:setTouchEnabled(true)
        self.ui.SoundOff:setBright(false)
        self.ui.SoundOff:setTouchEnabled(false)
    end
    mdr.setMusic(tonumber(userdata)==1)
    mdr.setSound(tonumber(userdata)==1)
    --self.ui.SoundButton:setBright(mdr.settings.music)
end

-- Event for VoiceButton callback (addEventListener)
function Setting:onSetSound(node, eventType, userdata)
    
end

-- Event for Tips callback (addClickEventListener)
function Setting:OnTips(node, eventType, userdata)
    local view = util.showDialog('Dialog','Common.TipDialog')
    view:setkey(2)
end

-- Event for Shave callback (addEventListener)
function Setting:onShave(node, eventType, userdata)
    mdt.mode=tonumber(userdata)
    ctr.game.refreshCell()
    self:OnSetMode(tonumber(userdata))
end

-- Event for Panel_ReName callback (addClickEventListener)
function Setting:onReName(node, eventType, userdata)
    util.showDialog('Dialog','Common.ChangeName')
end

-- Event for Panel_quit callback (addClickEventListener)
function Setting:onDisband(node, eventType, userdata)
    -- ctr.player.showMessageBox(static.language[30081][device.language], 2, function(ret)
    --     if ret then
             mdt.CanPickReward = nil
            --sdkManager.huawei:logOut()
            sdkManager.uc:exit()
    --     end
    -- end)
end

function Setting:doUnBand()
    if not util.isShowDialog('Common.Waiting') then
        util.showDialog(nil, 'Common.Waiting')
    end

    if util.isIOS() then
        sdkManager.facebook:logout(function ()
            net.msg.NC_UnBindAccount()
        end)
    elseif util.isAndroid() then
        local luaj = require "cocos.cocos2d.luaj"
        local classname = "org/cocos2dx/lua/AppActivity"
        local args = { nil }
        local sigs = "()V"
        local ok, ret = luaj.callStaticMethod(classname, "doLogout", args, sigs)
        local function logoutCallback()
            if util.isShowDialog('Common.Waiting') then
                util.closeDialog('Common.Waiting')
            end
            ctr.login.disband()
        end
       util.SendLuaFuncID2Java(logoutCallback)
    else
        net.msg.NC_UnBindAccount()
    end
end

function Setting:NS_UnBindAccount(env,ns)
    print("【解绑】",ns.nErrorCode)
    if ns.nErrorCode == 0 then
        mdr.oldusername = mdr.username
        mdr.oldpassword = mdr.password
        mdr.username = ns.szUserName
        mdr.password = ns.szPassWord
        mdlogin.setLoginType(mdlogin.getCurLoginServerID(),ns.nBindType)
        mdr.accounttype = ns.nBindType
        mdr.save()
        ctr.player.restart()
    end
end

-- Event for Panel_ReCountry callback (addClickEventListener)
function Setting:onReCountry(node, eventType, userdata)
    util.showDialog('Dialog', 'Setting.CountryDialog')
end

-- Event for Panel_duihuanma callback (addClickEventListener)
function Setting:OnDuihuanma(node, eventType, userdata)
    util.showDialog('Dialog', 'Common.ExchangeDialog')
end

return Setting
