local CustomItem = class("CustomItem", cc.load("mvc").LayoutBase)
CustomItem.RESOURCE_FILENAME = "Shop.CustomItem"

function CustomItem:onCreate()
    self:addEvent('NS_BuyShopItem')
    self:addEvent('NS_ExchangeFlag')
    self:addEvent("NS_UploadFlagComplete")
end

function CustomItem:onEnter()
    self.isBuy=false--实际买了
    self.isClickHasBuyGoods=false--仅作为开关用
    self.isBGUI=false--仅作开关使用？
    self.isEquit=false--实际穿上了
    self.ui.Text_1:setString(static.language[10012][device.language])
    self.ui.Text_4:setString(static.language[10013][device.language])
    -- if nil ~= mdr.nFlagIndex then
    if mdt.uploadFlagUrlIndex - 40000 > 0 then
        self.ui.Diamond_0:setVisible(false)
        self.ui.ndHead:setInfo(mdt.player.nGUID, nil,nil,mdt.uploadFlagUrlIndex)   --mdr.nFlagIndex
        self.ui.ndHead:setVisible(true)
        self.ui.ndHead:setScale(1.5)
    else
        self.ui.Diamond_0:setVisible(true)
        self.ui.ndHead:setVisible(false)
        self.ui.ndHead:setScale(1)
    end
end

function CustomItem:onExit()

end

function CustomItem:NS_BuyShopItem(ev,ns)
    if ns.nErrorCode == 0 then
        if self.id == ns.nItemID then
            self.isBuy=true
        end
        if self.isClickHasBuyGoods == true then    
            table.insert(self.refreshData,ns.nItemID)    
            self:setkey(self.refreshData)   
            self.ui.Buy:setVisible(false)        
            self.isClickHasBuyGoods = false
        end
        event.dispatch("OnRefreshGoldOrDiamond")
    else
        print('CustomItem购买失败,nErrorCode='..ns.nErrorCode)
    end
end
function CustomItem:NS_ExchangeFlag(ev,ns)    
    if ns.nErrorCode == 0 then
        self:OnCurChooseId()
    else
        print('Custom旗子装备失败,nErrorCode='..ns.nErrorCode)
    end
end

function CustomItem:setkey(list)
    self.refreshData = list
    self.iscustom = false
    for k,_ in pairs(static.shop) do
        if static.shop[k].code == 40000 then
            self.item = static.shop[k]
            break
        end
    end
    for i=1,#list do
        if list[i]>=40000 then
            self.id = list[i]
            self.isBuy = true
            self.iscustom = true
            if self.id == mdt.flagindex then
                self.isBGUI = true
                self.isEquit = true
            end
            break
        end
    end
    self:setdate()
    self:OnCurChooseId()
    if self.isEquit == true then
        self.ui.Select:setVisible(false)
        self.ui.Buy:setVisible(false)
        self.ui.Text_1:setVisible(true)
    end
    self.ui.Upload:setVisible(self.isBuy)
end

function CustomItem:setdate()
    if self.iscustom then
        self.ui.Buy:setVisible(false)
        self.ui.Select:setVisible(true)
        self.ui.Text_1:setVisible(false)
    else
        self.ui.Dollar:setString(self.item.cost)
        if(self.item.costType==1)  then
            self.ui.Image_3:setTexture("Image/coin.png") 
        elseif(self.item.costType==3)  then
            self.ui.Image_3:setTexture("Image/Diamond.png") 
        else
            self.ui.Image_3:setTexture("Image/pvp/pvp.png") 
        end
    end
end

function CustomItem:OnCurChooseId()
    local isSelected = (40000 <= mdt.flagindex)
    self.isBGUI=isSelected
    self.ui.Text_1:setVisible(isSelected)
    self.ui.Select:setVisible(not isSelected)
    self.ui.Image_BG:setVisible(self.isBGUI)
end

-- Event for Select callback (addClickEventListener)
function CustomItem:onSelect(node, eventType, userdata)
    if self.isBuy then
        if nil == mdr.nFlagIndex then
            self:doChangePic()
        else
            self:doSelect()
        end
    end
end

function CustomItem:doSelect()
    if self.isBuy then
        net.msg.NC_ExchangeFlag(40000) --自定义旗帜传 40000 By 史成亮
    end
end

-- Event for Button_1 callback (addClickEventListener)
function CustomItem:OnBuy(node, eventType, userdata)
    local id = self.id or self.item.code
    local num = 0
    if self.item.costType == 1 then
        num = tonumber(mdt.player.gold)
    elseif self.item.costType == 2 then
        num = tonumber(mdt.mypvpcoin)
    elseif self.item.costType == 3 then
        num = tonumber(mdt.player.diamond)
    end
    if tonumber(self.item.cost) > num then
        util.showDialog('Dialog3','Common.NotEnough'):setkey(self.item.costType,true) 
    elseif id == 40000 then
        local view = util.showDialog(nil, 'Common.ConfirmDialog')
        view:setkey(
        self.item.cost,
        function()
            self.isClickHasBuyGoods = true
            net.msg.NC_BuyShopItem(id)
            mdt.buyitemcode = self.item.code
        end ,
        self.item.costType,30165)
    else  
        local view = util.showDialog(nil, 'Common.ConfirmDialog')
        view:setkey(
        self.item.cost,
        function()
            self.isClickHasBuyGoods = true
            net.msg.NC_BuyShopItem(id)
            mdt.buyitemcode = self.item.code
        end ,
        self.item.costType,30010)
    end
end

function CustomItem:doChangePic()
    async.create(function ()
        net.msg.NC_RequestUploadFlag()
        async.waitForEvent("NS_RequestUploadFlag")
        if true == mdt.isRequestUploadFlag then
            if util.isIOS() or util.isAndroid() then
                sdkManager.mrc:showSystemAlbum(function(imageFullPath)
                    if imageFullPath then
                        ctr.player.uploadFlag(imageFullPath)
                    end
                end,{["round"]=true,["size"]={["width"]=120,["height"]=120}})
            else
                ctr.player.uploadFlag(device.writablePath.."res/Image/emoji/emoji_02.png")
            end
        else
            --TODO
        end
    end)
end

-- Event for Diamond callback (addClickEventListener)
function CustomItem:OnChangePic(node, eventType, userdata)
    local id = self.id or self.item.code
    if self.isBuy then
        if nil == mdr.nFlagIndex then
            self:doChangePic()
        else
            local view = util.showDialog(nil, 'Common.ConfirmDialog')
            view:setkey(
            300,
            function()
                if mdt.player.diamond - 300 <0 then
                    util.showDialog('Dialog3','Common.NotEnough'):setkey(3)
                else
                    self:doChangePic()
                end
            end ,
            3,30164)
        end
    else
        local view = util.showDialog(nil, 'Common.ConfirmDialog')
        view:setkey(
        300,
        function()
            self.isClickHasBuyGoods = true
            net.msg.NC_BuyShopItem(40000)
            mdt.buyitemcode = self.item.code
        end ,
        3,30165)
    end
end

function CustomItem:NS_UploadFlagComplete(ev,ns)
    self.ui.Diamond_0:setVisible(false)
    print("==========================更改自定义旗子！！",mdr.nFlagIndex)
    self.ui.ndHead:setInfo(mdt.player.nGUID, nil,nil,mdr.nFlagIndex)
    self.ui.ndHead:setVisible(true)
    self.ui.ndHead:setScale(1.5)
    self:doSelect()
    event.dispatch("OnRefreshGoldOrDiamond")
end

return CustomItem