local ThemeItem = class("ThemeItem", cc.load("mvc").LayoutBase)
ThemeItem.RESOURCE_FILENAME = "Shop.ThemeItem"

function ThemeItem:onCreate()
    self:addEvent('NS_BuyShopItem')
    self:addEvent('NS_ExchangeTheme')
end

function ThemeItem:onEnter()

end

function ThemeItem:NS_BuyShopItem(ev,ns)
    if ns.nItemID == self.id then
        if ns.nErrorCode ~= 0 then
            print('失败')
        else 
            self.state = 1
            self.ui.Text_6:setVisible(false)
            self.ui.Image_3:setVisible(false)
            self.ui.State:setVisible(true) 
            self.ui.State:setString(static.language[10013][device.language])
        end
    end
end

function ThemeItem:NS_ExchangeTheme(ev,ns)
    if ns.nErrorCode ~= 0 then
            print('失败')
    else 
        if self.state == 2 then
            self.state = 1
            self:setUI(self.item)
        end
        if ns.nThemeId == self.id then           
            self.state = 2
            self.ui.Text_6:setVisible(false)
            self.ui.Image_3:setVisible(false)
            self.ui.State:setVisible(true) 
            self.ui.State:setString(static.language[10012][device.language])
            self.ui.Buy:onEnabled(false)
            self.ui.Buy:onBright(false)
            mdt.theme = self.item.numID
            mdt.themeindex = self.id
            event.dispatch('onThemeChanged')
        end
    end     
end

function ThemeItem:setThemekey(item,curlist)
    self.state = 0
    self.shopitem = item
    local x = nil
    for i=1,#static.item do
        if static.item[i].id == self.shopitem.itemCode then
            x = static.item[i]
            break
        end
    end
    for i = 1 , #curlist do
        if item.itemCode == curlist[i] then
            if mdt.themeindex == item.itemCode then
                self.state = 2
            else
                self.state = 1
            end
        end
    end
    self:setUI(x)
end

function ThemeItem:setUI(item)
    self.item = item
    self.ui.Theme:loadTexture(self.item.imageId,0)
    self.ui.Text_6:setString(self.shopitem.cost)
    local num = 0
    if self.shopitem.costType == 1 then
        num = tonumber(mdt.player.gold)
    elseif self.shopitem.costType == 2 then
        num = tonumber(mdt.mypvpcoin)
    elseif self.shopitem.costType == 3 then
        num = tonumber(mdt.player.diamond)
    end
    self.id = item.id
    if self.state == 0 then
        self.ui.Text_6:setVisible(true)
        self.ui.Image_3:setVisible(true)
        if self.shopitem.costType == 1 then
            self.ui.Image_3:setTexture("Image/coin.png")
        elseif self.shopitem.costType == 2 then
            self.ui.Image_3:setTexture("Image/pvp/pvp.png")
        elseif self.shopitem.costType == 3 then
            self.ui.Image_3:setTexture("Image/Diamond.png")
        end
        self.ui.State:setVisible(false) 
        self.ui.Buy:onEnabled(true)
        self.ui.Buy:onBright(true)
    elseif self.state == 1 then
        self.ui.Text_6:setVisible(false)
        self.ui.Image_3:setVisible(false)
        self.ui.State:setVisible(true)
        self.ui.State:setString(static.language[10013][device.language])
        self.ui.Buy:onEnabled(true)
        self.ui.Buy:onBright(true)
    else
        self.ui.Text_6:setVisible(false)
        self.ui.Image_3:setVisible(false)
        self.ui.State:setVisible(true)
        self.ui.State:setString(static.language[10012][device.language]) 
        self.ui.Buy:onEnabled(false)
        self.ui.Buy:onBright(false)
    end
end

function ThemeItem:onExit()

end

-- Event for Buy callback (addClickEventListener)
function ThemeItem:OnBuy(node, eventType, userdata)
    if self.state == 1 then
        net.msg.NC_ExchangeTheme(self.id)
    else
        if tonumber(self.shopitem.cost) > tonumber(mdt.player.diamond) then
            util.showDialog('Dialog3','Common.NotEnough'):setkey(self.item.costType)
--            self.ui.Box:setCurrentPageIndex(self.page)
        else
            if self.state == 0 then
                local view = util.showDialog(nil,'Common.ConfirmDialog')
                view:setkey(
                self.shopitem.cost,
                function()               
                    net.msg.NC_BuyShopItem(self.id)               
                end,
                self.shopitem.costType,30010)
            end
        end
    end  
end



return ThemeItem
