local UpdatorScene = class("UpdatorScene", cc.load("mvc").ViewBase)
UpdatorScene.RESOURCE_FILENAME = "UpdatorScene"

function UpdatorScene:onCreate()
    self:addEvent('onUpdatorInfo')
    self:addEvent('onUpdatorEvent')


    sdkManager:init(function()
            sdkManager:registerSDK("SDKMrC")
            sdkManager:registerSDK("SDKFacebook")
            sdkManager:registerSDK("SDKTalkingdata")
            sdkManager:registerSDK("SDKApplePay")
            sdkManager:registerSDK("SDKUnityAds")
            sdkManager:registerSDK("SDKAppLovin")
            sdkManager:registerSDK("SDKVungle")
            sdkManager:registerSDK("SDKAppsFlyer")
            sdkManager:registerSDK("SDKLocojoyBJ")
            sdkManager:registerSDK("AndroidPay")
            sdkManager:registerSDK("SDKUC")
            sdkManager:registerSDK("SDKHuawei")
            if not static.isHaiWai then
                sdkManager:registerSDK("TDAdTracking")
            end
            sdkManager:registerSDK("SDKOneway")
            if util.isAndroid() then
                sdkManager:registerSDK("SDKAdcolony")
            end
    end)
    AdManager:init()
    mdlogin.load()
    local curLanguage = sdkManager.mrc:getLanguage()
    if util.isAndroid() or util.isIOS() then 
        if string.find(curLanguage,"zh%-Hant") or string.find(curLanguage,"tw")  then
            device.language = "tw"
        elseif string.find(curLanguage,"zh%-Hans") or string.find(curLanguage,"zh") then
            device.language = "cn"
        elseif string.find(curLanguage,"ru") then
            device.language = "ru"
        elseif string.find(curLanguage,"fr") then
            device.language = "fr"
        elseif string.find(curLanguage,"es") then
            device.language = "es"
        elseif string.find(curLanguage,"de") then
            device.language = "de"
        elseif string.find(curLanguage,"ko") then
            device.language = "ko"
        elseif string.find(curLanguage,"pt") then
            device.language = "pt"
        elseif string.find(curLanguage,"ja") then
            device.language = "ja"
        elseif string.find(curLanguage,"it") then
            device.language = "it"
        elseif string.find(curLanguage,"id") then
            device.language = "id"
        else
            device.language = "en"
        end
    else
        device.language = "cn"
    end
    if static.isHaiWai ~= nil and not static.isHaiWai then
        device.language = "cn"
    end
    self.ui.Panel_GN:setVisible(not static.isHaiWai)
end

function UpdatorScene:onEnter()
    if util.isAndroid() then
        cc.Director:getInstance():setAnimationInterval(1.0 / 60)
    end
    if device.language == "cn"then
        self.ui.Image_1:loadTexture('Image/newUI/logo_cn.png',0)
    end
    static.initUI()

    local tLayer = display.newLayer():onKeypad(handler(self, self.onKeypad))
    self.ui.BG:addChild(tLayer)

    -- ¿ª·¢Ä£Ê½²»ÏÂÔØ×ÊÔ´
    if ctr.updator.isTest then
        util.enterScene('CoverScene')
        return
    end
    ctr.updator.init()
    ctr.updator.check()
    local num = math.random(80001,80007)
--    dump(static.language)
    self.ui.loadingTips:setString(static.language[num][device.language])
    self.ui.loadingTxt:setString(static.language[30102][device.language])
    if CC_NO_UPDATOR == false then
        local curVersion = ctr.updator.getLocalVersion()
        self.ui.UpdateVersion:setString('build '..curVersion)
    else
        self.ui.UpdateVersion:setVisible(false)
    end
end

function UpdatorScene:onKeypad( event )
    if event == "backClicked" then
        sdkManager.locojoybj:showQuit()
    end
end

function UpdatorScene:onExit()

end

function UpdatorScene:onUpdatorInfo(ev, data)
    
end

function UpdatorScene:onUpdatorEvent(ev, data)

    if ctr.updator.finished() then
        if ctr.updator.eventCode==cc.EventAssetsManagerEx.EventCode.UPDATE_FINISHED then
            ctr.updator.reload()
        end
        util.enterScene('CoverScene')
    elseif ctr.updator.isError() then
        self.ui.loadingTxt:setString(static.UI['CheckingFailed'][device.language])
        self.ui.Image_4:setVisible(false)
        self.ui.Sprite_1:setVisible(false)
    elseif ctr.updator.needUpdate() then
        if not ctr.updator.isLoading() then
            ctr.updator.doload()
        end
    end
    local percent = ctr.updator.percent or 0
    self.ui.Text_1:setString(math.floor(percent)..'%')
    self.ui.loading:setPercent(ctr.updator.percent or 0)
end

return UpdatorScene
